/*
 * Translator Helper (TH)
 * Fco. Javier Domínguez Carral
 * TFC - UOC (2014)
 */
package com.ADApps.translatorhelper.contactes;

import java.io.Serializable;


/**
 * The Class Contacte.
 */
public class Contacte implements Serializable{

	/** The Constant serialVersionUID. */
	private static final long serialVersionUID = 1L;

	/** The id contacte. */
	private final int idContacte;

	/** The nom cognoms. */
	private String nomCognoms;

	/** The tipus contacte. */
	private int tipusContacte;

	/** The nif cif. */
	private String nifCif;

	/** The carrer. */
	private String carrer;

	/** The ciutat. */
	private String ciutat;

	/** The codi postal. */
	private String codiPostal;

	/** The pais. */
	private String pais;

	/** The email. */
	private String email;

	/** The telefon. */
	private String telefon;

	/** The fax. */
	private String fax;

	/** The url web. */
	private String urlWeb;
	
	/**
	 * Instantiates a new contacte.
	 * 
	 * @param idContacte
	 *            the id contacte
	 * @param nomCognoms
	 *            the nom cognoms
	 * @param tipusContacte
	 *            the tipus contacte
	 * @param nifCif
	 *            the nif cif
	 * @param carrer
	 *            the carrer
	 * @param ciutat
	 *            the ciutat
	 * @param codiPostal
	 *            the codi postal
	 * @param pais
	 *            the pais
	 * @param email
	 *            the email
	 * @param telefon
	 *            the telefon
	 * @param fax
	 *            the fax
	 * @param urlWeb
	 *            the url web
	 */
	public Contacte(int idContacte, String nomCognoms,int tipusContacte, String nifCif, String carrer
			, String ciutat,String codiPostal, String pais, String email, String telefon,String fax, String urlWeb) {
		this.idContacte = idContacte;
		this.nomCognoms = nomCognoms;
		this.tipusContacte = tipusContacte;
		this.nifCif = nifCif;
		this.carrer = carrer;
		this.ciutat = ciutat;
		this.codiPostal = codiPostal;
		this.pais = pais;
		this.email = email;
		this.telefon = telefon;
		this.fax = fax;
		this.urlWeb = urlWeb;
	}

	/**
	 * Gets the nom cognoms.
	 * 
	 * @return the nom cognoms
	 */
	public String getNomCognoms() {
		return nomCognoms;
	}

	/**
	 * Sets the nom.
	 * 
	 * @param nomCognoms
	 *            the new nom
	 */
	public void setNom(String nomCognoms) {
		this.nomCognoms = nomCognoms;
	}

	/**
	 * Gets the tipus contacte.
	 * 
	 * @return the tipus contacte
	 */
	public int getTipusContacte() {
		return tipusContacte;
	}

	/**
	 * Sets the tipus contacte.
	 * 
	 * @param tipusContacte
	 *            the new tipus contacte
	 */
	public void setTipusContacte(int tipusContacte) {
		this.tipusContacte = tipusContacte;
	}

	/**
	 * Gets the nif cif.
	 * 
	 * @return the nif cif
	 */
	public String getNifCif() {
		return nifCif;
	}

	/**
	 * Sets the nif cif.
	 * 
	 * @param nifCif
	 *            the new nif cif
	 */
	public void setNifCif(String nifCif) {
		this.nifCif = nifCif;
	}

	/**
	 * Gets the carrer.
	 * 
	 * @return the carrer
	 */
	public String getCarrer() {
		return carrer;
	}

	/**
	 * Sets the carrer.
	 * 
	 * @param carrer
	 *            the new carrer
	 */
	public void setCarrer(String carrer) {
		this.carrer = carrer;
	}

	/**
	 * Gets the ciutat.
	 * 
	 * @return the ciutat
	 */
	public String getCiutat() {
		return ciutat;
	}

	/**
	 * Sets the ciutat.
	 * 
	 * @param ciutat
	 *            the new ciutat
	 */
	public void setCiutat(String ciutat) {
		this.ciutat = ciutat;
	}

	/**
	 * Gets the codi postal.
	 * 
	 * @return the codi postal
	 */
	public String getCodiPostal() {
		return codiPostal;
	}

	/**
	 * Sets the codi postal.
	 * 
	 * @param codiPostal
	 *            the new codi postal
	 */
	public void setCodiPostal(String codiPostal) {
		this.codiPostal = codiPostal;
	}

	/**
	 * Gets the pais.
	 * 
	 * @return the pais
	 */
	public String getPais() {
		return pais;
	}

	/**
	 * Sets the pais.
	 * 
	 * @param pais
	 *            the new pais
	 */
	public void setPais(String pais) {
		this.pais = pais;
	}

	/**
	 * Gets the email.
	 * 
	 * @return the email
	 */
	public String getEmail() {
		return email;
	}

	/**
	 * Sets the email.
	 * 
	 * @param email
	 *            the new email
	 */
	public void setEmail(String email) {
		this.email = email;
	}

	/**
	 * Gets the telefon.
	 * 
	 * @return the telefon
	 */
	public String getTelefon() {
		return telefon;
	}

	/**
	 * Sets the telefon.
	 * 
	 * @param telefon
	 *            the new telefon
	 */
	public void setTelefon(String telefon) {
		this.telefon = telefon;
	}

	/**
	 * Gets the fax.
	 * 
	 * @return the fax
	 */
	public String getFax() {
		return fax;
	}

	/**
	 * Sets the fax.
	 * 
	 * @param fax
	 *            the new fax
	 */
	public void setFax(String fax) {
		this.fax = fax;
	}

	/**
	 * Gets the url web.
	 * 
	 * @return the url web
	 */
	public String getUrlWeb() {
		return urlWeb;
	}

	/**
	 * Sets the url web.
	 * 
	 * @param urlWeb
	 *            the new url web
	 */
	public void setUrlWeb(String urlWeb) {
		this.urlWeb = urlWeb;
	}

	/**
	 * Gets the id contacte.
	 * 
	 * @return the id contacte
	 */
	public int getIdContacte() {
		return idContacte;
	}	
}
