/*
 * Translator Helper (TH)
 * Fco. Javier Domínguez Carral
 * TFC - UOC (2014)
 */
package com.ADApps.translatorhelper.contactes;

import android.content.Intent;
import android.net.Uri;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.EditText;
import android.widget.RadioButton;
import android.widget.RadioGroup;
import android.widget.TextView;
import android.widget.Toast;

import com.ADApps.translatorhelper.R;
import com.ADApps.translatorhelper.main.Dialeg;
import com.ADApps.translatorhelper.main.THDataBaseHelper;
import com.actionbarsherlock.app.SherlockFragment;
import com.actionbarsherlock.view.Menu;
import com.actionbarsherlock.view.MenuInflater;
import com.actionbarsherlock.view.MenuItem;


/**
 * The Class DetallsContacteFragment.
 */
public class DetallsContacteFragment extends SherlockFragment implements Dialeg.DialogCallbacks{
	
	/** The Constant ESBORRAR. */
	private static final int ESBORRAR = 1;
	
	/** The Constant MODIFICAR. */
	private static final int MODIFICAR = 2;
	
	/** The Constant INSERTAR. */
	private static final int INSERTAR = 3;
	
	/** The Constant TIPUS_CLIENT. */
	private static final int TIPUS_CLIENT = 1;
	
	/** The Constant TIPUS_COLABORADOR. */
	private static final int TIPUS_COLABORADOR = 2;
	
	/** The et nom contacte. */
	private EditText etNomContacte;
	
	/** The tv id contacte. */
	private TextView tvIDContacte;
	
	/** The et nif. */
	private EditText etNif;
	
	/** The rg tipus contacte. */
	private RadioGroup rgTipusContacte;
	
	/** The r client. */
	private RadioButton rClient;
	
	/** The r colaborador. */
	private RadioButton rColaborador;
	
	/** The et carrer. */
	private EditText etCarrer;
	
	/** The et ciutat. */
	private EditText etCiutat;
	
	/** The et codi postal. */
	private EditText etCodiPostal;
	
	/** The et pais. */
	private EditText etPais;
	
	/** The et email. */
	private EditText etEmail;
	
	/** The et telefon. */
	private EditText etTelefon;
	
	/** The et fax. */
	private EditText etFax;
	
	/** The et url. */
	private EditText etUrl;
	
	/** The my menu. */
	private Menu myMenu;
	
	/** The db. */
	private static THDataBaseHelper db;

	/* (non-Javadoc)
	 * @see android.support.v4.app.Fragment#onCreate(android.os.Bundle)
	 */
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setHasOptionsMenu(true);
		db = new THDataBaseHelper(getActivity());
		db.open();
	}

	/* (non-Javadoc)
	 * @see android.support.v4.app.Fragment#onCreateView(android.view.LayoutInflater, android.view.ViewGroup, android.os.Bundle)
	 */
	@Override
	public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
		View view = inflater.inflate(R.layout.fragment_detalls_contacte, container, false);
		return view;
	}
	
	/* (non-Javadoc)
	 * @see android.support.v4.app.Fragment#onActivityCreated(android.os.Bundle)
	 */
	@Override
	public void onActivityCreated(Bundle savedInstanceState) {
		super.onActivityCreated(savedInstanceState);
		Bundle extras = getActivity().getIntent().getExtras();
		etNomContacte = (EditText) getView().findViewById(R.id.txtDetallsContacteNomCognoms);
		tvIDContacte = (TextView) getView().findViewById(R.id.lblDetallsContacteID);
		etNif = (EditText) getView().findViewById(R.id.txtDetallsContacteNif);
		rgTipusContacte = (RadioGroup) getView().findViewById(R.id.rgDetallsContacteTipus);
		rClient = (RadioButton) getView().findViewById(R.id.rDetallsContacteClient);
		rColaborador = (RadioButton) getView().findViewById(R.id.rDetallsContacteColaborador);
		etCarrer = (EditText) getView().findViewById(R.id.txtDetallsContacteAdreca);
		etCiutat = (EditText) getView().findViewById(R.id.txtDetallsContacteCiutat);
		etCodiPostal = (EditText) getView().findViewById(R.id.txtDetallsContacteCodiPostal);
		etPais = (EditText) getView().findViewById(R.id.txtDetallsContactePais);
		etEmail = (EditText) getView().findViewById(R.id.txtDetallsContacteEmail);
		etEmail.setOnClickListener(new View.OnClickListener(){
			@Override
			public void onClick(View v) {
				if (etEmail.getText().toString().isEmpty()){
					Toast.makeText(getActivity().getApplicationContext(),
							"Adreça de correu buida.", Toast.LENGTH_LONG)
							.show();
				}else{
					String to = etEmail.getText().toString();
					 
		            Intent emailIntent = new Intent(Intent.ACTION_SEND);
		            emailIntent.putExtra(Intent.EXTRA_EMAIL, new String[] { to });
		 
					// Únicament clients de correu
		            emailIntent.setType("message/rfc822");
		 
					startActivity(Intent.createChooser(emailIntent,
							"Enviar correu electrònic..."));
				}
			}
		});
		
		etTelefon = (EditText) getView().findViewById(R.id.txtDetallsContacteTelefon);
		etTelefon.setOnClickListener(new View.OnClickListener(){
			@Override
			public void onClick(View v) {
				if (etTelefon.getText().toString().isEmpty()){
					Toast.makeText(getActivity().getApplicationContext(),
							"Telèfon buit.", Toast.LENGTH_LONG).show();
				}else{
					Intent callIntent = new Intent(Intent.ACTION_CALL);
					callIntent.setData(Uri.parse("tel:" + etTelefon.getText().toString()));
					startActivity(callIntent);
				}
			}
		});
		
		etFax = (EditText) getView().findViewById(R.id.txtDetallsContacteFax);
		etUrl = (EditText) getView().findViewById(R.id.txtDetallsContacteUrl);
		etUrl.setOnClickListener(new View.OnClickListener(){
			@Override
			public void onClick(View v) {
				if (etUrl.getText().toString().isEmpty()){
					Toast.makeText(getActivity().getApplicationContext(), "Url buida.", Toast.LENGTH_LONG).show();
				}else{
					Intent urlIntent = new Intent("android.intent.action.VIEW", Uri.parse("http://" + etUrl.getText().toString()));
					startActivity(urlIntent);
				}
			}
		});
		
		inicialitzarViews (extras);
	}
	
	/**
	 * Inicialitzar views.
	 *
	 * @param extras the extras
	 */
	public void inicialitzarViews(Bundle extras) {
		
		if (!extras.getBoolean("afegir")){
			Contacte registre = (Contacte)extras.getSerializable("registre");
			etNomContacte.setText(registre.getNomCognoms());
			tvIDContacte.setText(Integer.toString(registre.getIdContacte()));
			etNif.setText(registre.getNifCif());
			etCarrer.setText(registre.getCarrer());
			etCiutat.setText(registre.getCiutat());
			etCodiPostal.setText(registre.getCodiPostal());
			etPais.setText(registre.getPais());
			etEmail.setText(registre.getEmail());
			etTelefon.setText(registre.getTelefon());
			etFax.setText(registre.getFax());
			etUrl.setText(registre.getUrlWeb());			
			
			switch (registre.getTipusContacte()) {
			case TIPUS_CLIENT:
				rClient.setChecked(true);
				break;
			case TIPUS_COLABORADOR:
				rColaborador.setChecked(true);
				break;
			default:
				break;
			}
			
		}else {
			etNomContacte.setCursorVisible(true);
			etNomContacte.setFocusable(true);
			etNomContacte.setFocusableInTouchMode(true);
			etNomContacte.requestFocus();
			
			etNif.setCursorVisible(true);
			etNif.setFocusable(true);
			etNif.setFocusableInTouchMode(true);
			
			rClient.setClickable(true);
			rColaborador.setClickable(true);
			
			etCarrer.setCursorVisible(true);
			etCarrer.setFocusable(true);
			etCarrer.setFocusableInTouchMode(true);
			
			etCiutat.setCursorVisible(true);
			etCiutat.setFocusable(true);
			etCiutat.setFocusableInTouchMode(true);
			
			etCodiPostal.setCursorVisible(true);
			etCodiPostal.setFocusable(true);
			etCodiPostal.setFocusableInTouchMode(true);
			
			etPais.setCursorVisible(true);
			etPais.setFocusable(true);
			etPais.setFocusableInTouchMode(true);
			
			etEmail.setClickable(false);
			etEmail.setCursorVisible(true);
			etEmail.setFocusable(true);
			etEmail.setFocusableInTouchMode(true);
			
			etTelefon.setClickable(false);
			etTelefon.setCursorVisible(true);
			etTelefon.setFocusable(true);
			etTelefon.setFocusableInTouchMode(true);
			
			etFax.setCursorVisible(true);
			etFax.setFocusable(true);
			etFax.setFocusableInTouchMode(true);
			
			etUrl.setClickable(false);
			etUrl.setCursorVisible(true);
			etUrl.setFocusable(true);
			etUrl.setFocusableInTouchMode(true);
		}		
	}
	
	/* (non-Javadoc)
	 * @see com.actionbarsherlock.app.SherlockFragment#onCreateOptionsMenu(android.view.Menu, android.view.MenuInflater)
	 */
	@Override
	public void onCreateOptionsMenu(Menu menu, MenuInflater inflater) {
	    inflater.inflate(R.menu.detall_fragment, menu);
	    myMenu = menu;
	    if (getActivity().getIntent().getExtras().getBoolean("afegir")) {
	    	myMenu.findItem(R.id.menuDetallsInsert).setVisible(true);
	    	myMenu.findItem(R.id.menuDetallsModificar).setVisible(false);
	    	myMenu.findItem(R.id.menuDetallsEliminar).setVisible(false);
	    }
	}
	
	/* (non-Javadoc)
	 * @see com.actionbarsherlock.app.SherlockFragment#onOptionsItemSelected(android.view.MenuItem)
	 */
	@Override
    public boolean onOptionsItemSelected(MenuItem item) {
        switch (item.getItemId()) {
	        case android.R.id.home:
	        	db.close();
				Intent intent = new Intent(getActivity(), LlistaContactesActivity.class);
	            intent.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP|Intent.FLAG_ACTIVITY_NEW_TASK);
	            startActivity(intent);
	            return true;
	        case R.id.menuDetallsModificar:

				etNomContacte.setCursorVisible(true);
				etNomContacte.setFocusable(true);
				etNomContacte.setFocusableInTouchMode(true);
				etNomContacte.requestFocus();
				
				etNif.setCursorVisible(true);
				etNif.setFocusable(true);
				etNif.setFocusableInTouchMode(true);
				
				rClient.setClickable(true);
				rColaborador.setClickable(true);
				
				etCarrer.setCursorVisible(true);
				etCarrer.setFocusable(true);
				etCarrer.setFocusableInTouchMode(true);
				
				etCiutat.setCursorVisible(true);
				etCiutat.setFocusable(true);
				etCiutat.setFocusableInTouchMode(true);
				
				etCodiPostal.setCursorVisible(true);
				etCodiPostal.setFocusable(true);
				etCodiPostal.setFocusableInTouchMode(true);
				
				etPais.setCursorVisible(true);
				etPais.setFocusable(true);
				etPais.setFocusableInTouchMode(true);
				
				etEmail.setClickable(false);
				etEmail.setCursorVisible(true);
				etEmail.setFocusable(true);
				etEmail.setFocusableInTouchMode(true);
				
				etTelefon.setClickable(false);
				etTelefon.setCursorVisible(true);
				etTelefon.setFocusable(true);
				etTelefon.setFocusableInTouchMode(true);
				
				etFax.setClickable(true);
				etFax.setCursorVisible(true);
				etFax.setFocusable(true);
				etFax.setFocusableInTouchMode(true);
				
				etUrl.setClickable(false);
				etUrl.setCursorVisible(true);
				etUrl.setFocusable(true);
				etUrl.setFocusableInTouchMode(true);
	    			
	        	myMenu.findItem(R.id.menuDetallsUpdate).setVisible(true);
	        	myMenu.findItem(R.id.menuDetallsModificar).setVisible(false);
	        	myMenu.findItem(R.id.menuDetallsEliminar).setVisible(false);
	    		return true;
	    	case R.id.menuDetallsEliminar:
	    		Dialeg dialegEliminar = Dialeg.newInstance((DetallsContacteFragment)
	    				getFragmentManager().findFragmentById(R.id.detallsContacteFragment), 
	    				"Eliminar contacte", "Segur que vol eliminar el contacte?", ESBORRAR);
	    		dialegEliminar.show(getFragmentManager(), "eliminar");
	    		return true;
	    	case R.id.menuDetallsUpdate:
	    		String nomContacteUpdate = etNomContacte.getText().toString();
	    		int tipoContacte = (rClient.isChecked()) ? TIPUS_CLIENT : TIPUS_COLABORADOR;
	    		
	    		if (nomContacteUpdate == null || nomContacteUpdate.isEmpty()) {
	    			Toast.makeText(getActivity().getApplicationContext()
	    					,"El camp nom i cognoms no pot estar buit.", Toast.LENGTH_LONG).show();
	    			return true;
	    		}
	    		
    			if (db.getIDContacte(nomContacteUpdate
    					, tipoContacte
    					, etNif.getText().toString()
    					, etCarrer.getText().toString()
    					, etCiutat.getText().toString()
    					, etCodiPostal.getText().toString()
    					, etPais.getText().toString()
    					, etEmail.getText().toString()
    					, etTelefon.getText().toString()
    					, etFax.getText().toString()
    					, etUrl.getText().toString()) == -1){
	    			Dialeg dialegModificar = Dialeg.newInstance((DetallsContacteFragment)
		    				getFragmentManager().findFragmentById(R.id.detallsContacteFragment), 
		    				"Modificar contacte", "Segur que vol desar els canvis al contacte?", MODIFICAR);
		    		dialegModificar.show(getFragmentManager(), "modificar");
	    		}else {
	    			Toast.makeText(getActivity().getApplicationContext(),"El contacte ja existeix.", 
			    			Toast.LENGTH_LONG).show();
	    		}
	    		return true;
	    	case R.id.menuDetallsInsert:
	    		String nomContacteInsert = etNomContacte.getText().toString();
	    		
	    		if (nomContacteInsert == null || nomContacteInsert.isEmpty()) {
	    			Toast.makeText(getActivity().getApplicationContext(),"El camp nom no pot estar buit.", 
			    			Toast.LENGTH_LONG).show();
	    			return true;
	    		}
	
	    		if (rgTipusContacte.getCheckedRadioButtonId() == -1) {
	    			Toast.makeText(getActivity().getApplicationContext(),"S'ha d'escollir un tipus de contacte.", 
			    			Toast.LENGTH_LONG).show();
	    			return true;
	    		}
	    		
	    		if (db.getIDContacte(nomContacteInsert) == -1){
		    		Dialeg dialegAfegir = Dialeg.newInstance((DetallsContacteFragment)
		    				getFragmentManager().findFragmentById(R.id.detallsContacteFragment), 
		    				"Afegir contacte", "Segur que vol afegir el contacte?", INSERTAR);
		    		dialegAfegir.show(getFragmentManager(), "afegir");
	    		}else {
	    			Toast.makeText(getActivity().getApplicationContext(),"El contacte ja existeix.", 
			    			Toast.LENGTH_LONG).show();
	    		}
	    		return true;
			default:
				return super.onOptionsItemSelected(item);
        }
    }
	
	/* (non-Javadoc)
	 * @see com.ADApps.translatorhelper.main.Dialeg.DialogCallbacks#onPositive(int)
	 */
	@Override
	public void onPositive(int mode) {
	
		switch (mode){
			case ESBORRAR:
				if (db.deleteContacte(Integer.parseInt(tvIDContacte.getText().toString()))) {
					db.close();
					Intent intent = new Intent(getActivity(), LlistaContactesActivity.class);
		            intent.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP|Intent.FLAG_ACTIVITY_NEW_TASK);
		            startActivity(intent);
				}else {
					db.close();
					Toast.makeText(getActivity().getApplicationContext(),"Error en esborrar", 
			    			Toast.LENGTH_LONG).show();
				}
				break;
			case MODIFICAR:
				int tipoContacteUpdate = (rClient.isChecked()) ? TIPUS_CLIENT : TIPUS_COLABORADOR;
				
				if (db.updateContacte(Integer.parseInt(tvIDContacte.getText().toString())
						, etNomContacte.getText().toString()
						, tipoContacteUpdate
						, etNif.getText().toString()
    					, etCarrer.getText().toString()
    					, etCiutat.getText().toString()
    					, etCodiPostal.getText().toString()
    					, etPais.getText().toString()
    					, etEmail.getText().toString()
    					, etTelefon.getText().toString()
    					, etFax.getText().toString()
    					, etUrl.getText().toString())) {
					db.close();
					Intent intent = new Intent(getActivity(), LlistaContactesActivity.class);
		            intent.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP|Intent.FLAG_ACTIVITY_NEW_TASK);
		            startActivity(intent);
				}else {
					db.close();
					Toast.makeText(getActivity().getApplicationContext(),"Error en modificar", 
			    			Toast.LENGTH_LONG).show();
				}
				break;
			case INSERTAR:
				int tipoContacteInsert = (rClient.isChecked()) ? TIPUS_CLIENT : TIPUS_COLABORADOR;
				
				if (db.insertContacte(etNomContacte.getText().toString()
						, tipoContacteInsert
						, etNif.getText().toString()
    					, etCarrer.getText().toString()
    					, etCiutat.getText().toString()
    					, etCodiPostal.getText().toString()
    					, etPais.getText().toString()
    					, etEmail.getText().toString()
    					, etTelefon.getText().toString()
    					, etFax.getText().toString()
    					, etUrl.getText().toString())) {
					db.close();
					Intent intent = new Intent(getActivity(), LlistaContactesActivity.class);
		            intent.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP|Intent.FLAG_ACTIVITY_NEW_TASK);
		            startActivity(intent);
				}else {
					db.close();
					Toast.makeText(getActivity().getApplicationContext(),"Error en insertar", 
			    			Toast.LENGTH_LONG).show();
				}
				break;
			default:
				break;
		}	
	}

	/* (non-Javadoc)
	 * @see com.ADApps.translatorhelper.main.Dialeg.DialogCallbacks#onNegative(int)
	 */
	@Override
	public void onNegative(int mode) {
	}
}
