/*
 * Translator Helper (TH)
 * Fco. Javier Domínguez Carral
 * TFC - UOC (2014)
 */
package com.ADApps.translatorhelper.contactes;

import com.ADApps.translatorhelper.R;
import com.ADApps.translatorhelper.main.MainActivity;

import com.actionbarsherlock.app.ActionBar;
import com.actionbarsherlock.app.SherlockFragmentActivity;
import com.actionbarsherlock.app.ActionBar.OnNavigationListener;
import android.content.Intent;
import android.os.Bundle;
import android.widget.ArrayAdapter;
import android.widget.SpinnerAdapter;


/**
 * The Class LlistaContactesActivity.
 */
public class LlistaContactesActivity extends SherlockFragmentActivity {

	/* (non-Javadoc)
	 * @see android.support.v4.app.FragmentActivity#onCreate(android.os.Bundle)
	 */
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		OnNavigationListener menuOnNavigationListener;
		super.onCreate(savedInstanceState);
		
		ActionBar ab = getSupportActionBar();
        ab.setNavigationMode(ActionBar.NAVIGATION_MODE_LIST);
        ab.setDisplayOptions(ActionBar.DISPLAY_SHOW_TITLE);
        ab.setTitle(R.string.app_name_title);
        
        SpinnerAdapter menuSpinnerAdapter = 
        		ArrayAdapter.createFromResource(this, R.array.action_list, R.layout.sherlock_spinner_dropdown_item);

        menuOnNavigationListener = new OnNavigationListener() {
        	
			@Override
			public boolean onNavigationItemSelected(int position, long itemId) {
				// Create new fragment from our own Fragment class
				switch (position) {
				case 0:
					startActivity(new Intent(getApplicationContext(), MainActivity.class));
					break;
				case 1:
					break;
				}
				return true;
			}        	
        };
        
        getSupportActionBar().setListNavigationCallbacks(menuSpinnerAdapter, menuOnNavigationListener);
		setContentView(R.layout.activity_llista_contactes);
	}

	/* (non-Javadoc)
	 * @see android.support.v4.app.FragmentActivity#onResume()
	 */
	@Override
	protected void onResume() {
		super.onResume();
		
		getSupportActionBar().setSelectedNavigationItem(1);
	}
}
