/*
 * Translator Helper (TH)
 * Fco. Javier Domínguez Carral
 * TFC - UOC (2014)
 */
package com.ADApps.translatorhelper.factures;

import harmony.java.awt.Color;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;

import android.app.DatePickerDialog;
import android.app.Dialog;
import android.content.Intent;
import android.net.Uri;
import android.os.Bundle;
import android.os.Environment;
import android.support.v4.app.DialogFragment;
import android.view.Gravity;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.DatePicker;
import android.widget.TableLayout;
import android.widget.TableRow;
import android.widget.TableRow.LayoutParams;
import android.widget.TextView;
import android.widget.Toast;

import com.ADApps.translatorhelper.R;
import com.ADApps.translatorhelper.main.Dialeg;
import com.ADApps.translatorhelper.main.THDataBaseHelper;
import com.ADApps.translatorhelper.parametres.impostos.ImpostFac;
import com.ADApps.translatorhelper.parametres.preusunitaris.PreuUnitariFac;
import com.ADApps.translatorhelper.parametres.variables.VariableFac;
import com.ADApps.translatorhelper.projectes.Projecte;
import com.actionbarsherlock.app.SherlockFragment;
import com.actionbarsherlock.view.Menu;
import com.actionbarsherlock.view.MenuInflater;
import com.actionbarsherlock.view.MenuItem;
import com.lowagie.text.Document;
import com.lowagie.text.DocumentException;
import com.lowagie.text.Font;
import com.lowagie.text.FontFactory;
import com.lowagie.text.Paragraph;
import com.lowagie.text.pdf.PdfPTable;
import com.lowagie.text.pdf.PdfWriter;


/**
 * The Class DetallsFacturaFragment.
 */
public class DetallsFacturaFragment extends SherlockFragment implements
		Dialeg.DialogCallbacks, OnClickListener {

	/** The Constant ESBORRAR. */
	private static final int ESBORRAR = 4;

	/** The Constant PROVISIONAL. */
	private static final int PROVISIONAL = 1;

	/** The Constant EN_CURS. */
	private static final int PENDENT = 2;

	/** The Constant ENTREGAT. */
	private static final int COBRADA = 3;

	/** The Constant en_curs. */
	private static final String pendent = "Retrocedir cobrament";

	/** The Constant entregat. */
	private static final String cobrada = "Cobrada";

	/** The Constant TITOL_DOCUMENT. */
	private static final String TITOL_DOCUMENT = "Factura Translators Helper";

	/** The Constant NOM_DIRECTORI. */
	private static final String NOM_DIRECTORI = "THDocs";
	
	private static final int DATE_DIALOG_ID = 5;

	private static TextView tvIdFactura;
	private TextView tvIdProjecte;
	private TextView tvClient;
	private TextView tvAdreca;
	private TextView tvNif;
	private static TextView tvData;
	private TextView tvDesProjecte;
	private TextView tvEstat;
	private TextView tvConcepte;
	private TextView tvTarifa;
	/** The tv preus unitaris total. */
	private TextView tvPreusUnitarisTotal;

	/** The tv impostos total. */
	private TextView tvImpostosTotal;

	/** The tv variables total. */
	private TextView tvVariablesTotal;

	/** The tv import total. */
	private TextView tvImportTotal;

	/** The tlo preus unitaris celes. */
	private TableLayout tloPreusUnitarisCeles;

	/** The tlo impostos celes. */
	private TableLayout tloImpostosCeles;

	/** The tlo variables celes. */
	private TableLayout tloVariablesCeles;

	/** The btn estat. */
	private Button btnEstatPendent;

	/** The btn estat. */
	private Button btnEstatCobrada;

	/** The btn enviar. */
	private Button btnEnviar;

	/** The btn enviar. */
	private Button btnModificarData;

	/** The my menu. */
	private Menu myMenu;

	/** The sdf. */
	static SimpleDateFormat sdf = new SimpleDateFormat("dd/MM/yyyy");

	private ArrayList<PreuUnitariFac> lstPreusUnitaris = new ArrayList<PreuUnitariFac>();

	private ArrayList<ImpostFac> lstImpostos = new ArrayList<ImpostFac>();

	private ArrayList<VariableFac> lstVariables = new ArrayList<VariableFac>();

	private float totalPreusUnitaris = 0f;

	/** The total variables. */
	private float totalVariables = 0f;

	/** The total impostos. */
	private float totalImpostos = 0f;

	/** The db. */
	private static THDataBaseHelper db;

	/* (non-Javadoc)
	 * @see android.support.v4.app.Fragment#onCreate(android.os.Bundle)
	 */
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setHasOptionsMenu(true);
		db = new THDataBaseHelper(getActivity());
		db.open();
	}

	/* (non-Javadoc)
	 * @see android.support.v4.app.Fragment#onCreateView(android.view.LayoutInflater, android.view.ViewGroup, android.os.Bundle)
	 */
	@Override
	public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
		View view = inflater.inflate(R.layout.fragment_detalls_factura, container, false);
		return view;
	}
	
	/*
	 * (non-Javadoc)
	 * 
	 * @see android.support.v4.app.Fragment#onActivityCreated(android.os.Bundle)
	 */
	@Override
	public void onActivityCreated(Bundle savedInstanceState) {
		super.onActivityCreated(savedInstanceState);
		Bundle extras = getActivity().getIntent().getExtras();
		
		tvIdFactura = (TextView) getView().findViewById(
				R.id.lblDetallsFacturaIdFacturaValor);
		tvIdProjecte = (TextView) getView().findViewById(
				R.id.lblDetallsFacturaIdProjecte);
		tvClient = (TextView) getView().findViewById(
				R.id.lblDetallsFacturaClientValor);
		tvAdreca = (TextView) getView().findViewById(
				R.id.lblDetallsFacturaAdrecaValor);
		tvNif = (TextView) getView().findViewById(
				R.id.lblDetallsFacturaNifValor);
		tvData = (TextView) getView().findViewById(
				R.id.lblDetallsFacturaDataValor);
		tvDesProjecte = (TextView) getView().findViewById(
				R.id.lblDetallsFacturaProjecteValor);
		tvEstat = (TextView) getView().findViewById(
				R.id.lblDetallsFacturaEstatValor);
		tvConcepte = (TextView) getView().findViewById(
				R.id.lblDetallsFacturaConcepteValor);
		tvTarifa = (TextView) getView().findViewById(
				R.id.lblDetallsFacturaTarifaValor);
		tvPreusUnitarisTotal = (TextView) getView().findViewById(
				R.id.lblDetallsFacturaPreusUnitarisTotal);
		tvImpostosTotal = (TextView) getView().findViewById(
				R.id.lblDetallsFacturaImpostosTotal);
		tvVariablesTotal = (TextView) getView().findViewById(
				R.id.lblDetallsFacturaVariablesTotal);
		tvImportTotal = (TextView) getView().findViewById(
				R.id.lblDetallsFacturaImportTotal);
		tloPreusUnitarisCeles = (TableLayout) getView().findViewById(
				R.id.tloDetallsFacturaPreusUnitarisCeles);
		tloImpostosCeles = (TableLayout) getView().findViewById(
				R.id.tloDetallsFacturaImpostosCeles);
		tloVariablesCeles = (TableLayout) getView().findViewById(
				R.id.tloDetallsFacturaVariablesCeles);
		btnEstatPendent = (Button) getView().findViewById(R.id.btnEstatPendent);
		btnEstatCobrada = (Button) getView().findViewById(R.id.btnEstatCobrada);
		btnEnviar = (Button) getView().findViewById(R.id.btnEnviar);
		btnModificarData = (Button) getView().findViewById(
				R.id.btnModificarData);

		inicialitzarViews(extras);

		btnEstatPendent.setOnClickListener(this);
		btnEstatCobrada.setOnClickListener(this);
		btnEnviar.setOnClickListener(this);
		btnModificarData.setOnClickListener(this);
	}

	/**
	 * Inicialitzar views.
	 * 
	 * @param extras
	 *            the extras
	 */
	private void inicialitzarViews(Bundle extras) {

		Projecte registre = (Projecte) extras.getSerializable("registre");
		String adreca = new String();
		adreca += "C/";
		adreca += registre.getClient().getCarrer();
		adreca += "\n";
		adreca += "(" + registre.getClient().getCodiPostal() + ") ";
		adreca += registre.getClient().getCiutat();
		adreca += "\n";
		adreca += registre.getClient().getPais();

		tvIdFactura.setText(registre.getFactura().getIdFactura());
		tvIdProjecte.setText(Integer.toString(registre.getIdProjecte()));
		tvClient.setText(registre.getClient().getNomCognoms());
		tvAdreca.setText(adreca);
		tvNif.setText(registre.getClient().getNifCif());
		tvData.setText(sdf.format(registre.getFactura().getDataCobrament()));
		tvDesProjecte.setText(registre.getNomProjecte());

		switch (registre.getFactura().getEstat()) {
		case PROVISIONAL:
			tvEstat.setText(R.string.estatFac_provisional);
			btnEstatCobrada.setVisibility(View.GONE);
			btnEstatPendent.setVisibility(View.GONE);
			break;
		case PENDENT:
			tvEstat.setText(R.string.estatFac_pendent);
			btnEstatPendent.setVisibility(View.GONE);
			break;
		case COBRADA:
			tvEstat.setText(R.string.estatFac_cobrada);
			btnEstatCobrada.setVisibility(View.GONE);
			break;
		default:
			break;
		}

		tvConcepte.setText(registre.getConcepte().getNom());
		tvTarifa.setText(registre.getTarifa().getNom());

		tvImportTotal.setText(Float.toString(registre.getImportProjecte()));

		lstPreusUnitaris = registre.getPreusUnitaris();
		lstImpostos = registre.getImpostos();
		lstVariables = registre.getVariables();

		inicialitzarTaulaPreusUnitaris();
		inicialitzarTaulaImpostos();
		inicialitzarTaulaVariables();

	}

	private void inicialitzarTaulaVariables() {

		if (!lstVariables.isEmpty()) {

			for (int index = 0; index < lstVariables.size(); index++) {
				final VariableFac var = lstVariables.get(index);

				TableRow variableRow = new TableRow(getActivity());
				variableRow.setLayoutParams(new LayoutParams(
						LayoutParams.MATCH_PARENT, LayoutParams.WRAP_CONTENT));
				variableRow.setGravity(Gravity.CENTER_VERTICAL);

				String totalParcialImpostos = new String();
				TextView txtParcialImpost = new TextView(getActivity());
				txtParcialImpost.setLayoutParams(new LayoutParams(200,
						LayoutParams.WRAP_CONTENT));

				if (var.getTipusOperacio() == 1) {
					totalParcialImpostos = var.getNom();
					totalParcialImpostos += ":\n";
					totalParcialImpostos += Float.toString(Float
							.parseFloat(tvPreusUnitarisTotal.getText()
									.toString())
							+ Float.parseFloat(tvImpostosTotal.getText()
									.toString()));
					totalParcialImpostos += " €";
				} else {
					totalParcialImpostos = var.getNom() + ":";
				}

				txtParcialImpost.setText(totalParcialImpostos);

				TextView txtOperacio = new TextView(getActivity());
				txtOperacio.setLayoutParams(new LayoutParams(125,
						LayoutParams.WRAP_CONTENT));
				txtOperacio.setGravity(Gravity.CENTER_VERTICAL);

				if (var.getTipusOperacio() == 1) {
					txtOperacio.setText("\n x "
							+ Float.toString(var.getValor()) + "%");
				} else {
					txtOperacio.setText("\n + "
							+ Float.toString(var.getValor()));
				}

				TextView txtVariableTotal = new TextView(getActivity());
				txtVariableTotal.setLayoutParams(new LayoutParams(115,
						LayoutParams.WRAP_CONTENT));
				txtVariableTotal.setGravity(Gravity.CENTER_VERTICAL);

				txtVariableTotal.setText("\n = "
						+ Float.toString((float) Math.round(var
								.getImportVariable() * 100) / 100) + " €");

				variableRow.addView(txtParcialImpost);
				variableRow.addView(txtOperacio);
				variableRow.addView(txtVariableTotal);

				variableRow.setId(index);

				// Càrrega de files a la taula
				tloVariablesCeles.addView(variableRow);

				totalVariables += var.getImportVariable();
			}
			// Assignació del total parcial d'impostos
			tvVariablesTotal.setText(Float.toString((float) Math
					.round(totalVariables * 100) / 100));
		} else
			Toast.makeText(getActivity().getApplicationContext(),
					"Error en recuperar les variables.", Toast.LENGTH_LONG)
					.show();
	}

	private void inicialitzarTaulaImpostos() {

		if (!lstImpostos.isEmpty()) {

			for (int index = 0; index < lstImpostos.size(); index++) {
				final ImpostFac imp = lstImpostos.get(index);

				TableRow impostRow = new TableRow(getActivity());
				impostRow.setLayoutParams(new LayoutParams(
						LayoutParams.MATCH_PARENT, LayoutParams.WRAP_CONTENT));
				impostRow.setGravity(Gravity.CENTER_VERTICAL);

				String totalParcialPreus = new String();
				TextView txtParcialPreu = new TextView(getActivity());
				txtParcialPreu.setLayoutParams(new LayoutParams(200,
						LayoutParams.WRAP_CONTENT));

				totalParcialPreus = imp.getNom();
				totalParcialPreus += ":\n";
				totalParcialPreus += tvPreusUnitarisTotal.getText().toString();
				totalParcialPreus += " €";

				txtParcialPreu.setText(totalParcialPreus);

				TextView txtPercent = new TextView(getActivity());
				txtPercent.setLayoutParams(new LayoutParams(125,
						LayoutParams.WRAP_CONTENT));
				txtPercent.setGravity(Gravity.CENTER_VERTICAL);

				txtPercent.setText("\n x "
						+ Float.toString(imp.getPercentatge()) + "%");

				TextView txtImpostTotal = new TextView(getActivity());
				txtImpostTotal.setLayoutParams(new LayoutParams(115,
						LayoutParams.WRAP_CONTENT));
				txtImpostTotal.setGravity(Gravity.CENTER_VERTICAL);

				txtImpostTotal.setText("\n = "
						+ Float.toString((float) Math.round(imp
								.getImportImpost() * 100) / 100) + " €");

				impostRow.addView(txtParcialPreu);
				impostRow.addView(txtPercent);
				impostRow.addView(txtImpostTotal);

				impostRow.setId(index);

				// Càrrega de files a la taula
				tloImpostosCeles.addView(impostRow);

				totalImpostos += imp.getImportImpost();
			}
			// Assignació del total parcial d'impostos
			tvImpostosTotal.setText(Float.toString((float) Math
					.round(totalImpostos * 100) / 100));

		} else
			Toast.makeText(getActivity().getApplicationContext(),
					"Error en recuperar els impostos.", Toast.LENGTH_LONG)
					.show();
	}

	private void inicialitzarTaulaPreusUnitaris() {
		totalPreusUnitaris = 0f;
		if (!lstPreusUnitaris.isEmpty()) {

			for (int index = 0; index < lstPreusUnitaris.size(); index++) {
				final PreuUnitariFac prU = lstPreusUnitaris.get(index);

				TableRow preuUnitariRow = new TableRow(getActivity());
				preuUnitariRow.setLayoutParams(new LayoutParams(
						LayoutParams.MATCH_PARENT, LayoutParams.WRAP_CONTENT));
				preuUnitariRow.setGravity(Gravity.CENTER_VERTICAL);

				String preu = new String();
				TextView txtPreu = new TextView(getActivity());
				txtPreu.setLayoutParams(new LayoutParams(200,
						LayoutParams.WRAP_CONTENT));

				preu = prU.getNom();
				preu += ":\n";
				preu += Float.toString(prU.getPreu());
				preu += " €";
				preu += "/";
				preu += prU.getUnitat();

				txtPreu.setText(preu);

				TextView txtUnitats = new TextView(getActivity());
				txtUnitats.setLayoutParams(new LayoutParams(125,
						LayoutParams.WRAP_CONTENT));
				txtUnitats.setGravity(Gravity.CENTER_VERTICAL);

				txtUnitats.setText("\n x "
						+ Integer.toString(prU.getNumUnitats()));

				TextView txtPreuUnitariTotal = new TextView(getActivity());
				txtPreuUnitariTotal.setLayoutParams(new LayoutParams(115,
						LayoutParams.WRAP_CONTENT));
				txtPreuUnitariTotal.setGravity(Gravity.CENTER_VERTICAL);

				txtPreuUnitariTotal.setText("\n = "
						+ Float.toString((float) Math.round(prU
								.getImportPreuUnitats() * 100) / 100) + " €");

				preuUnitariRow.addView(txtPreu);
				preuUnitariRow.addView(txtUnitats);
				preuUnitariRow.addView(txtPreuUnitariTotal);

				preuUnitariRow.setId(index);

				// Càrrega de files a la taula
				tloPreusUnitarisCeles.addView(preuUnitariRow);

				totalPreusUnitaris += prU.getImportPreuUnitats();
			}

			// Assignació del total parcial de preus unitaris
			tvPreusUnitarisTotal.setText(Float.toString((float) Math
					.round(totalPreusUnitaris * 100) / 100));
		} else
			Toast.makeText(getActivity().getApplicationContext(),
					"Error en recuperar els preus unitaris.", Toast.LENGTH_LONG)
					.show();
	}

	@Override
	public void onCreateOptionsMenu(Menu menu, MenuInflater inflater) {
		inflater.inflate(R.menu.detall_fragment, menu);
		myMenu = menu;

		myMenu.findItem(R.id.menuDetallsInsert).setVisible(false);
		myMenu.findItem(R.id.menuDetallsModificar).setVisible(false);
	}

	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		switch (item.getItemId()) {

		case android.R.id.home:
			db.close();
			Intent intent = new Intent(getActivity(),
					LlistaFacturesActivity.class);
			intent.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP
					| Intent.FLAG_ACTIVITY_NEW_TASK);
			startActivity(intent);
			return true;

		case R.id.menuDetallsEliminar:
			Dialeg dialegEliminar = Dialeg.newInstance(
					(DetallsFacturaFragment) getFragmentManager()
							.findFragmentById(R.id.detallsFacturaFragment),
					"Eliminar factura", "Segur que vol eliminar la factura?",
					ESBORRAR);
			dialegEliminar.show(getFragmentManager(), "eliminar");
			return true;

		default:
			return super.onOptionsItemSelected(item);
		}
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * com.ADApps.translatorhelper.main.Dialeg.DialogCallbacks#onPositive(int)
	 */
	@Override
	public void onPositive(int mode) {
		switch (mode) {

		case ESBORRAR:
			String idFacturaDelete = tvIdFactura.getText().toString();

			if (db.deleteFactura(idFacturaDelete)) {
				db.close();
				Intent intent = new Intent(getActivity(),
						LlistaFacturesActivity.class);
				intent.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP
						| Intent.FLAG_ACTIVITY_NEW_TASK);
				startActivity(intent);
			} else {
				db.close();
				Toast.makeText(getActivity().getApplicationContext(),
						"Error en esborrar la factura.", Toast.LENGTH_LONG)
						.show();
			}
			break;

		case PENDENT:
			if (!db.modificarEstatFactura(tvIdFactura.getText().toString(),
					PENDENT)) {
				Toast.makeText(getActivity().getApplicationContext(),
						"Error en posar a pendent de cobrar la factura.",
						Toast.LENGTH_LONG).show();
			} else {
				tvEstat.setText(R.string.estatFac_pendent);
				btnEstatPendent.setVisibility(View.GONE);
				btnEstatCobrada.setVisibility(View.VISIBLE);
				onOptionsItemSelected(myMenu
						.findItem(R.id.menuDetallsModificar));
			}
			break;

		case COBRADA:
			if (!db.modificarEstatFactura(tvIdFactura.getText().toString(),
					COBRADA)) {
				Toast.makeText(getActivity().getApplicationContext(),
						"Error en posar a cobrada la factura.",
						Toast.LENGTH_LONG).show();
			} else {
				tvEstat.setText(R.string.estatFac_cobrada);
				btnEstatPendent.setVisibility(View.VISIBLE);
				btnEstatCobrada.setVisibility(View.GONE);
			}
			break;

		default:
			break;
		}
	}

	@Override
	public void onNegative(int mode) {

	}

	@Override
	public void onClick(View v) {
		switch (v.getId()) {
		case R.id.btnEstatPendent:
			Dialeg dialegPendent = Dialeg.newInstance(
					(DetallsFacturaFragment) getFragmentManager()
							.findFragmentById(R.id.detallsFacturaFragment),
					"Retrocedir cobrament",
					"Segur que vol retrocedir el cobrament?",
					PENDENT);
			dialegPendent.show(getFragmentManager(), pendent);
			break;
		case R.id.btnEstatCobrada:
			Dialeg dialegCobrar = Dialeg.newInstance(
					(DetallsFacturaFragment) getFragmentManager()
							.findFragmentById(R.id.detallsFacturaFragment),
					"Cobrar factura",
					"Segur que vol passar la factura a cobrada?",
					COBRADA);
			dialegCobrar.show(getFragmentManager(), cobrada);
			break;
		case R.id.btnEnviar:
			if (!db.modificarEstatFactura(tvIdFactura.getText().toString(),
					PENDENT)) {
				Toast.makeText(getActivity().getApplicationContext(),
						"Error en posar a pendent de cobrar la factura.",
						Toast.LENGTH_LONG).show();
			} else {
				try {
					if (!enviarFactura())
						Toast.makeText(getActivity().getApplicationContext(),
								"Error d'enviament.", Toast.LENGTH_LONG).show();
				} catch (FileNotFoundException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (DocumentException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				tvEstat.setText(R.string.estatFac_pendent);
				btnEstatCobrada.setVisibility(View.VISIBLE);
			}
			break;
		case R.id.btnModificarData:
			mostrarDatePickerDialog();
			break;
		default:
			break;
		}
	}

	private boolean enviarFactura() throws FileNotFoundException,
			DocumentException {
		File fitxer = null;

		if ((fitxer = crearDocument()) != null) {

			Intent emailIntent = new Intent(Intent.ACTION_SEND);

			emailIntent.putExtra(Intent.EXTRA_STREAM, Uri.fromFile(fitxer));

			// Únicament clients de correu
			emailIntent.setType("message/rfc822");

			startActivity(Intent.createChooser(emailIntent,
					"Enviar correu electrònic..."));

			return true;
		} else {
			return false;
		}
	}

	private File crearDocument() throws FileNotFoundException,
			DocumentException {
		// Creem el document.
		Document doc = new Document();

		// Creem el paràgraf.
		Paragraph par;

		// Creem la taula.
		PdfPTable taula;

		// Creem el fitxer amb el nom desitjat.
		File f = crearFitxer(tvIdFactura.getText().toString() + ".pdf");

		// Creem el flux de dades de sortida pel fitxer on guardarem el pdf.
		FileOutputStream fitxerPdf = new FileOutputStream(f.getAbsolutePath());

		// Associem el flux que acabem de crear al document.
		PdfWriter.getInstance(doc, fitxerPdf);

		// Obrim el document.
		doc.open();

		// Afegim el títol.
		par = new Paragraph(TITOL_DOCUMENT, FontFactory.getFont(
				FontFactory.HELVETICA, 28, Font.BOLD, Color.BLACK));
		par.setSpacingAfter(3f);
		doc.add(par);

		// Afegim el Client.
		par = new Paragraph("Client:", FontFactory.getFont(
				FontFactory.HELVETICA, 16, Font.BOLD, Color.BLACK));
		par.setSpacingAfter(1.5f);
		par.setIndentationLeft(1f);
		doc.add(par);

		par = new Paragraph(tvClient.getText().toString(), FontFactory.getFont(
				FontFactory.HELVETICA, 12, Font.NORMAL, Color.BLACK));
		par.setSpacingAfter(2f);
		par.setIndentationLeft(2f);
		doc.add(par);

		// Afegim la descripció del pressupost.
		par = new Paragraph("Descripció del projecte:", FontFactory.getFont(
				FontFactory.HELVETICA, 16, Font.BOLD, Color.BLACK));
		par.setSpacingAfter(1.5f);
		par.setIndentationLeft(1f);
		doc.add(par);

		par = new Paragraph(tvDesProjecte.getText().toString(),
				FontFactory.getFont(FontFactory.HELVETICA, 12, Font.NORMAL,
						Color.BLACK));
		par.setSpacingAfter(2f);
		par.setIndentationLeft(2f);
		doc.add(par);

		// Afegim la data d'entrega.
		par = new Paragraph("Data d'entrega:", FontFactory.getFont(
				FontFactory.HELVETICA, 16, Font.BOLD, Color.BLACK));
		par.setSpacingAfter(1.5f);
		par.setIndentationLeft(1f);
		doc.add(par);

		par = new Paragraph(tvData.getText().toString(), FontFactory.getFont(
				FontFactory.HELVETICA, 12, Font.NORMAL, Color.BLACK));
		par.setSpacingAfter(2f);
		par.setIndentationLeft(2f);
		doc.add(par);

		// Afegim el concepte i la tarifa.
		par = new Paragraph("Concepte/Tarifa:", FontFactory.getFont(
				FontFactory.HELVETICA, 16, Font.BOLD, Color.BLACK));
		par.setSpacingAfter(1.5f);
		par.setIndentationLeft(1f);
		doc.add(par);

		par = new Paragraph(tvConcepte.getText().toString() + "/"
				+ tvTarifa.getText().toString(), FontFactory.getFont(
				FontFactory.HELVETICA, 12, Font.NORMAL, Color.BLACK));
		par.setSpacingAfter(20f);
		par.setIndentationLeft(2f);
		doc.add(par);

		// Afegim la taula de preus unitaris.
		taula = new PdfPTable(3);

		taula.setSpacingBefore(20f);

		// Afegim la capçalera.
		taula.addCell("Preus unitaris");
		taula.addCell("Unitats");
		taula.addCell("");

		// Afegim les cel·les.
		for (int index = 0; index < lstPreusUnitaris.size(); index++) {
			PreuUnitariFac prU = lstPreusUnitaris.get(index);
			taula.addCell(prU.getNom() + ": " + Float.toString(prU.getPreu())
					+ " €/" + prU.getUnitat());
			taula.addCell(" x " + Integer.toString(prU.getNumUnitats()));
			taula.addCell(" = " + Float.toString(prU.getImportPreuUnitats())
					+ " €");
		}
		// Afegim la línia de total de preus unitaris.
		taula.addCell("");
		taula.addCell("");
		taula.addCell(tvPreusUnitarisTotal.getText().toString() + " €");

		doc.add(taula);

		// Afegim la taula d'impostos.
		taula = new PdfPTable(3);

		// Afegim la capçalera.
		taula.addCell("Impostos");
		taula.addCell("Valor");
		taula.addCell("");

		// Afegim les cel·les.
		for (int index = 0; index < lstImpostos.size(); index++) {
			ImpostFac imp = lstImpostos.get(index);
			taula.addCell(imp.getNom() + ": "
					+ tvPreusUnitarisTotal.getText().toString() + " €");
			taula.addCell(" x " + Float.toString(imp.getPercentatge()) + "%");
			taula.addCell(" = " + Float.toString(imp.getImportImpost()) + " €");
		}
		// Afegim la línia de total de preus unitaris.
		taula.addCell("");
		taula.addCell("");
		taula.addCell(tvImpostosTotal.getText().toString() + " €");

		doc.add(taula);

		// Afegim la taula de variables.
		taula = new PdfPTable(3);

		// Afegim la capçalera.
		taula.addCell("Variables");
		taula.addCell("Valor");
		taula.addCell("");

		// Afegim les cel·les.
		for (int index = 0; index < lstVariables.size(); index++) {
			VariableFac var = lstVariables.get(index);

			if (var.getTipusOperacio() == 1) {
				taula.addCell(var.getNom()
						+ ": "
						+ Float.toString(Float.parseFloat(tvPreusUnitarisTotal
								.getText().toString())
								+ Float.parseFloat(tvImpostosTotal.getText()
										.toString())) + " €");
				taula.addCell(" x " + Float.toString(var.getValor()) + "%");
			} else {
				taula.addCell(var.getNom() + ":");
				taula.addCell(" + " + Float.toString(var.getValor()) + " €");
			}

			taula.addCell(" = " + Float.toString(var.getImportVariable())
					+ " €");
		}

		// Afegim la línia de total de preus unitaris.
		taula.addCell("");
		taula.addCell("");
		taula.addCell(tvVariablesTotal.getText().toString() + " €");

		doc.add(taula);

		// Afegim el total del pressupost.
		par = new Paragraph("Total: " + tvImportTotal.getText() + " €",
				FontFactory.getFont(FontFactory.HELVETICA, 16, Font.NORMAL,
						Color.BLACK));
		par.setSpacingAfter(1.5f);
		par.setSpacingBefore(2f);
		par.setAlignment("right");
		doc.add(par);

		// Tanquem el document.
		doc.close();

		return f;
	}

	private File crearFitxer(String nomFitxer) {
		File ruta = getRuta();
		File fichero = null;
		if (ruta != null)
			fichero = new File(ruta, nomFitxer);
		return fichero;
	}

	private File getRuta() {
		// El fitxer serà emmagatzemat en un directori dins del directori
		// Download
		File ruta = null;
		if (Environment.MEDIA_MOUNTED.equals(Environment
				.getExternalStorageState())) {
			ruta = new File(
					Environment
							.getExternalStoragePublicDirectory(Environment.DIRECTORY_DOWNLOADS),
					NOM_DIRECTORI);

			if (ruta != null) {
				if (!ruta.mkdirs()) {
					if (!ruta.exists()) {
						return null;
					}
				}
			}
		}
		return ruta;
	}

	public void mostrarDatePickerDialog() {
		DialogFragment newFragment = new SelectDateFragment();
		newFragment.show(getFragmentManager(), "datePicker");
	}

	public static class SelectDateFragment extends DialogFragment implements
			DatePickerDialog.OnDateSetListener {
		@Override
		public Dialog onCreateDialog(Bundle savedInstanceState) {
			final Calendar calendar = Calendar.getInstance();
			int yy = calendar.get(Calendar.YEAR);
			int mm = calendar.get(Calendar.MONTH);
			int dd = calendar.get(Calendar.DAY_OF_MONTH);
			return new DatePickerDialog(getActivity(), this, yy, mm, dd);
		}

		@Override
		public void onDateSet(DatePicker view, int yy, int mm, int dd) {
			if (Integer.toString(mm).length() == 1) {
				tvData.setText(Integer.toString(dd) + "/0"
						+ Integer.toString(mm + 1) + "/" + Integer.toString(yy));
			} else {
				tvData.setText(Integer.toString(dd) + "/"
						+ Integer.toString(mm + 1) + "/" + Integer.toString(yy));
			}
			actualitzarData();
		}
	}

	public static void actualitzarData() {
		try {
			db.modificarDataFactura(tvIdFactura.getText().toString(),
					sdf.parse(tvData.getText().toString()));
		} catch (ParseException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
}
