/*
 * Translator Helper (TH)
 * Fco. Javier Domínguez Carral
 * TFC - UOC (2014)
 */
package com.ADApps.translatorhelper.factures;

import java.io.Serializable;
import java.util.Date;

import com.ADApps.translatorhelper.contactes.*;


/**
 * The Class Factura.
 */
public class Factura implements Serializable{

	/** The Constant serialVersionUID. */
	private static final long serialVersionUID = 1L;
	
	/** The id factura. */
	private String idFactura;
	
	/** The client. */
	private Contacte client;
	
	/** The data cobrament. */
	private Date dataCobrament;
	
	/** The estat. */
	private int estat;
	
	/** The data estat. */
	private Date dataEstat;
	
	/** The import total. */
	private float importTotal;
	
	/**
	 * Instantiates a new factura.
	 *
	 * @param idFactura the id factura
	 * @param client the client
	 * @param dataCobrament the data cobrament
	 * @param estat the estat
	 * @param dataEstat the data estat
	 * @param importTotal the import total
	 */
	public Factura(String idFactura, Contacte client, Date dataCobrament, int estat, Date dataEstat,
			float importTotal) {
		this.idFactura = idFactura;
		this.client = client;
		this.dataCobrament = dataCobrament;
		this.estat = estat;
		this.dataEstat = dataEstat;
		this.importTotal = importTotal;
	}
	
	/**
	 * Gets the client.
	 *
	 * @return the client
	 */
	public Contacte getClient() {
		return client;
	}
	
	/**
	 * Sets the client.
	 *
	 * @param client the new client
	 */
	public void setClient(Contacte client) {
		this.client = client;
	}
	
	/**
	 * Gets the data cobrament.
	 *
	 * @return the data cobrament
	 */
	public Date getDataCobrament() {
		return dataCobrament;
	}
	
	/**
	 * Sets the data cobrament.
	 *
	 * @param dataCobrament the new data cobrament
	 */
	public void setDataCobrament(Date dataCobrament) {
		this.dataCobrament = dataCobrament;
	}
	
	/**
	 * Gets the estat.
	 *
	 * @return the estat
	 */
	public int getEstat() {
		return estat;
	}
	
	/**
	 * Sets the estat.
	 *
	 * @param estat the new estat
	 */
	public void setEstat(int estat) {
		this.estat = estat;
	}
	
	/**
	 * Gets the data estat.
	 *
	 * @return the data estat
	 */
	public Date getDataEstat() {
		return dataEstat;
	}
	
	/**
	 * Sets the data estat.
	 *
	 * @param dataEstat the new data estat
	 */
	public void setDataEstat(Date dataEstat) {
		this.dataEstat = dataEstat;
	}
	
	/**
	 * Gets the import total.
	 *
	 * @return the import total
	 */
	public float getImportTotal() {
		return importTotal;
	}
	
	/**
	 * Sets the import total.
	 *
	 * @param importTotal the new import total
	 */
	public void setImportTotal(float importTotal) {
		this.importTotal = importTotal;
	}
	
	/**
	 * Gets the id factura.
	 *
	 * @return the id factura
	 */
	public String getIdFactura() {
		return idFactura;
	}
}
