/*
 * Translator Helper (TH)
 * Fco. Javier Domínguez Carral
 * TFC - UOC (2014)
 */
package com.ADApps.translatorhelper.main;

import android.app.AlertDialog;
import android.app.Dialog;
import android.content.DialogInterface;
import android.content.DialogInterface.OnClickListener;
import android.os.Bundle;
import android.support.v4.app.DialogFragment;

import com.ADApps.translatorhelper.contactes.DetallsContacteFragment;
import com.ADApps.translatorhelper.factures.DetallsFacturaFragment;
import com.ADApps.translatorhelper.parametres.conceptes.DetallsConcepteFragment;
import com.ADApps.translatorhelper.parametres.impostos.DetallsImpostFragment;
import com.ADApps.translatorhelper.parametres.preusunitaris.DetallsPreuUnitariFragment;
import com.ADApps.translatorhelper.parametres.tarifes.DetallsTarifaFragment;
import com.ADApps.translatorhelper.parametres.variables.DetallsVariableFragment;
import com.ADApps.translatorhelper.pressupostos.DetallsPressupostFragment;
import com.ADApps.translatorhelper.projectes.DetallsProjecteFragment;


/**
 * The Class Dialeg.
 */
public class Dialeg extends DialogFragment {

	/** The listener. */
	private static DialogCallbacks listener;
	
	/** The dialog title. */
	private static String dialogTitle;
	
	/** The dialog message. */
	private static String dialogMessage;
	
	/** The dialog mode. */
	private static int dialogMode;
	
    /**
     * The Interface DialogCallbacks.
     */
    public interface DialogCallbacks {
        
        /**
         * On positive.
         *
         * @param dialogMode the dialog mode
         */
        void onPositive(int dialogMode);
        
        /**
         * On negative.
         *
         * @param dialogMode the dialog mode
         */
        void onNegative(int dialogMode);
    }

    /**
     * New instance.
     *
     * @param hostFragment the host fragment
     * @param title the title
     * @param message the message
     * @param mode the mode
     * @return the dialeg
     */
    public static Dialeg newInstance(DetallsConcepteFragment hostFragment, 
    		String title, String message, int mode) {
        listener = hostFragment;
        dialogTitle = title;
        dialogMessage = message;
        dialogMode = mode;
        return new Dialeg();
    }
    
    /**
     * New instance.
     *
     * @param hostFragment the host fragment
     * @param title the title
     * @param message the message
     * @param mode the mode
     * @return the dialeg
     */
    public static Dialeg newInstance(DetallsTarifaFragment hostFragment, 
    		String title, String message, int mode) {
        listener = hostFragment;
        dialogTitle = title;
        dialogMessage = message;
        dialogMode = mode;
        return new Dialeg();
    }
    
    /**
     * New instance.
     *
     * @param hostFragment the host fragment
     * @param title the title
     * @param message the message
     * @param mode the mode
     * @return the dialeg
     */
    public static Dialeg newInstance(DetallsPreuUnitariFragment hostFragment, 
    		String title, String message, int mode) {
        listener = hostFragment;
        dialogTitle = title;
        dialogMessage = message;
        dialogMode = mode;
        return new Dialeg();
    }
    
    /**
     * New instance.
     *
     * @param hostFragment the host fragment
     * @param title the title
     * @param message the message
     * @param mode the mode
     * @return the dialeg
     */
    public static Dialeg newInstance(DetallsImpostFragment hostFragment, 
    		String title, String message, int mode) {
        listener = hostFragment;
        dialogTitle = title;
        dialogMessage = message;
        dialogMode = mode;
        return new Dialeg();
    }
    
    /**
     * New instance.
     *
     * @param hostFragment the host fragment
     * @param title the title
     * @param message the message
     * @param mode the mode
     * @return the dialeg
     */
    public static Dialeg newInstance(DetallsVariableFragment hostFragment, 
    		String title, String message, int mode) {
        listener = hostFragment;
        dialogTitle = title;
        dialogMessage = message;
        dialogMode = mode;
        return new Dialeg();
    }
    
    /**
     * New instance.
     *
     * @param hostFragment the host fragment
     * @param title the title
     * @param message the message
     * @param mode the mode
     * @return the dialeg
     */
    public static Dialeg newInstance(DetallsContacteFragment hostFragment, 
    		String title, String message, int mode) {
        listener = hostFragment;
        dialogTitle = title;
        dialogMessage = message;
        dialogMode = mode;
        return new Dialeg();
    }
    
    /**
     * New instance.
     *
     * @param hostFragment the host fragment
     * @param title the title
     * @param message the message
     * @param mode the mode
     * @return the dialeg
     */
    public static Dialeg newInstance(DetallsPressupostFragment hostFragment,
    		String title, String message, int mode) {
    	listener = hostFragment;
        dialogTitle = title;
        dialogMessage = message;
        dialogMode = mode;
        return new Dialeg();
	}
    
    /**
     * New instance.
     *
     * @param hostFragment the host fragment
     * @param title the title
     * @param message the message
     * @param mode the mode
     * @return the dialeg
     */
    public static Dialeg newInstance(DetallsProjecteFragment hostFragment,
			String title, String message, int mode) {
    	listener = hostFragment;
        dialogTitle = title;
        dialogMessage = message;
        dialogMode = mode;
        return new Dialeg();
	}

	public static Dialeg newInstance(DetallsFacturaFragment hostFragment,
			String title, String message, int mode) {
		listener = hostFragment;
		dialogTitle = title;
		dialogMessage = message;
		dialogMode = mode;
		return new Dialeg();
	}
	
	/* (non-Javadoc)
	 * @see android.support.v4.app.DialogFragment#onCreateDialog(android.os.Bundle)
	 */
	@Override
	public Dialog onCreateDialog(Bundle savedInstanceState) {
		AlertDialog.Builder builder = new AlertDialog.Builder(getActivity());
     
        builder.setTitle(dialogTitle);
        builder.setMessage(dialogMessage);
        builder.setPositiveButton("Acceptar", new OnClickListener() {
	        @Override
			public void onClick(DialogInterface dialog, int which) {
	        	listener.onPositive(dialogMode);
	        }
        });
        builder.setNegativeButton("Cancelar", new OnClickListener() {
	        @Override
			public void onClick(DialogInterface dialog, int which) {
	        	listener.onNegative(dialogMode);
	        }
        });
     
        return builder.create();
	}
}
