/*
 * Translator Helper (TH)
 * Fco. Javier Domínguez Carral
 * TFC - UOC (2014)
 */
package com.ADApps.translatorhelper.main;

import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.SpinnerAdapter;

import com.ADApps.translatorhelper.contactes.LlistaContactesActivity;
import com.ADApps.translatorhelper.factures.LlistaFacturesActivity;
import com.ADApps.translatorhelper.pressupostos.LlistaPressupostosActivity;
import com.ADApps.translatorhelper.projectes.LlistaProjectesActivity;
import com.ADApps.translatorhelper.R;
import com.actionbarsherlock.app.ActionBar;
import com.actionbarsherlock.app.ActionBar.OnNavigationListener;
import com.actionbarsherlock.app.SherlockActivity;
import com.actionbarsherlock.view.Menu;
import com.actionbarsherlock.view.MenuInflater;
import com.actionbarsherlock.view.MenuItem;


/**
 * The Class MainActivity.
 */
public class MainActivity extends SherlockActivity {    
	
    /* (non-Javadoc)
     * @see android.app.Activity#onCreate(android.os.Bundle)
     */
    @Override
    public void onCreate(Bundle savedInstanceState) {
    	OnNavigationListener menuOnNavigationListener;
        super.onCreate(savedInstanceState);
        
        // Action bar control
        ActionBar ab = getSupportActionBar();
        ab.setNavigationMode(ActionBar.NAVIGATION_MODE_LIST);
        ab.setDisplayOptions(ActionBar.DISPLAY_SHOW_TITLE);
        ab.setTitle(R.string.app_name_title);
        
        SpinnerAdapter menuSpinnerAdapter = 
        		ArrayAdapter.createFromResource(this, R.array.action_list, R.layout.sherlock_spinner_dropdown_item);
        
        menuOnNavigationListener = new OnNavigationListener() {
        	
			@Override
			public boolean onNavigationItemSelected(int position, long itemId) {
				// Create new fragment from our own Fragment class
				switch (position) {
				case 0:
					break;
				case 1:
					startActivity(new Intent(getApplicationContext(), LlistaContactesActivity.class));
					break;
				}
				return true;
			}        	
        };
        
        getSupportActionBar().setListNavigationCallbacks(menuSpinnerAdapter, menuOnNavigationListener);
                
        setContentView(R.layout.activity_main);
        
        // Button pressupostos control
        Button btnPre = (Button)findViewById(R.id.BtnPressupostos);
        btnPre.setOnClickListener(new OnClickListener() {
        	public void onClick(View v) {
        		startActivity(new Intent(getApplicationContext(), LlistaPressupostosActivity.class));
        	}
        });
        
        // Button projectes control
        Button btnPro = (Button)findViewById(R.id.BtnProjectes);
        btnPro.setOnClickListener(new OnClickListener() {
        	public void onClick(View v) {
        		startActivity(new Intent(getApplicationContext(), LlistaProjectesActivity.class));
        	}
        });
        
        // Button factures control
        Button btnFac = (Button)findViewById(R.id.BtnFactures);
        btnFac.setOnClickListener(new OnClickListener() {
        	public void onClick(View v) {
        		startActivity(new Intent(getApplicationContext(), LlistaFacturesActivity.class));
        	}
        });
    }
    
    /* (non-Javadoc)
     * @see android.app.Activity#onResume()
     */
    @Override
	protected void onResume() {
		super.onResume();
		
		getSupportActionBar().setSelectedNavigationItem(0);
	}

	/* (non-Javadoc)
	 * @see com.actionbarsherlock.app.SherlockActivity#onCreateOptionsMenu(android.view.Menu)
	 */
	@Override
    public boolean onCreateOptionsMenu(Menu menu) {
        MenuInflater inflater = getSupportMenuInflater();
        inflater.inflate(R.menu.main, menu);
        return true;
    }
    
    /* (non-Javadoc)
     * @see com.actionbarsherlock.app.SherlockActivity#onOptionsItemSelected(android.view.MenuItem)
     */
    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        if (item.getItemId() == R.id.configuracion) {
        	startActivity(new Intent(getApplicationContext(), MainParametres.class));
        }
        return true;
    }
}