/*
 * Translator Helper (TH)
 * Fco. Javier Domínguez Carral
 * TFC - UOC (2014)
 */
package com.ADApps.translatorhelper.main;

import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
//import android.widget.Toast;

import com.ADApps.translatorhelper.parametres.conceptes.LlistaConceptesActivity;
import com.ADApps.translatorhelper.parametres.impostos.LlistaImpostosActivity;
import com.ADApps.translatorhelper.parametres.preusunitaris.LlistaPreusUnitarisActivity;
import com.ADApps.translatorhelper.parametres.tarifes.LlistaTarifesActivity;
import com.ADApps.translatorhelper.parametres.variables.LlistaVariablesActivity;
import com.ADApps.translatorhelper.R;
import com.actionbarsherlock.app.ActionBar;
import com.actionbarsherlock.app.SherlockActivity;
//import com.actionbarsherlock.view.Menu;
//import com.actionbarsherlock.view.MenuInflater;
import com.actionbarsherlock.view.MenuItem;


/**
 * The Class MainParametres.
 */
public class MainParametres extends SherlockActivity {

	/* (non-Javadoc)
	 * @see android.app.Activity#onCreate(android.os.Bundle)
	 */
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		
		ActionBar ab = getSupportActionBar();
        ab.setDisplayOptions(ActionBar.DISPLAY_SHOW_TITLE|ActionBar.DISPLAY_HOME_AS_UP);
        ab.setTitle(getString(R.string.title_activity_main_parametres));
        
		setContentView(R.layout.activity_main_parametres);
		
		// Button conceptes control
        Button btnCon = (Button)findViewById(R.id.btnConceptes);
        btnCon.setOnClickListener(new OnClickListener() {
        	public void onClick(View v) {
        		startActivity(new Intent(getApplicationContext(), LlistaConceptesActivity.class));
        	}
        });
        
        // Button tarifes control
        Button btnTar = (Button)findViewById(R.id.btnTarifes);
        btnTar.setOnClickListener(new OnClickListener() {
        	public void onClick(View v) {
        		startActivity(new Intent(getApplicationContext(), LlistaTarifesActivity.class));
        	}
        });
        
        // Button preus unitaris control
        Button btnPUn = (Button)findViewById(R.id.btnPreusUnitaris);
        btnPUn.setOnClickListener(new OnClickListener() {
        	public void onClick(View v) {
        		startActivity(new Intent(getApplicationContext(), LlistaPreusUnitarisActivity.class));
        	}
        });
        
     // Button impostos control
        Button btnImp = (Button)findViewById(R.id.btnImpostos);
        btnImp.setOnClickListener(new OnClickListener() {
        	public void onClick(View v) {
        		startActivity(new Intent(getApplicationContext(), LlistaImpostosActivity.class));
        	}
        });
        
        // Button variables control
        Button btnVar = (Button)findViewById(R.id.btnVariables);
        btnVar.setOnClickListener(new OnClickListener() {
        	public void onClick(View v) {
        		startActivity(new Intent(getApplicationContext(), LlistaVariablesActivity.class));
        	}
        });
	}

	/* (non-Javadoc)
	 * @see com.actionbarsherlock.app.SherlockActivity#onOptionsItemSelected(android.view.MenuItem)
	 */
	@Override
    public boolean onOptionsItemSelected(MenuItem item) {
        if (item.getItemId() == android.R.id.home) {
            Intent intent = new Intent(this, MainActivity.class);
            intent.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP|Intent.FLAG_ACTIVITY_NEW_TASK);
            startActivity(intent);
            return true;
        }
        return true;
    }
}
