/*
 * Translator Helper (TH)
 * Fco. Javier Domínguez Carral
 * TFC - UOC (2014)
 */
package com.ADApps.translatorhelper.parametres.conceptes;

import android.content.Intent;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.Toast;

import com.ADApps.translatorhelper.R;
import com.ADApps.translatorhelper.main.Dialeg;
import com.ADApps.translatorhelper.main.THDataBaseHelper;
import com.actionbarsherlock.app.SherlockFragment;
import com.actionbarsherlock.view.Menu;
import com.actionbarsherlock.view.MenuInflater;
import com.actionbarsherlock.view.MenuItem;


/**
 * The Class DetallsConcepteFragment.
 */
public class DetallsConcepteFragment extends SherlockFragment implements Dialeg.DialogCallbacks{
	
	/** The Constant ESBORRAR. */
	private static final int ESBORRAR = 1;
	
	/** The Constant MODIFICAR. */
	private static final int MODIFICAR = 2;
	
	/** The Constant INSERTAR. */
	private static final int INSERTAR = 3;	
	
	/** The et nom concepte. */
	private EditText etNomConcepte;
	
	/** The tv id concepte. */
	private TextView tvIDConcepte;
	
	/** The my menu. */
	private Menu myMenu;
	
	/** The db. */
	private static THDataBaseHelper db;

	/* (non-Javadoc)
	 * @see android.support.v4.app.Fragment#onCreate(android.os.Bundle)
	 */
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setHasOptionsMenu(true);
		db = new THDataBaseHelper(getActivity());
		db.open();
	}

	/* (non-Javadoc)
	 * @see android.support.v4.app.Fragment#onCreateView(android.view.LayoutInflater, android.view.ViewGroup, android.os.Bundle)
	 */
	@Override
	public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
		View view = inflater.inflate(R.layout.fragment_detalls_concepte, container, false);
		return view;
	}
	
	/* (non-Javadoc)
	 * @see android.support.v4.app.Fragment#onActivityCreated(android.os.Bundle)
	 */
	@Override
	public void onActivityCreated(Bundle savedInstanceState) {
		super.onActivityCreated(savedInstanceState);
		Bundle extras = getActivity().getIntent().getExtras();
		etNomConcepte = (EditText) getView().findViewById(R.id.detallsConcepteTxt);
		tvIDConcepte = (TextView) getView().findViewById(R.id.lblDetallsConcepteID);
		
		inicialitzarViews(extras);
	}
	
	/**
	 * Inicialitzar views.
	 *
	 * @param extras the extras
	 */
	public void inicialitzarViews(Bundle extras) {		
		if (!extras.getBoolean("afegir")){
			Concepte registre = (Concepte)extras.getSerializable("registre");
			etNomConcepte.setText(registre.getNom());
			tvIDConcepte.setText(Integer.toString(registre.getidConcepte()));
			
		}else {
			etNomConcepte.setClickable(true);
			etNomConcepte.setCursorVisible(true);
			etNomConcepte.setFocusable(true);
			etNomConcepte.setFocusableInTouchMode(true);
			etNomConcepte.requestFocus();
		}
	}
	
	/* (non-Javadoc)
	 * @see com.actionbarsherlock.app.SherlockFragment#onCreateOptionsMenu(android.view.Menu, android.view.MenuInflater)
	 */
	@Override
    public void onCreateOptionsMenu(Menu menu, MenuInflater inflater) {
        inflater.inflate(R.menu.detall_parametre_fragment, menu);
        myMenu = menu;
        if (getActivity().getIntent().getExtras().getBoolean("afegir")) {
        	myMenu.findItem(R.id.menuLstParametresInsert).setVisible(true);
        	myMenu.findItem(R.id.menuLstParametresModificar).setVisible(false);
        	myMenu.findItem(R.id.menuLstParametresEliminar).setVisible(false);
        }
    }

    /* (non-Javadoc)
     * @see com.actionbarsherlock.app.SherlockFragment#onOptionsItemSelected(android.view.MenuItem)
     */
    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        switch (item.getItemId()) {
	        case android.R.id.home:
	        	db.close();
				Intent intent = new Intent(getActivity(), LlistaConceptesActivity.class);
	            intent.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP|Intent.FLAG_ACTIVITY_NEW_TASK);
	            startActivity(intent);
	            return true;
	        case R.id.menuLstParametresModificar:
	        	if (etNomConcepte != null) {
	        		etNomConcepte.setClickable(true);
	        		etNomConcepte.setCursorVisible(true);
	        		etNomConcepte.setFocusable(true);
	        		etNomConcepte.setFocusableInTouchMode(true);
	        		etNomConcepte.requestFocus();
	        	}
	        	myMenu.findItem(R.id.menuLstParametresUpdate).setVisible(true);
	        	myMenu.findItem(R.id.menuLstParametresModificar).setVisible(false);
	        	myMenu.findItem(R.id.menuLstParametresEliminar).setVisible(false);
	    		return true;
	    	case R.id.menuLstParametresEliminar:
	    		if (db.isConcepteReferenced(Integer.parseInt(tvIDConcepte.getText().toString()))){
		    		Dialeg dialegEliminar = Dialeg.newInstance((DetallsConcepteFragment)
		    				getFragmentManager().findFragmentById(R.id.detallsConcepteFragment), 
		    				"Eliminar concepte", "Segur que vol eliminar el concepte?", ESBORRAR);
		    		dialegEliminar.show(getFragmentManager(), "eliminar");
	    		}else {
					Toast.makeText(getActivity().getApplicationContext()
,
						"IMPOSIBLE ESBORRAR: El concepte està referenciat per una tarifa."
							,Toast.LENGTH_LONG).show();
				}
	    		return true;
	    	case R.id.menuLstParametresUpdate:
	    		String stringUpdate = etNomConcepte.getText().toString();
	    		if (stringUpdate == null || stringUpdate.isEmpty()) {
	    			Toast.makeText(getActivity().getApplicationContext(),"El camp nom no pot estar buit.", 
			    			Toast.LENGTH_LONG).show();
	    		}else	if (db.getIDConcepte(stringUpdate) == -1){
			    			Dialeg dialegModificar = Dialeg.newInstance((DetallsConcepteFragment)
				    				getFragmentManager().findFragmentById(R.id.detallsConcepteFragment), 
				    				"Modificar concepte", "Segur que vol desar els canvis al concepte?", MODIFICAR);
				    		dialegModificar.show(getFragmentManager(), "modificar");
			    		}else {
			    			Toast.makeText(getActivity().getApplicationContext(),"El concepte ja existeix.", 
					    			Toast.LENGTH_LONG).show();
			    		}
	    		return true;
	    	case R.id.menuLstParametresInsert:
	    		String stringInsert = etNomConcepte.getText().toString();
	    		if (stringInsert == null || stringInsert.isEmpty()) {
	    			Toast.makeText(getActivity().getApplicationContext(),"El camp nom no pot estar buit.", 
			    			Toast.LENGTH_LONG).show();
	    		}else	if (db.getIDConcepte(stringInsert) == -1){
				    		Dialeg dialegAfegir = Dialeg.newInstance((DetallsConcepteFragment)
				    				getFragmentManager().findFragmentById(R.id.detallsConcepteFragment), 
				    				"Afegir concepte", "Segur que vol afegir el concepte?", INSERTAR);
				    		dialegAfegir.show(getFragmentManager(), "afegir");
			    		}else {
			    			Toast.makeText(getActivity().getApplicationContext(),"El concepte ja existeix.", 
					    			Toast.LENGTH_LONG).show();
			    		}
	    		return true;
			default:
				return super.onOptionsItemSelected(item);
        }
    }

	/* (non-Javadoc)
	 * @see com.ADApps.translatorhelper.main.Dialeg.DialogCallbacks#onPositive(int)
	 */
	@Override
	public void onPositive(int mode) {		
		switch (mode){
			case ESBORRAR:
				if (db.deleteConcepte(Integer.parseInt(tvIDConcepte.getText().toString()))) {
					db.close();
					Intent intent = new Intent(getActivity(), LlistaConceptesActivity.class);
		            intent.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP|Intent.FLAG_ACTIVITY_NEW_TASK);
		            startActivity(intent);
				}else {
					db.close();
					Toast.makeText(getActivity().getApplicationContext(),"Error en modificar", 
			    			Toast.LENGTH_LONG).show();
				}
				break;
			case MODIFICAR:
				if (db.updateConcepte(Integer.parseInt(tvIDConcepte.getText().toString())
						, etNomConcepte.getText().toString())) {
					db.close();
					Intent intent = new Intent(getActivity(), LlistaConceptesActivity.class);
		            intent.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP|Intent.FLAG_ACTIVITY_NEW_TASK);
		            startActivity(intent);
				}else {
					db.close();
					Toast.makeText(getActivity().getApplicationContext(),"Error en modificar", 
			    			Toast.LENGTH_LONG).show();
				}
				break;
			case INSERTAR:
				if (db.insertConcepte(etNomConcepte.getText().toString())) {
					db.close();
					Intent intent = new Intent(getActivity(), LlistaConceptesActivity.class);
		            intent.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP|Intent.FLAG_ACTIVITY_NEW_TASK);
		            startActivity(intent);
				}else {
					db.close();
					Toast.makeText(getActivity().getApplicationContext(),"Error en insertar", 
			    			Toast.LENGTH_LONG).show();
				}
				break;
			default:
				break;
		}	
	}

	/* (non-Javadoc)
	 * @see com.ADApps.translatorhelper.main.Dialeg.DialogCallbacks#onNegative(int)
	 */
	@Override
	public void onNegative(int mode) {
	}
}