/*
 * Translator Helper (TH)
 * Fco. Javier Domínguez Carral
 * TFC - UOC (2014)
 */
package com.ADApps.translatorhelper.parametres.impostos;

import android.content.Intent;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.Toast;

import com.ADApps.translatorhelper.main.Dialeg;
import com.ADApps.translatorhelper.main.THDataBaseHelper;
import com.ADApps.translatorhelper.R;
import com.actionbarsherlock.app.SherlockFragment;
import com.actionbarsherlock.view.Menu;
import com.actionbarsherlock.view.MenuInflater;
import com.actionbarsherlock.view.MenuItem;


/**
 * The Class DetallsImpostFragment.
 */
public class DetallsImpostFragment extends SherlockFragment implements Dialeg.DialogCallbacks{
	
	/** The Constant ESBORRAR. */
	private static final int ESBORRAR = 1;
	
	/** The Constant MODIFICAR. */
	private static final int MODIFICAR = 2;
	
	/** The Constant INSERTAR. */
	private static final int INSERTAR = 3;
	
	/** The et nom impost. */
	private EditText etNomImpost;
	
	/** The tv id impost. */
	private TextView tvIDImpost;
	
	/** The et percentatge impost. */
	private EditText etPercentatgeImpost;
	
	/** The my menu. */
	private Menu myMenu;
	
	/** The db. */
	private static THDataBaseHelper db;

	/* (non-Javadoc)
	 * @see android.support.v4.app.Fragment#onCreate(android.os.Bundle)
	 */
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setHasOptionsMenu(true);
		db = new THDataBaseHelper(getActivity());
		db.open();
	}

	/* (non-Javadoc)
	 * @see android.support.v4.app.Fragment#onCreateView(android.view.LayoutInflater, android.view.ViewGroup, android.os.Bundle)
	 */
	@Override
	public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
		View view = inflater.inflate(R.layout.fragment_detalls_impost, container, false);
		return view;
	}
	
	/* (non-Javadoc)
	 * @see android.support.v4.app.Fragment#onActivityCreated(android.os.Bundle)
	 */
	@Override
	public void onActivityCreated(Bundle savedInstanceState) {
		super.onActivityCreated(savedInstanceState);
		Bundle extras = getActivity().getIntent().getExtras();
		etNomImpost = (EditText) getView().findViewById(R.id.txtDetallsImpostNom);
		tvIDImpost = (TextView) getView().findViewById(R.id.lblDetallsImpostID);
		etPercentatgeImpost = (EditText) getView().findViewById(R.id.txtDImpostPercentatge);
		
		inicialitzarViews (extras);
	}
	
	/**
	 * Inicialitzar views.
	 *
	 * @param extras the extras
	 */
	public void inicialitzarViews(Bundle extras) {
				
		if (!extras.getBoolean("afegir")){
			Impost registre = (Impost)extras.getSerializable("registre");
			etNomImpost.setText(registre.getNom());
			tvIDImpost.setText(Integer.toString(registre.getIdImpost()));
			etPercentatgeImpost.setText(Float.toString(registre.getPercentatge()));
			
		}else {
			etNomImpost.setClickable(true);
			etNomImpost.setCursorVisible(true);
			etNomImpost.setFocusable(true);
			etNomImpost.setFocusableInTouchMode(true);
			etNomImpost.requestFocus();
						
			etPercentatgeImpost.setClickable(true);
			etPercentatgeImpost.setCursorVisible(true);
			etPercentatgeImpost.setFocusable(true);
			etPercentatgeImpost.setFocusableInTouchMode(true);
		}		
	}

	/* (non-Javadoc)
	 * @see com.actionbarsherlock.app.SherlockFragment#onCreateOptionsMenu(android.view.Menu, android.view.MenuInflater)
	 */
	@Override
	public void onCreateOptionsMenu(Menu menu, MenuInflater inflater) {
	    inflater.inflate(R.menu.detall_parametre_fragment, menu);
	    myMenu = menu;
	    if (getActivity().getIntent().getExtras().getBoolean("afegir")) {
	    	myMenu.findItem(R.id.menuLstParametresInsert).setVisible(true);
	    	myMenu.findItem(R.id.menuLstParametresModificar).setVisible(false);
	    	myMenu.findItem(R.id.menuLstParametresEliminar).setVisible(false);
	    }
	}
	
	/* (non-Javadoc)
	 * @see com.actionbarsherlock.app.SherlockFragment#onOptionsItemSelected(android.view.MenuItem)
	 */
	@Override
    public boolean onOptionsItemSelected(MenuItem item) {
        switch (item.getItemId()) {
	        case android.R.id.home:
	        	db.close();
				Intent intent = new Intent(getActivity(), LlistaImpostosActivity.class);
	            intent.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP|Intent.FLAG_ACTIVITY_NEW_TASK);
	            startActivity(intent);
	            return true;
	        case R.id.menuLstParametresModificar:
	        	if (etNomImpost != null && etPercentatgeImpost != null) {
	        		etNomImpost.setClickable(true);
	        		etNomImpost.setCursorVisible(true);
	        		etNomImpost.setFocusable(true);
	        		etNomImpost.setFocusableInTouchMode(true);
	        		etNomImpost.requestFocus();
	        		
	        		etPercentatgeImpost.setClickable(true);
	    			etPercentatgeImpost.setCursorVisible(true);
	    			etPercentatgeImpost.setFocusable(true);
	    			etPercentatgeImpost.setFocusableInTouchMode(true);
	    			
	        	}else{
	        		Toast.makeText(getActivity().getApplicationContext(),"Error en modificar", 
			    			Toast.LENGTH_LONG).show();
	        	}
	        	myMenu.findItem(R.id.menuLstParametresUpdate).setVisible(true);
	        	myMenu.findItem(R.id.menuLstParametresModificar).setVisible(false);
	        	myMenu.findItem(R.id.menuLstParametresEliminar).setVisible(false);
	    		return true;
	    	case R.id.menuLstParametresEliminar:
	    		Dialeg dialegEliminar = Dialeg.newInstance((DetallsImpostFragment)
	    				getFragmentManager().findFragmentById(R.id.detallsImpostFragment), 
	    				"Eliminar impost", "Segur que vol eliminar l'impost?", ESBORRAR);
	    		dialegEliminar.show(getFragmentManager(), "eliminar");
	    		return true;
	    	case R.id.menuLstParametresUpdate:
	    		String nomImpostUpdate = etNomImpost.getText().toString();
	    		String percentatgeImpostUpdate = etPercentatgeImpost.getText().toString();
	    		
	    		if (nomImpostUpdate == null || nomImpostUpdate.isEmpty()) {
	    			Toast.makeText(getActivity().getApplicationContext(),"El camp nom no pot estar buit.", 
			    			Toast.LENGTH_LONG).show();
	    			return true;
	    		}
	    		
	    		if (percentatgeImpostUpdate == null || percentatgeImpostUpdate.isEmpty()) {
	    			Toast.makeText(getActivity().getApplicationContext(),"El camp percentatge no pot estar buit.", 
			    			Toast.LENGTH_LONG).show();
	    			return true;
	    		}
	    		
    			if (db.getIDImpost(nomImpostUpdate, percentatgeImpostUpdate) == -1){
	    			Dialeg dialegModificar = Dialeg.newInstance((DetallsImpostFragment)
		    				getFragmentManager().findFragmentById(R.id.detallsImpostFragment), 
		    				"Modificar impost", "Segur que vol desar els canvis a l'impost?", MODIFICAR);
		    		dialegModificar.show(getFragmentManager(), "modificar");
	    		}else {
	    			Toast.makeText(getActivity().getApplicationContext(),"L'impost ja existeix.", 
			    			Toast.LENGTH_LONG).show();
	    		}
	    		return true;
	    	case R.id.menuLstParametresInsert:
	    		String nomImpostInsert = etNomImpost.getText().toString();
	    		String percentatgeImpostInsert = etPercentatgeImpost.getText().toString();
	    		
	    		if (nomImpostInsert == null || nomImpostInsert.isEmpty()) {
	    			Toast.makeText(getActivity().getApplicationContext(),"El camp nom no pot estar buit.", 
			    			Toast.LENGTH_LONG).show();
	    			return true;
	    		}
	    		
	    		if (percentatgeImpostInsert == null || percentatgeImpostInsert.isEmpty()) {
	    			Toast.makeText(getActivity().getApplicationContext(),"El camp percentatge no pot estar buit.", 
			    			Toast.LENGTH_LONG).show();
	    			return true;
	    		}
	    			    		
	    		if (db.getIDImpost(nomImpostInsert) == -1){
		    		Dialeg dialegAfegir = Dialeg.newInstance((DetallsImpostFragment)
		    				getFragmentManager().findFragmentById(R.id.detallsImpostFragment), 
		    				"Afegir impost", "Segur que vol afegir l'impost?", INSERTAR);
		    		dialegAfegir.show(getFragmentManager(), "afegir");
	    		}else {
	    			Toast.makeText(getActivity().getApplicationContext(),"L'impost ja existeix.", 
			    			Toast.LENGTH_LONG).show();
	    		}
	    		return true;
			default:
				return super.onOptionsItemSelected(item);
        }
    }
	
	/* (non-Javadoc)
	 * @see com.ADApps.translatorhelper.main.Dialeg.DialogCallbacks#onPositive(int)
	 */
	@Override
	public void onPositive(int mode) {
		switch (mode){
			case ESBORRAR:
				if (db.deleteImpost(Integer.parseInt(tvIDImpost.getText().toString()))) {
					db.close();
					Intent intent = new Intent(getActivity(), LlistaImpostosActivity.class);
		            intent.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP|Intent.FLAG_ACTIVITY_NEW_TASK);
		            startActivity(intent);
				}else {
					db.close();
					Toast.makeText(getActivity().getApplicationContext(),"Error en esborrar", 
			    			Toast.LENGTH_LONG).show();
				}
				break;
			case MODIFICAR:
				
				if (db.updateImpost(Integer.parseInt(tvIDImpost.getText().toString())
						, etNomImpost.getText().toString()
						, etPercentatgeImpost.getText().toString())) {
					db.close();
					Intent intent = new Intent(getActivity(), LlistaImpostosActivity.class);
		            intent.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP|Intent.FLAG_ACTIVITY_NEW_TASK);
		            startActivity(intent);
				}else {
					db.close();
					Toast.makeText(getActivity().getApplicationContext(),"Error en modificar", 
			    			Toast.LENGTH_LONG).show();
				}
				break;
			case INSERTAR:
					
				if (db.insertImpost(etNomImpost.getText().toString()
						, etPercentatgeImpost.getText().toString())) {
					db.close();
					Intent intent = new Intent(getActivity(), LlistaImpostosActivity.class);
		            intent.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP|Intent.FLAG_ACTIVITY_NEW_TASK);
		            startActivity(intent);
				}else {
					db.close();
					Toast.makeText(getActivity().getApplicationContext(),"Error en insertar", 
			    			Toast.LENGTH_LONG).show();
				}
				break;
			default:
				break;
		}	
	}

	/* (non-Javadoc)
	 * @see com.ADApps.translatorhelper.main.Dialeg.DialogCallbacks#onNegative(int)
	 */
	@Override
	public void onNegative(int mode) {
	}
}
