/*
 * Translator Helper (TH)
 * Fco. Javier Domínguez Carral
 * TFC - UOC (2014)
 */
package com.ADApps.translatorhelper.parametres.preusunitaris;

import android.content.Intent;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.EditText;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Toast;
import android.widget.AdapterView.OnItemSelectedListener;

import com.ADApps.translatorhelper.main.Dialeg;
import com.ADApps.translatorhelper.main.THDataBaseHelper;
import com.ADApps.translatorhelper.parametres.tarifes.Tarifa;
import com.ADApps.translatorhelper.R;
import com.actionbarsherlock.app.SherlockFragment;
import com.actionbarsherlock.view.Menu;
import com.actionbarsherlock.view.MenuInflater;
import com.actionbarsherlock.view.MenuItem;


/**
 * The Class DetallsPreuUnitariFragment.
 */
public class DetallsPreuUnitariFragment extends SherlockFragment implements Dialeg.DialogCallbacks{
	
	/** The Constant ESBORRAR. */
	private static final int ESBORRAR = 1;
	
	/** The Constant MODIFICAR. */
	private static final int MODIFICAR = 2;
	
	/** The Constant INSERTAR. */
	private static final int INSERTAR = 3;
	
	/** The et nom preu unitari. */
	private EditText etNomPreuUnitari;
	
	/** The tv id preu unitari. */
	private TextView tvIDPreuUnitari;
	
	/** The sp tarifes. */
	private Spinner spTarifes;
	
	/** The sp conceptes. */
	private Spinner spConceptes;
	
	/** The et preu preu unitari. */
	private EditText etPreuPreuUnitari;
	
	/** The et unitats preu unitari. */
	private EditText etUnitatsPreuUnitari;
	
	/** The spinner adapter tarifes. */
	private ArrayAdapter<String> spinnerAdapterTarifes;
	
	/** The spinner adapter conceptes. */
	private ArrayAdapter<String> spinnerAdapterConceptes;
	
	/** The my menu. */
	private Menu myMenu;
	
	/** The db. */
	private static THDataBaseHelper db;

	/* (non-Javadoc)
	 * @see android.support.v4.app.Fragment#onCreate(android.os.Bundle)
	 */
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setHasOptionsMenu(true);
		db = new THDataBaseHelper(getActivity());
		db.open();
	}

	/* (non-Javadoc)
	 * @see android.support.v4.app.Fragment#onCreateView(android.view.LayoutInflater, android.view.ViewGroup, android.os.Bundle)
	 */
	@Override
	public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
		View view = inflater.inflate(R.layout.fragment_detalls_preu_unitari, container, false);
		return view;
	}
	
	/* (non-Javadoc)
	 * @see android.support.v4.app.Fragment#onActivityCreated(android.os.Bundle)
	 */
	@Override
	public void onActivityCreated(Bundle savedInstanceState) {
		super.onActivityCreated(savedInstanceState);
		Bundle extras = getActivity().getIntent().getExtras();
		etNomPreuUnitari = (EditText) getView().findViewById(R.id.txtDetallsPreuUnitariNom);
		tvIDPreuUnitari = (TextView) getView().findViewById(R.id.lblDetallsPreuUnitariID);
		spTarifes = (Spinner) getView().findViewById(R.id.spDetallsPreuUnitariTarifes);
		spConceptes = (Spinner) getView().findViewById(R.id.spDetallsPreuUnitariConceptes);
		etPreuPreuUnitari = (EditText) getView().findViewById(R.id.txtDPreuUnitariPreu);
		etUnitatsPreuUnitari = (EditText) getView().findViewById(R.id.txtDPreuUnitariUnitats);
		
		inicialitzarViews (extras);
	}
	
	/**
	 * Inicialitzar views.
	 *
	 * @param extras the extras
	 */
	public void inicialitzarViews(Bundle extras) {
		
		inicialitzarSpinnerConceptes();
		
		if (!extras.getBoolean("afegir")){
			PreuUnitari registre = (PreuUnitari)extras.getSerializable("registre");
			Tarifa tarifa = registre.getTarifa();
			etNomPreuUnitari.setText(registre.getNom());
			tvIDPreuUnitari.setText(Integer.toString(registre.getIdPreuUnitari()));
			spConceptes.setSelection(spinnerAdapterConceptes.getPosition(tarifa.getConcepte().getNom()));
			inicialitzarSpinnerTarifes(db.getIDConcepte(spConceptes.getSelectedItem().toString()));
			spTarifes.setSelection(spinnerAdapterTarifes.getPosition(tarifa.getNom()));
			etPreuPreuUnitari.setText(Float.toString(registre.getPreu()));
			etUnitatsPreuUnitari.setText(registre.getUnitat());
			
		}else {
			etNomPreuUnitari.setClickable(true);
			etNomPreuUnitari.setCursorVisible(true);
			etNomPreuUnitari.setFocusable(true);
			etNomPreuUnitari.setFocusableInTouchMode(true);
			etNomPreuUnitari.requestFocus();
			
			spConceptes.setClickable(true);
			spConceptes.setFocusable(true);
			
			spTarifes.setClickable(true);
			spTarifes.setFocusable(true);
			
			etPreuPreuUnitari.setClickable(true);
			etPreuPreuUnitari.setCursorVisible(true);
			etPreuPreuUnitari.setFocusable(true);
			etPreuPreuUnitari.setFocusableInTouchMode(true);
			
			etUnitatsPreuUnitari.setClickable(true);
			etUnitatsPreuUnitari.setCursorVisible(true);
			etUnitatsPreuUnitari.setFocusable(true);
			etUnitatsPreuUnitari.setFocusableInTouchMode(true);
		}		
	}
	
	/**
	 * Inicialitzar spinner conceptes.
	 */
	private void inicialitzarSpinnerConceptes() {
		spinnerAdapterConceptes = new ArrayAdapter<String> (getActivity().getBaseContext(), 
				android.R.layout.simple_spinner_item, db.getConceptesSpinner());
		
		spinnerAdapterConceptes.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
		
		spConceptes.setAdapter(spinnerAdapterConceptes);
		
		spConceptes.setOnItemSelectedListener(new OnItemSelectedListener(){
			@Override
	        public void onItemSelected(AdapterView<?> arg0, View arg1, int arg2, long arg3) {
				
				inicialitzarSpinnerTarifes(db.getIDConcepte(spConceptes.getItemAtPosition(arg2).toString()));
			}
			
			@Override
	        public void onNothingSelected(AdapterView<?> arg0) {
	        }
		});
	}

	/**
	 * Inicialitzar spinner tarifes.
	 *
	 * @param idConcepte the id concepte
	 */
	private void inicialitzarSpinnerTarifes(int idConcepte) {
		spinnerAdapterTarifes = new ArrayAdapter<String> (getActivity().getBaseContext(), 
				android.R.layout.simple_spinner_item, db.getTarifesSpinner(idConcepte));
		
		spinnerAdapterTarifes.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
		
		spTarifes.setAdapter(spinnerAdapterTarifes);
		
		spTarifes.setOnItemSelectedListener(new OnItemSelectedListener(){
			@Override
	        public void onItemSelected(AdapterView<?> arg0, View arg1,
	                int arg2, long arg3) {
			}
			
			@Override
	        public void onNothingSelected(AdapterView<?> arg0) {
	        }
		});
	}
	
	/* (non-Javadoc)
	 * @see com.actionbarsherlock.app.SherlockFragment#onCreateOptionsMenu(android.view.Menu, android.view.MenuInflater)
	 */
	@Override
    public void onCreateOptionsMenu(Menu menu, MenuInflater inflater) {
        inflater.inflate(R.menu.detall_parametre_fragment, menu);
        myMenu = menu;
        if (getActivity().getIntent().getExtras().getBoolean("afegir")) {
        	myMenu.findItem(R.id.menuLstParametresInsert).setVisible(true);
        	myMenu.findItem(R.id.menuLstParametresModificar).setVisible(false);
        	myMenu.findItem(R.id.menuLstParametresEliminar).setVisible(false);
        }
    }

    /* (non-Javadoc)
     * @see com.actionbarsherlock.app.SherlockFragment#onOptionsItemSelected(android.view.MenuItem)
     */
    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        switch (item.getItemId()) {
	        case android.R.id.home:
	        	db.close();
				Intent intent = new Intent(getActivity(), LlistaPreusUnitarisActivity.class);
	            intent.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP|Intent.FLAG_ACTIVITY_NEW_TASK);
	            startActivity(intent);
	            return true;
	        case R.id.menuLstParametresModificar:
	        	if (etNomPreuUnitari != null && spTarifes != null && etPreuPreuUnitari != null 
	        			&& etUnitatsPreuUnitari != null) {
	        		etNomPreuUnitari.setClickable(true);
	        		etNomPreuUnitari.setCursorVisible(true);
	        		etNomPreuUnitari.setFocusable(true);
	        		etNomPreuUnitari.setFocusableInTouchMode(true);
	        		etNomPreuUnitari.requestFocus();
	        		
	        		spConceptes.setClickable(true);
	        		spConceptes.setFocusable(true);
	        		
	        		spTarifes.setClickable(true);
	    			spTarifes.setFocusable(true);
	        		
	        		etPreuPreuUnitari.setClickable(true);
	    			etPreuPreuUnitari.setCursorVisible(true);
	    			etPreuPreuUnitari.setFocusable(true);
	    			etPreuPreuUnitari.setFocusableInTouchMode(true);
	    			
	    			etUnitatsPreuUnitari.setClickable(true);
	    			etUnitatsPreuUnitari.setCursorVisible(true);
	    			etUnitatsPreuUnitari.setFocusable(true);
	    			etUnitatsPreuUnitari.setFocusableInTouchMode(true);
	    			
	        	}else{
	        		Toast.makeText(getActivity().getApplicationContext(),"Error en modificar", 
			    			Toast.LENGTH_LONG).show();
	        	}
	        	myMenu.findItem(R.id.menuLstParametresUpdate).setVisible(true);
	        	myMenu.findItem(R.id.menuLstParametresModificar).setVisible(false);
	        	myMenu.findItem(R.id.menuLstParametresEliminar).setVisible(false);
	    		return true;
	    	case R.id.menuLstParametresEliminar:
	    		Dialeg dialegEliminar = Dialeg.newInstance((DetallsPreuUnitariFragment)
	    				getFragmentManager().findFragmentById(R.id.detallsPreuUnitariFragment), 
	    				"Eliminar preu unitari", "Segur que vol eliminar el preu unitari?", ESBORRAR);
	    		dialegEliminar.show(getFragmentManager(), "eliminar");
	    		return true;
	    	case R.id.menuLstParametresUpdate:
	    		String nomPreuUnitariUpdate = etNomPreuUnitari.getText().toString();
	    		String preuPreuUnitariUpdate = etPreuPreuUnitari.getText().toString();
	    		String unitatsPreuUnitariUpdate = etUnitatsPreuUnitari.getText().toString();
	    		int idTarifaUpdate = db.getIDTarifa(spTarifes.getSelectedItem().toString(), 
						db.getIDConcepte(spConceptes.getSelectedItem().toString()));
	    		
	    		if (nomPreuUnitariUpdate == null || nomPreuUnitariUpdate.isEmpty()) {
	    			Toast.makeText(getActivity().getApplicationContext(),"El camp nom no pot estar buit.", 
			    			Toast.LENGTH_LONG).show();
	    			return true;
	    		}
	    		
	    		if (preuPreuUnitariUpdate == null || preuPreuUnitariUpdate.isEmpty()) {
	    			Toast.makeText(getActivity().getApplicationContext(),"El camp preu no pot estar buit.", 
			    			Toast.LENGTH_LONG).show();
	    			return true;
	    		}
	    		
	    		if (unitatsPreuUnitariUpdate == null || unitatsPreuUnitariUpdate.isEmpty()) {
	    			Toast.makeText(getActivity().getApplicationContext(),"El camp unitats no pot estar buit.", 
			    			Toast.LENGTH_LONG).show();
	    			return true;
	    		}
				
    			if (db.getIDPreuUnitari(idTarifaUpdate, nomPreuUnitariUpdate, preuPreuUnitariUpdate, unitatsPreuUnitariUpdate) == -1){
	    			Dialeg dialegModificar = Dialeg.newInstance((DetallsPreuUnitariFragment)
		    				getFragmentManager().findFragmentById(R.id.detallsPreuUnitariFragment), 
		    				"Modificar preu unitari", "Segur que vol desar els canvis al preu unitari?", MODIFICAR);
		    		dialegModificar.show(getFragmentManager(), "modificar");
	    		}else {
	    			Toast.makeText(getActivity().getApplicationContext(),"El preu unitari ja existeix.", 
			    			Toast.LENGTH_LONG).show();
	    		}
	    		return true;
	    	case R.id.menuLstParametresInsert:
	    		String nomPreuUnitariInsert = etNomPreuUnitari.getText().toString();
	    		String preuPreuUnitariInsert = etPreuPreuUnitari.getText().toString();
	    		String unitatsPreuUnitariInsert = etUnitatsPreuUnitari.getText().toString();
	    		int idTarifaInsert = db.getIDTarifa(spTarifes.getSelectedItem().toString(), 
						db.getIDConcepte(spConceptes.getSelectedItem().toString()));
	    		
	    		if (nomPreuUnitariInsert == null || nomPreuUnitariInsert.isEmpty()) {
	    			Toast.makeText(getActivity().getApplicationContext(),"El camp nom no pot estar buit.", 
			    			Toast.LENGTH_LONG).show();
	    			return true;
	    		}
	    		
	    		if (preuPreuUnitariInsert == null || preuPreuUnitariInsert.isEmpty()) {
	    			Toast.makeText(getActivity().getApplicationContext(),"El camp preu no pot estar buit.", 
			    			Toast.LENGTH_LONG).show();
	    			return true;
	    		}
	    		
	    		if (unitatsPreuUnitariInsert == null || unitatsPreuUnitariInsert.isEmpty()) {
	    			Toast.makeText(getActivity().getApplicationContext(),"El camp unitats no pot estar buit.", 
			    			Toast.LENGTH_LONG).show();
	    			return true;
	    		}
	    		
	    		if (db.getIDPreuUnitari(idTarifaInsert, nomPreuUnitariInsert, preuPreuUnitariInsert, unitatsPreuUnitariInsert) == -1){
		    		Dialeg dialegAfegir = Dialeg.newInstance((DetallsPreuUnitariFragment)
		    				getFragmentManager().findFragmentById(R.id.detallsPreuUnitariFragment), 
		    				"Afegir preu unitari", "Segur que vol afegir el preu unitari?", INSERTAR);
		    		dialegAfegir.show(getFragmentManager(), "afegir");
	    		}else {
	    			Toast.makeText(getActivity().getApplicationContext(),"El preu unitari ja existeix.", 
			    			Toast.LENGTH_LONG).show();
	    		}
	    		return true;
			default:
				return super.onOptionsItemSelected(item);
        }
    }

    /* (non-Javadoc)
     * @see com.ADApps.translatorhelper.main.Dialeg.DialogCallbacks#onPositive(int)
     */
    @Override
	public void onPositive(int mode) {
	
		switch (mode){
			case ESBORRAR:
				if (db.deletePreuUnitari(Integer.parseInt(tvIDPreuUnitari.getText().toString()))) {
					db.close();
					Intent intent = new Intent(getActivity(), LlistaPreusUnitarisActivity.class);
		            intent.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP|Intent.FLAG_ACTIVITY_NEW_TASK);
		            startActivity(intent);
				}else {
					db.close();
					Toast.makeText(getActivity().getApplicationContext(),"Error en esborrar", 
			    			Toast.LENGTH_LONG).show();
				}
				break;
			case MODIFICAR:
				
				if (db.updatePreuUnitari(Integer.parseInt(tvIDPreuUnitari.getText().toString())
						, db.getIDTarifa(spTarifes.getSelectedItem().toString(),
								db.getIDConcepte(spConceptes.getSelectedItem().toString()))
						, etNomPreuUnitari.getText().toString()
						, etPreuPreuUnitari.getText().toString()
						, etUnitatsPreuUnitari.getText().toString())) {
					db.close();
					Intent intent = new Intent(getActivity(), LlistaPreusUnitarisActivity.class);
		            intent.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP|Intent.FLAG_ACTIVITY_NEW_TASK);
		            startActivity(intent);
				}else {
					db.close();
					Toast.makeText(getActivity().getApplicationContext(),"Error en modificar", 
			    			Toast.LENGTH_LONG).show();
				}
				break;
			case INSERTAR:
				
				if (db.insertPreuUnitari(
						db.getIDTarifa(spTarifes.getSelectedItem().toString(), 
								db.getIDConcepte(spConceptes.getSelectedItem().toString()))
						, etNomPreuUnitari.getText().toString()
						, etPreuPreuUnitari.getText().toString()
						, etUnitatsPreuUnitari.getText().toString())) {
					db.close();
					Intent intent = new Intent(getActivity(), LlistaPreusUnitarisActivity.class);
		            intent.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP|Intent.FLAG_ACTIVITY_NEW_TASK);
		            startActivity(intent);
				}else {
					db.close();
					Toast.makeText(getActivity().getApplicationContext(),"Error en insertar", 
			    			Toast.LENGTH_LONG).show();
				}
				break;
			default:
				break;
		}	
	}

	/* (non-Javadoc)
	 * @see com.ADApps.translatorhelper.main.Dialeg.DialogCallbacks#onNegative(int)
	 */
	@Override
	public void onNegative(int mode) {
	}
}
