/*
 * Translator Helper (TH)
 * Fco. Javier Domínguez Carral
 * TFC - UOC (2014)
 */
package com.ADApps.translatorhelper.parametres.preusunitaris;

import com.ADApps.translatorhelper.main.*;
import com.ADApps.translatorhelper.parametres.tarifes.Tarifa;


/**
 * The Class PreuUnitari.
 */
public class PreuUnitari extends Parametre{

	/** The Constant serialVersionUID. */
	private static final long serialVersionUID = 1L;
	
	/** The id preu unitari. */
	private int idPreuUnitari;
	
	/** The tarifa. */
	private Tarifa tarifa;
	
	/** The preu. */
	private float preu;
	
	/** The unitat. */
	private String unitat;
	
	/**
	 * Instantiates a new preu unitari.
	 *
	 * @param idPreuUnitari the id preu unitari
	 * @param tarifa the tarifa
	 * @param nom the nom
	 * @param preu the preu
	 * @param unitat the unitat
	 */
	public PreuUnitari(int idPreuUnitari, Tarifa tarifa, String nom, 
			float preu, String unitat) {
		super(nom);
		this.idPreuUnitari = idPreuUnitari;
		this.tarifa = tarifa;
		this.preu = preu;
		this.unitat = unitat;
	}

	/**
	 * Gets the tarifa.
	 *
	 * @return the tarifa
	 */
	public Tarifa getTarifa() {
		return tarifa;
	}

	/**
	 * Sets the tarifa.
	 *
	 * @param tarifa the new tarifa
	 */
	public void setTarifa(Tarifa tarifa) {
		this.tarifa = tarifa;
	}

	/**
	 * Gets the preu.
	 *
	 * @return the preu
	 */
	public float getPreu() {
		return preu;
	}

	/**
	 * Sets the preu.
	 *
	 * @param preu the new preu
	 */
	public void setPreu(float preu) {
		this.preu = preu;
	}

	/**
	 * Gets the unitat.
	 *
	 * @return the unitat
	 */
	public String getUnitat() {
		return unitat;
	}

	/**
	 * Sets the unitat.
	 *
	 * @param unitat the new unitat
	 */
	public void setUnitat(String unitat) {
		this.unitat = unitat;
	}

	/**
	 * Gets the id preu unitari.
	 *
	 * @return the id preu unitari
	 */
	public int getIdPreuUnitari() {
		return idPreuUnitari;
	}
}
