/*
 * Translator Helper (TH)
 * Fco. Javier Domínguez Carral
 * TFC - UOC (2014)
 */
package com.ADApps.translatorhelper.parametres.preusunitaris;

import com.ADApps.translatorhelper.parametres.tarifes.Tarifa;


/**
 * The Class PreuUnitariFac.
 */
public class PreuUnitariFac extends PreuUnitari{

	/** The Constant serialVersionUID. */
	private static final long serialVersionUID = 1L;
	
	/** The num unitats. */
	private int numUnitats;
	
	/** The import preu unitats. */
	private float importPreuUnitats;
		
	/**
	 * Instantiates a new preu unitari fac.
	 *
	 * @param nom the nom
	 * @param idPreuUnitari the id preu unitari
	 * @param tarifa the tarifa
	 * @param preu the preu
	 * @param unitat the unitat
	 * @param numUnitats the num unitats
	 * @param importPreuUnitats the import preu unitats
	 */
	public PreuUnitariFac(String nom, int idPreuUnitari, Tarifa tarifa,
			float preu, String unitat, int numUnitats,	float importPreuUnitats) {
		super(idPreuUnitari, tarifa, nom, preu, unitat);
		this.numUnitats = numUnitats;
		this.importPreuUnitats = importPreuUnitats;
	}

	/**
	 * Gets the num unitats.
	 *
	 * @return the num unitats
	 */
	public int getNumUnitats() {
		return numUnitats;
	}

	/**
	 * Sets the num unitats.
	 *
	 * @param numUnitats the new num unitats
	 */
	public void setNumUnitats(int numUnitats) {
		this.numUnitats = numUnitats;
	}

	/**
	 * Gets the import preu unitats.
	 *
	 * @return the import preu unitats
	 */
	public float getImportPreuUnitats() {
		return importPreuUnitats;
	}

	/**
	 * Sets the import preu unitats.
	 *
	 * @param importPreuUnitats the new import preu unitats
	 */
	public void setImportPreuUnitats(float importPreuUnitats) {
		this.importPreuUnitats = importPreuUnitats;
	}
}
