/*
 * Translator Helper (TH)
 * Fco. Javier Domínguez Carral
 * TFC - UOC (2014)
 */
package com.ADApps.translatorhelper.parametres.tarifes;

import android.content.Intent;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemSelectedListener;
import android.widget.ArrayAdapter;
import android.widget.EditText;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Toast;

import com.ADApps.translatorhelper.R;
import com.ADApps.translatorhelper.main.Dialeg;
import com.ADApps.translatorhelper.main.THDataBaseHelper;
import com.actionbarsherlock.app.SherlockFragment;
import com.actionbarsherlock.view.Menu;
import com.actionbarsherlock.view.MenuInflater;
import com.actionbarsherlock.view.MenuItem;


/**
 * The Class DetallsTarifaFragment.
 */
public class DetallsTarifaFragment extends SherlockFragment implements Dialeg.DialogCallbacks{
	
	/** The Constant ESBORRAR. */
	private static final int ESBORRAR = 1;
	
	/** The Constant MODIFICAR. */
	private static final int MODIFICAR = 2;
	
	/** The Constant INSERTAR. */
	private static final int INSERTAR = 3;
	
	/** The et nom tarifa. */
	private EditText etNomTarifa;
	
	/** The tv id tarifa. */
	private TextView tvIDTarifa;
	
	/** The et concepte. */
	private EditText etConcepte;
	
	/** The sp conceptes. */
	private Spinner spConceptes;
	
	/** The spinner adapter. */
	ArrayAdapter<String> spinnerAdapter;
	
	/** The my menu. */
	private Menu myMenu;
	
	/** The db. */
	private static THDataBaseHelper db;
	
	/* (non-Javadoc)
	 * @see android.support.v4.app.Fragment#onCreate(android.os.Bundle)
	 */
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setHasOptionsMenu(true);
		db = new THDataBaseHelper(getActivity());
		db.open();
	}

	/* (non-Javadoc)
	 * @see android.support.v4.app.Fragment#onCreateView(android.view.LayoutInflater, android.view.ViewGroup, android.os.Bundle)
	 */
	@Override
	public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
		View view = inflater.inflate(R.layout.fragment_detalls_tarifa, container, false);
		return view;
	}
	
	/* (non-Javadoc)
	 * @see android.support.v4.app.Fragment#onActivityCreated(android.os.Bundle)
	 */
	@Override
	public void onActivityCreated(Bundle savedInstanceState) {
		super.onActivityCreated(savedInstanceState);
		Bundle extras = getActivity().getIntent().getExtras();
		etNomTarifa = (EditText) getView().findViewById(R.id.txtDetallsTarifaNom);
		tvIDTarifa = (TextView) getView().findViewById(R.id.lblDetallsTarifaID);
		etConcepte = (EditText) getView().findViewById(R.id.txtDTarifaConcepteSeleccionat);
		spConceptes = (Spinner) getView().findViewById(R.id.spDetallsTarifaConceptes);
		
		inicialitzarViews (extras);
	}
	
	/**
	 * Inicialitzar views.
	 *
	 * @param extras the extras
	 */
	public void inicialitzarViews(Bundle extras) {
		
		inicialitzarSpinner();
		
		if (!extras.getBoolean("afegir")){
			Tarifa registre = (Tarifa)extras.getSerializable("registre");
			String nom = db.getConcepte(registre.getConcepte().getidConcepte()).getNom();
			etNomTarifa.setText(registre.getNom());
			tvIDTarifa.setText(Integer.toString(registre.getIdTarifa()));
			spConceptes.setSelection(spinnerAdapter.getPosition(nom));
			spConceptes.setVisibility(View.GONE);
			etConcepte.setText(nom);
			
		}else {
			etNomTarifa.setClickable(true);
			etNomTarifa.setCursorVisible(true);
			etNomTarifa.setFocusable(true);
			etNomTarifa.setFocusableInTouchMode(true);
			etNomTarifa.requestFocus();
			
			etConcepte.setVisibility(View.GONE);
		}		
	}
	
	/**
	 * Inicialitzar spinner.
	 */
	private void inicialitzarSpinner() {
		spinnerAdapter = new ArrayAdapter<String> (getActivity().getBaseContext(), 
				android.R.layout.simple_spinner_item, db.getConceptesSpinner());
		
		spinnerAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
		
		spConceptes.setAdapter(spinnerAdapter);
		
		spConceptes.setOnItemSelectedListener(new OnItemSelectedListener(){
			@Override
            public void onItemSelected(AdapterView<?> arg0, View arg1,
                    int arg2, long arg3) {
			}
			
			@Override
            public void onNothingSelected(AdapterView<?> arg0) {
            }
		});
	}
	
	/* (non-Javadoc)
	 * @see com.actionbarsherlock.app.SherlockFragment#onCreateOptionsMenu(android.view.Menu, android.view.MenuInflater)
	 */
	@Override
    public void onCreateOptionsMenu(Menu menu, MenuInflater inflater) {
        inflater.inflate(R.menu.detall_parametre_fragment, menu);
        myMenu = menu;
        if (getActivity().getIntent().getExtras().getBoolean("afegir")) {
        	myMenu.findItem(R.id.menuLstParametresInsert).setVisible(true);
        	myMenu.findItem(R.id.menuLstParametresModificar).setVisible(false);
        	myMenu.findItem(R.id.menuLstParametresEliminar).setVisible(false);
        }
    }

    /* (non-Javadoc)
     * @see com.actionbarsherlock.app.SherlockFragment#onOptionsItemSelected(android.view.MenuItem)
     */
    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        switch (item.getItemId()) {
	        case android.R.id.home:
	        	db.close();
				Intent intent = new Intent(getActivity(), LlistaTarifesActivity.class);
	            intent.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP|Intent.FLAG_ACTIVITY_NEW_TASK);
	            startActivity(intent);
	            return true;
	        case R.id.menuLstParametresModificar:
	        	if (etNomTarifa != null && spConceptes != null) {
	        		etNomTarifa.setClickable(true);
	        		etNomTarifa.setCursorVisible(true);
	        		etNomTarifa.setFocusable(true);
	        		etNomTarifa.setFocusableInTouchMode(true);
	        		etNomTarifa.requestFocus();
	        		
	        		etConcepte.setVisibility(View.GONE);
	        		
	        		spConceptes.setVisibility(View.VISIBLE);
	        	}else{
	        		Toast.makeText(getActivity().getApplicationContext(),"Error en modificar", 
			    			Toast.LENGTH_LONG).show();
	        	}
	        	myMenu.findItem(R.id.menuLstParametresUpdate).setVisible(true);
	        	myMenu.findItem(R.id.menuLstParametresModificar).setVisible(false);
	        	myMenu.findItem(R.id.menuLstParametresEliminar).setVisible(false);
	    		return true;
	    	case R.id.menuLstParametresEliminar:
	    		if (db.isTarifaReferenced(Integer.parseInt(tvIDTarifa.getText().toString()))){
		    		Dialeg dialegEliminar = Dialeg.newInstance((DetallsTarifaFragment)
		    				getFragmentManager().findFragmentById(R.id.detallsTarifaFragment), 
		    				"Eliminar tarifa", "Segur que vol eliminar la tarifa?", ESBORRAR);
		    		dialegEliminar.show(getFragmentManager(), "eliminar");
	    		}else {
					Toast.makeText(getActivity().getApplicationContext()
,
						"IMPOSIBLE ESBORRAR: La tarifa està referenciada per un preu unitari."
							,Toast.LENGTH_LONG).show();
				}
	    		return true;
	    	case R.id.menuLstParametresUpdate:
	    		String stringUpdate = etNomTarifa.getText().toString();
	    		if (stringUpdate == null || stringUpdate.isEmpty()) {
	    			Toast.makeText(getActivity().getApplicationContext(),"El camp nom no pot estar buit.", 
			    			Toast.LENGTH_LONG).show();
	    		}else	if (db.getIDTarifa(stringUpdate
	    						, db.getIDConcepte(spConceptes.getSelectedItem().toString())) == -1){
			    			Dialeg dialegModificar = Dialeg.newInstance((DetallsTarifaFragment)
				    				getFragmentManager().findFragmentById(R.id.detallsTarifaFragment), 
				    				"Modificar tarifa", "Segur que vol desar els canvis a la tarifa?", MODIFICAR);
				    		dialegModificar.show(getFragmentManager(), "modificar");
			    		}else {
			    			Toast.makeText(getActivity().getApplicationContext(),"La tarifa ja existeix.", 
					    			Toast.LENGTH_LONG).show();
			    		}
	    		return true;
	    	case R.id.menuLstParametresInsert:
	    		String stringInsert = etNomTarifa.getText().toString();
	    		int idConcepte = db.getIDConcepte(spConceptes.getSelectedItem().toString());
	    		
	    		if (stringInsert == null || stringInsert.isEmpty()) {
	    			Toast.makeText(getActivity().getApplicationContext(),"El camp nom no pot estar buit.", 
			    			Toast.LENGTH_LONG).show();
	    		}else 	if (db.getIDTarifa(stringInsert, idConcepte) == -1){
				    		Dialeg dialegAfegir = Dialeg.newInstance((DetallsTarifaFragment)
				    				getFragmentManager().findFragmentById(R.id.detallsTarifaFragment), 
				    				"Afegir tarifa", "Segur que vol afegir la tarifa?", INSERTAR);
				    		dialegAfegir.show(getFragmentManager(), "afegir");
			    		}else {
			    			Toast.makeText(getActivity().getApplicationContext(),"La tarifa ja existeix.", 
					    			Toast.LENGTH_LONG).show();
			    		}
	    		return true;
			default:
				return super.onOptionsItemSelected(item);
        }
    }

	/* (non-Javadoc)
	 * @see com.ADApps.translatorhelper.main.Dialeg.DialogCallbacks#onPositive(int)
	 */
	@Override
	public void onPositive(int mode) {
	
		switch (mode){
			case ESBORRAR:
				if (db.deleteTarifa(Integer.parseInt(tvIDTarifa.getText().toString()))) {
					db.close();
					Intent intent = new Intent(getActivity(), LlistaTarifesActivity.class);
		            intent.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP|Intent.FLAG_ACTIVITY_NEW_TASK);
		            startActivity(intent);
				}else {
					db.close();
					Toast.makeText(getActivity().getApplicationContext(),"Error en esborrar", 
			    			Toast.LENGTH_LONG).show();
				}
				break;
			case MODIFICAR:				
				if (db.updateTarifa(Integer.parseInt(tvIDTarifa.getText().toString())
						, etNomTarifa.getText().toString()
						, db.getIDConcepte(spConceptes.getSelectedItem().toString()))) {
					db.close();
					Intent intent = new Intent(getActivity(), LlistaTarifesActivity.class);
		            intent.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP|Intent.FLAG_ACTIVITY_NEW_TASK);
		            startActivity(intent);
				}else {
					db.close();
					Toast.makeText(getActivity().getApplicationContext(),"Error en modificar", 
			    			Toast.LENGTH_LONG).show();
				}
				break;
			case INSERTAR:
				if (db.insertTarifa(etNomTarifa.getText().toString()
						, db.getIDConcepte(spConceptes.getSelectedItem().toString()))) {
					db.close();
					Intent intent = new Intent(getActivity(), LlistaTarifesActivity.class);
		            intent.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP|Intent.FLAG_ACTIVITY_NEW_TASK);
		            startActivity(intent);
				}else {
					db.close();
					Toast.makeText(getActivity().getApplicationContext(),"Error en insertar", 
			    			Toast.LENGTH_LONG).show();
				}
				break;
			default:
				break;
		}	
	}

	/* (non-Javadoc)
	 * @see com.ADApps.translatorhelper.main.Dialeg.DialogCallbacks#onNegative(int)
	 */
	@Override
	public void onNegative(int mode) {
	}
}

