/*
 * Translator Helper (TH)
 * Fco. Javier Domínguez Carral
 * TFC - UOC (2014)
 */
package com.ADApps.translatorhelper.parametres.tarifes;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.ListView;
import android.widget.TextView;

import com.ADApps.translatorhelper.main.MainParametres;
import com.ADApps.translatorhelper.main.THDataBaseHelper;
import com.ADApps.translatorhelper.R;
import com.actionbarsherlock.app.SherlockListFragment;
import com.actionbarsherlock.view.Menu;
import com.actionbarsherlock.view.MenuInflater;
import com.actionbarsherlock.view.MenuItem;


/**
 * The Class LlistaTarifesFragment.
 */
public class LlistaTarifesFragment extends SherlockListFragment{
	
	/** The db. */
	private static THDataBaseHelper db;
	
	/** The list items. */
	private Tarifa[] listItems;

	/* (non-Javadoc)
	 * @see android.support.v4.app.Fragment#onCreate(android.os.Bundle)
	 */
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setHasOptionsMenu(true);
		db = new THDataBaseHelper(getActivity());
		db.open();
		
		listItems = (Tarifa[]) db.getTarifes().toArray(new Tarifa[0]);
	}
	
	/* (non-Javadoc)
	 * @see android.support.v4.app.ListFragment#onCreateView(android.view.LayoutInflater, android.view.ViewGroup, android.os.Bundle)
	 */
	@Override
	public View onCreateView(LayoutInflater inflater, ViewGroup container,
			Bundle savedInstanceState) {
		return inflater.inflate(R.layout.fragment_llista, container, false);
	}
	
	/* (non-Javadoc)
	 * @see android.support.v4.app.Fragment#onActivityCreated(android.os.Bundle)
	 */
	@Override
	public void onActivityCreated(Bundle savedInstanceState) {
		super.onActivityCreated(savedInstanceState);
		
		setListAdapter(new AdaptadorTarifes(this));
		
		if (listItems.length == 0)
			((TextView) getView().findViewById(android.R.id.empty)).setText("No hi ha tarifes per mostrar.");
	}
	
	/**
	 * The Class AdaptadorTarifes.
	 */
	class AdaptadorTarifes extends ArrayAdapter<Tarifa> {
		
		/** The context. */
		Activity context;
		
		/**
		 * Instantiates a new adaptador tarifes.
		 *
		 * @param context the context
		 */
		AdaptadorTarifes (SherlockListFragment context) {
			super(context.getActivity(), R.layout.listitem_tarifa, listItems);
			this.context = context.getActivity();
		}
		
		/* (non-Javadoc)
		 * @see android.widget.ArrayAdapter#getView(int, android.view.View, android.view.ViewGroup)
		 */
		public View getView(int position, View convertView, ViewGroup parent) {
			LayoutInflater inflater = context.getLayoutInflater();
			View item = inflater.inflate(R.layout.listitem_tarifa, null);
			
			TextView lblNomLITarifa = (TextView)item.findViewById(R.id.lblNomLITarifa);
			lblNomLITarifa.setText(listItems[position].getNom());
			
			TextView lblConcepteLITarifa = (TextView)item.findViewById(R.id.lblConcepteLITarifa);
			lblConcepteLITarifa.setText((db.getConcepte(listItems[position].getConcepte().getidConcepte())).getNom());
			
			return item;
		}
	}
	
	/* (non-Javadoc)
	 * @see android.support.v4.app.ListFragment#onListItemClick(android.widget.ListView, android.view.View, int, long)
	 */
	@Override
	public void onListItemClick(ListView l, View v, int position, long id) {
		Tarifa registre = (Tarifa) getListAdapter().getItem(position);
		
		Intent intent = new Intent(getActivity().getBaseContext(), DetallsTarifaActivity.class);
		intent.putExtra("afegir", false);
		intent.putExtra("registre", registre);
		startActivity(intent);
	}
	
	/* (non-Javadoc)
	 * @see com.actionbarsherlock.app.SherlockListFragment#onCreateOptionsMenu(android.view.Menu, android.view.MenuInflater)
	 */
	@Override
	public void onCreateOptionsMenu(Menu menu, MenuInflater inflater) {
		inflater.inflate(R.menu.llista_parametres, menu);
	}
	
	/* (non-Javadoc)
	 * @see com.actionbarsherlock.app.SherlockListFragment#onOptionsItemSelected(android.view.MenuItem)
	 */
	@Override
    public boolean onOptionsItemSelected(MenuItem item) {
		Intent intent;
		switch (item.getItemId()) {
			case android.R.id.home:
				db.close();
	            intent = new Intent(getActivity(), MainParametres.class);
	            intent.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP|Intent.FLAG_ACTIVITY_NEW_TASK);
	            startActivity(intent);
	            return true;
			case R.id.menuLstParametresAfegir:
				db.close();
				intent = new Intent(getActivity().getBaseContext(), DetallsTarifaActivity.class);
				intent.putExtra("afegir", true);
				startActivity(intent);
	            return true;
			default:
				return super.onOptionsItemSelected(item);
        }
    }	
}

