/*
 * Translator Helper (TH)
 * Fco. Javier Domínguez Carral
 * TFC - UOC (2014)
 */
package com.ADApps.translatorhelper.parametres.tarifes;

import com.ADApps.translatorhelper.main.*;
import com.ADApps.translatorhelper.parametres.conceptes.Concepte;


/**
 * The Class Tarifa.
 */
public class Tarifa extends Parametre{

	/** The Constant serialVersionUID. */
	private static final long serialVersionUID = 1L;
	
	/** The id tarifa. */
	private int idTarifa;
	
	/** The concepte. */
	private Concepte concepte;
	
	/**
	 * Instantiates a new tarifa.
	 *
	 * @param idTarifa the id tarifa
	 * @param nom the nom
	 * @param concepte the concepte
	 */
	public Tarifa(int idTarifa, String nom, Concepte concepte) {
		super(nom);
		this.idTarifa = idTarifa;
		this.concepte = concepte;
	}
	
	/**
	 * Gets the concepte.
	 *
	 * @return the concepte
	 */
	public Concepte getConcepte() {
		return concepte;
	}
	
	/**
	 * Sets the concepte.
	 *
	 * @param concepte the new concepte
	 */
	public void setConcepte(Concepte concepte) {
		this.concepte = concepte;
	}
	
	/**
	 * Gets the id tarifa.
	 *
	 * @return the id tarifa
	 */
	public int getIdTarifa() {
		return idTarifa;
	}
}
