/*
 * Translator Helper (TH)
 * Fco. Javier Domínguez Carral
 * TFC - UOC (2014)
 */
package com.ADApps.translatorhelper.parametres.variables;

import android.content.Intent;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.EditText;
import android.widget.RadioButton;
import android.widget.RadioGroup;
import android.widget.TextView;
import android.widget.Toast;

import com.ADApps.translatorhelper.R;
import com.ADApps.translatorhelper.main.Dialeg;
import com.ADApps.translatorhelper.main.THDataBaseHelper;
import com.actionbarsherlock.app.SherlockFragment;
import com.actionbarsherlock.view.Menu;
import com.actionbarsherlock.view.MenuInflater;
import com.actionbarsherlock.view.MenuItem;


/**
 * The Class DetallsVariableFragment.
 */
public class DetallsVariableFragment extends SherlockFragment implements Dialeg.DialogCallbacks{
	
	/** The Constant ESBORRAR. */
	private static final int ESBORRAR = 1;
	
	/** The Constant MODIFICAR. */
	private static final int MODIFICAR = 2;
	
	/** The Constant INSERTAR. */
	private static final int INSERTAR = 3;
	
	/** The Constant TIPUS_PERCENTATGE. */
	private static final int TIPUS_PERCENTATGE = 1;
	
	/** The Constant TIPUS_SUMA. */
	private static final int TIPUS_SUMA = 2;
	
	/** The et nom variable. */
	private EditText etNomVariable;
	
	/** The tv id variable. */
	private TextView tvIDVariable;
	
	/** The et valor variable. */
	private EditText etValorVariable;
	
	/** The rg tipus variable. */
	private RadioGroup rgTipusVariable;
	
	/** The r percentatge. */
	private RadioButton rPercentatge;
	
	/** The r suma. */
	private RadioButton rSuma;
	
	/** The my menu. */
	private Menu myMenu;
	
	/** The db. */
	private static THDataBaseHelper db;

	/* (non-Javadoc)
	 * @see android.support.v4.app.Fragment#onCreate(android.os.Bundle)
	 */
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setHasOptionsMenu(true);
		db = new THDataBaseHelper(getActivity());
		db.open();
	}

	/* (non-Javadoc)
	 * @see android.support.v4.app.Fragment#onCreateView(android.view.LayoutInflater, android.view.ViewGroup, android.os.Bundle)
	 */
	@Override
	public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
		View view = inflater.inflate(R.layout.fragment_detalls_variable, container, false);
		return view;
	}
	
	/* (non-Javadoc)
	 * @see android.support.v4.app.Fragment#onActivityCreated(android.os.Bundle)
	 */
	@Override
	public void onActivityCreated(Bundle savedInstanceState) {
		super.onActivityCreated(savedInstanceState);
		Bundle extras = getActivity().getIntent().getExtras();
		etNomVariable = (EditText) getView().findViewById(R.id.txtDetallsVariablenom);
		tvIDVariable = (TextView) getView().findViewById(R.id.lblDetallsVariableID);
		etValorVariable = (EditText) getView().findViewById(R.id.txtDetallsVariableValor);
		rgTipusVariable = (RadioGroup) getView().findViewById(R.id.rgDetallsVariableTipus);
		rPercentatge = (RadioButton) getView().findViewById(R.id.rTipusPercentatge);
		rSuma = (RadioButton) getView().findViewById(R.id.rTipusSuma);
		
		inicialitzarViews (extras);
	}
	
	/**
	 * Inicialitzar views.
	 *
	 * @param extras the extras
	 */
	public void inicialitzarViews(Bundle extras) {
		
		if (!extras.getBoolean("afegir")){
			Variable registre = (Variable)extras.getSerializable("registre");
			etNomVariable.setText(registre.getNom());
			tvIDVariable.setText(Integer.toString(registre.getIdVariable()));
			etValorVariable.setText(Float.toString(registre.getValor()));
			
			switch (registre.getTipusOperacio()) {
			case TIPUS_PERCENTATGE:
				rPercentatge.setChecked(true);
				break;
			case TIPUS_SUMA:
				rSuma.setChecked(true);
				break;
			default:
				break;
			}
			
		}else {
			etNomVariable.setClickable(true);
			etNomVariable.setCursorVisible(true);
			etNomVariable.setFocusable(true);
			etNomVariable.setFocusableInTouchMode(true);
			etNomVariable.requestFocus();
			
			etValorVariable.setClickable(true);
			etValorVariable.setCursorVisible(true);
			etValorVariable.setFocusable(true);
			etValorVariable.setFocusableInTouchMode(true);
			
			rPercentatge.setClickable(true);
			rSuma.setClickable(true);
		}		
	}

	/* (non-Javadoc)
	 * @see com.actionbarsherlock.app.SherlockFragment#onCreateOptionsMenu(android.view.Menu, android.view.MenuInflater)
	 */
	@Override
	public void onCreateOptionsMenu(Menu menu, MenuInflater inflater) {
	    inflater.inflate(R.menu.detall_parametre_fragment, menu);
	    myMenu = menu;
	    if (getActivity().getIntent().getExtras().getBoolean("afegir")) {
	    	myMenu.findItem(R.id.menuLstParametresInsert).setVisible(true);
	    	myMenu.findItem(R.id.menuLstParametresModificar).setVisible(false);
	    	myMenu.findItem(R.id.menuLstParametresEliminar).setVisible(false);
	    }
	}
	
	/* (non-Javadoc)
	 * @see com.actionbarsherlock.app.SherlockFragment#onOptionsItemSelected(android.view.MenuItem)
	 */
	@Override
    public boolean onOptionsItemSelected(MenuItem item) {
        switch (item.getItemId()) {
	        case android.R.id.home:
	        	db.close();
				Intent intent = new Intent(getActivity(), LlistaVariablesActivity.class);
	            intent.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP|Intent.FLAG_ACTIVITY_NEW_TASK);
	            startActivity(intent);
	            return true;
	        case R.id.menuLstParametresModificar:
	        	if (etNomVariable != null && etValorVariable != null 
	        	&& rgTipusVariable.getCheckedRadioButtonId() != -1) {
	        		etNomVariable.setClickable(true);
	    			etNomVariable.setCursorVisible(true);
	    			etNomVariable.setFocusable(true);
	    			etNomVariable.setFocusableInTouchMode(true);
	    			etNomVariable.requestFocus();
	    			
	    			etValorVariable.setClickable(true);
	    			etValorVariable.setCursorVisible(true);
	    			etValorVariable.setFocusable(true);
	    			etValorVariable.setFocusableInTouchMode(true);
	    			
	    			rPercentatge.setClickable(true);
	    			rSuma.setClickable(true);
	    			
	        	}else{
	        		Toast.makeText(getActivity().getApplicationContext(),"Error en modificar", 
			    			Toast.LENGTH_LONG).show();
	        	}
	        	myMenu.findItem(R.id.menuLstParametresUpdate).setVisible(true);
	        	myMenu.findItem(R.id.menuLstParametresModificar).setVisible(false);
	        	myMenu.findItem(R.id.menuLstParametresEliminar).setVisible(false);
	    		return true;
	    	case R.id.menuLstParametresEliminar:
	    		Dialeg dialegEliminar = Dialeg.newInstance((DetallsVariableFragment)
	    				getFragmentManager().findFragmentById(R.id.detallsVariableFragment), 
	    				"Eliminar variable", "Segur que vol eliminar la variable?", ESBORRAR);
	    		dialegEliminar.show(getFragmentManager(), "eliminar");
	    		return true;
	    	case R.id.menuLstParametresUpdate:
	    		String nomVariableUpdate = etNomVariable.getText().toString();
	    		String valorVariableUpdate = etValorVariable.getText().toString();
	    		int tipoVariable = (rPercentatge.isChecked()) ? TIPUS_PERCENTATGE : TIPUS_SUMA;
	    		
	    		if (nomVariableUpdate == null || nomVariableUpdate.isEmpty()) {
	    			Toast.makeText(getActivity().getApplicationContext(),"El camp nom no pot estar buit.", 
			    			Toast.LENGTH_LONG).show();
	    			return true;
	    		}
	    		
	    		if (valorVariableUpdate == null || valorVariableUpdate.isEmpty()) {
	    			Toast.makeText(getActivity().getApplicationContext(),"El camp valor no pot estar buit.", 
			    			Toast.LENGTH_LONG).show();
	    			return true;
	    		}
	    		
    			if (db.getIDVariable(nomVariableUpdate, valorVariableUpdate, tipoVariable) == -1){
	    			Dialeg dialegModificar = Dialeg.newInstance((DetallsVariableFragment)
		    				getFragmentManager().findFragmentById(R.id.detallsVariableFragment), 
		    				"Modificar variable", "Segur que vol desar els canvis a la variable?", MODIFICAR);
		    		dialegModificar.show(getFragmentManager(), "modificar");
	    		}else {
	    			Toast.makeText(getActivity().getApplicationContext(),"La variable ja existeix.", 
			    			Toast.LENGTH_LONG).show();
	    		}
	    		return true;
	    	case R.id.menuLstParametresInsert:
	    		String nomVariableInsert = etNomVariable.getText().toString();
	    		String valorVariableInsert = etValorVariable.getText().toString();
	    		
	    		if (nomVariableInsert == null || nomVariableInsert.isEmpty()) {
	    			Toast.makeText(getActivity().getApplicationContext(),"El camp nom no pot estar buit.", 
			    			Toast.LENGTH_LONG).show();
	    			return true;
	    		}
	    		
	    		if (valorVariableInsert == null || valorVariableInsert.isEmpty()) {
	    			Toast.makeText(getActivity().getApplicationContext(),"El camp valor no pot estar buit.", 
			    			Toast.LENGTH_LONG).show();
	    			return true;
	    		}
	    		
	    		if (rgTipusVariable.getCheckedRadioButtonId() == -1) {
				Toast.makeText(getActivity().getApplicationContext(),
						"S'ha d'escollir un tipus d'operació.",
			    			Toast.LENGTH_LONG).show();
	    			return true;
	    		}
	    		
	    		if (db.getIDVariable(nomVariableInsert) == -1){
		    		Dialeg dialegAfegir = Dialeg.newInstance((DetallsVariableFragment)
		    				getFragmentManager().findFragmentById(R.id.detallsVariableFragment), 
		    				"Afegir variable", "Segur que vol afegir la variable?", INSERTAR);
		    		dialegAfegir.show(getFragmentManager(), "afegir");
	    		}else {
	    			Toast.makeText(getActivity().getApplicationContext(),"La variable ja existeix.", 
			    			Toast.LENGTH_LONG).show();
	    		}
	    		return true;
			default:
				return super.onOptionsItemSelected(item);
        }
    }

	/* (non-Javadoc)
	 * @see com.ADApps.translatorhelper.main.Dialeg.DialogCallbacks#onPositive(int)
	 */
	@Override
	public void onPositive(int mode) {
	
		switch (mode){
			case ESBORRAR:
				if (db.deleteVariable(Integer.parseInt(tvIDVariable.getText().toString()))) {
					db.close();
					Intent intent = new Intent(getActivity(), LlistaVariablesActivity.class);
		            intent.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP|Intent.FLAG_ACTIVITY_NEW_TASK);
		            startActivity(intent);
				}else {
					db.close();
					Toast.makeText(getActivity().getApplicationContext(),"Error en esborrar", 
			    			Toast.LENGTH_LONG).show();
				}
				break;
			case MODIFICAR:
				int tipoVariableUpdate = (rPercentatge.isChecked()) ? TIPUS_PERCENTATGE : TIPUS_SUMA; 
				if (db.updateVariable(Integer.parseInt(tvIDVariable.getText().toString())
						, etNomVariable.getText().toString()
						, etValorVariable.getText().toString()
						, tipoVariableUpdate)) {
					db.close();
					Intent intent = new Intent(getActivity(), LlistaVariablesActivity.class);
		            intent.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP|Intent.FLAG_ACTIVITY_NEW_TASK);
		            startActivity(intent);
				}else {
					db.close();
					Toast.makeText(getActivity().getApplicationContext(),"Error en modificar", 
			    			Toast.LENGTH_LONG).show();
				}
				break;
			case INSERTAR:
				int tipoVariableInsert = (rPercentatge.isChecked()) ? 1 : 2;
				if (db.insertVariable(etNomVariable.getText().toString()
						, etValorVariable.getText().toString()
						, tipoVariableInsert)) {
					db.close();
					Intent intent = new Intent(getActivity(), LlistaVariablesActivity.class);
		            intent.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP|Intent.FLAG_ACTIVITY_NEW_TASK);
		            startActivity(intent);
				}else {
					db.close();
					Toast.makeText(getActivity().getApplicationContext(),"Error en insertar", 
			    			Toast.LENGTH_LONG).show();
				}
				break;
			default:
				break;
		}	
	}

	/* (non-Javadoc)
	 * @see com.ADApps.translatorhelper.main.Dialeg.DialogCallbacks#onNegative(int)
	 */
	@Override
	public void onNegative(int mode) {
	}
}

