/*
 * Translator Helper (TH)
 * Fco. Javier Domínguez Carral
 * TFC - UOC (2014)
 */
package com.ADApps.translatorhelper.parametres.variables;

import com.ADApps.translatorhelper.main.*;


/**
 * The Class Variable.
 */
public class Variable extends Parametre{

	/** The Constant serialVersionUID. */
	private static final long serialVersionUID = 1L;
	
	/** The id variable. */
	private int idVariable;
	
	/** The valor. */
	private float valor;
	
	/** The tipus operacio. */
	private int tipusOperacio;
	
	/**
	 * Instantiates a new variable.
	 *
	 * @param idVariable the id variable
	 * @param nom the nom
	 * @param valor the valor
	 * @param tipusOperacio the tipus operacio
	 */
	public Variable(int idVariable, String nom, float valor, int tipusOperacio) {
		super(nom);
		this.idVariable = idVariable;
		this.valor = valor;
		this.tipusOperacio = tipusOperacio;
	}
	
	/**
	 * Gets the valor.
	 *
	 * @return the valor
	 */
	public float getValor() {
		return valor;
	}
	
	/**
	 * Sets the valor.
	 *
	 * @param valor the new valor
	 */
	public void setValor(float valor) {
		this.valor = valor;
	}
	
	/**
	 * Gets the tipus operacio.
	 *
	 * @return the tipus operacio
	 */
	public int getTipusOperacio() {
		return tipusOperacio;
	}
	
	/**
	 * Sets the tipus operacio.
	 *
	 * @param tipusOperacio the new tipus operacio
	 */
	public void setTipusOperacio(int tipusOperacio) {
		this.tipusOperacio = tipusOperacio;
	}
	
	/**
	 * Gets the id variable.
	 *
	 * @return the id variable
	 */
	public int getIdVariable() {
		return idVariable;
	}
}
