/*
 * Translator Helper (TH)
 * Fco. Javier Domínguez Carral
 * TFC - UOC (2014)
 */
package com.ADApps.translatorhelper.pressupostos;

import harmony.java.awt.Color;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;

import android.app.Dialog;
import android.content.Intent;
import android.net.Uri;
import android.os.Bundle;
import android.os.Environment;
import android.view.Gravity;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemSelectedListener;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.DatePicker;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.Spinner;
import android.widget.TableLayout;
import android.widget.TableRow;
import android.widget.TableRow.LayoutParams;
import android.widget.TextView;
import android.widget.Toast;

import com.ADApps.translatorhelper.R;
import com.ADApps.translatorhelper.main.Dialeg;
import com.ADApps.translatorhelper.main.THDataBaseHelper;
import com.ADApps.translatorhelper.parametres.impostos.Impost;
import com.ADApps.translatorhelper.parametres.impostos.ImpostFac;
import com.ADApps.translatorhelper.parametres.preusunitaris.PreuUnitari;
import com.ADApps.translatorhelper.parametres.preusunitaris.PreuUnitariFac;
import com.ADApps.translatorhelper.parametres.tarifes.Tarifa;
import com.ADApps.translatorhelper.parametres.variables.Variable;
import com.ADApps.translatorhelper.parametres.variables.VariableFac;
import com.ADApps.translatorhelper.projectes.Projecte;
import com.actionbarsherlock.app.SherlockFragment;
import com.actionbarsherlock.view.Menu;
import com.actionbarsherlock.view.MenuInflater;
import com.actionbarsherlock.view.MenuItem;
import com.lowagie.text.Document;
import com.lowagie.text.DocumentException;
import com.lowagie.text.Font;
import com.lowagie.text.FontFactory;
import com.lowagie.text.Paragraph;
import com.lowagie.text.pdf.PdfPTable;
import com.lowagie.text.pdf.PdfWriter;


/**
 * The Class DetallsPressupostFragment.
 */
public class DetallsPressupostFragment extends SherlockFragment implements Dialeg.DialogCallbacks{
	
	/** The Constant ESBORRAR. */
	private static final int ESBORRAR = 1;
	
	/** The Constant MODIFICAR. */
	private static final int MODIFICAR = 2;
	
	/** The Constant INSERTAR. */
	private static final int INSERTAR = 3;
	
	/** The Constant PREU_UNITARI. */
	private static final int PREU_UNITARI = 4;
	
	/** The Constant IMPOST. */
	private static final int IMPOST = 5;
	
	/** The Constant VARIABLE. */
	private static final int VARIABLE = 6;
	
	/** The Constant ACCEPTAR. */
	private static final int ACCEPTAR = 7;
	
	/** The Constant NOM_DIRECTORI. */
	private static final String NOM_DIRECTORI = "THDocs";
	
	/** The Constant TITOL_DOCUMENT. */
	private static final String TITOL_DOCUMENT = "Pressupost Translators Helper";
	
	/** The et client. */
	private EditText etClient;
	
	/** The et nom pressupost. */
	private EditText etNomPressupost;
	
	/** The tv data creacio. */
	private TextView tvDataCreacio;
	
	/** The tv data entrega. */
	private TextView tvDataEntrega;
	
	/** The dp data entrega. */
	private DatePicker dpDataEntrega;
	
	/** The sp concepte. */
	private Spinner spConcepte;
	
	/** The sp tarifa. */
	private Spinner spTarifa;
	
	/** The tv import total. */
	private TextView tvImportTotal;
	
	/** The tv id pressupost. */
	private TextView tvIDPressupost;
	
	/** The tv preus unitaris total. */
	private TextView tvPreusUnitarisTotal;
	
	/** The tv impostos total. */
	private TextView tvImpostosTotal;
	
	/** The tv variables total. */
	private TextView tvVariablesTotal;
	
	/** The tlo preus unitaris celes. */
	private TableLayout tloPreusUnitarisCeles;
	
	/** The tlo impostos celes. */
	private TableLayout tloImpostosCeles;
	
	/** The tlo variables celes. */
	private TableLayout tloVariablesCeles;
	
	/** The img afegir preu unitari. */
	private ImageView imgAfegirPreuUnitari;
	
	/** The img afegir impost. */
	private ImageView imgAfegirImpost;
	
	/** The img afegir variable. */
	private ImageView imgAfegirVariable;
	
	/** The btn acceptar. */
	private Button btnAcceptar;
	
	/** The btn enviar. */
	private Button btnEnviar;
	
	/** The lst preus unitaris. */
	private ArrayList<PreuUnitariFac> lstPreusUnitaris = new ArrayList<PreuUnitariFac>();
	
	/** The lst impostos. */
	private ArrayList<ImpostFac> lstImpostos = new ArrayList<ImpostFac>();
	
	/** The lst variables. */
	private ArrayList<VariableFac> lstVariables = new ArrayList<VariableFac>();
	
	/** The spinner adapter conceptes. */
	private ArrayAdapter<String> spinnerAdapterConceptes;
	
	/** The spinner adapter tarifes. */
	private ArrayAdapter<String> spinnerAdapterTarifes;
	
	/** The spinner adapter preus unitaris. */
	private ArrayAdapter<String> spinnerAdapterPreusUnitaris;
	
	/** The spinner adapter impostos. */
	private ArrayAdapter<String> spinnerAdapterImpostos;
	
	/** The spinner adapter variables. */
	private ArrayAdapter<String> spinnerAdapterVariables;
	
	/** The total variables. */
	private float totalVariables = 0f;
	
	/** The total impostos. */
	private float totalImpostos = 0f;
	
	/** The total preus unitaris. */
	private float totalPreusUnitaris = 0f;
	
	/** The my menu. */
	private Menu myMenu;
	
	/** The botons. */
	private LinearLayout botons;

	/** The sdf. */
	SimpleDateFormat sdf = new SimpleDateFormat ("dd/MM/yyyy");
	
	private Bundle extras;

	/** The db. */
	private static THDataBaseHelper db;

	/* (non-Javadoc)
	 * @see android.support.v4.app.Fragment#onCreate(android.os.Bundle)
	 */
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setHasOptionsMenu(true);
		db = new THDataBaseHelper(getActivity());
		db.open();
	}
	
	/* (non-Javadoc)
	 * @see android.support.v4.app.Fragment#onCreateView(android.view.LayoutInflater, android.view.ViewGroup, android.os.Bundle)
	 */
	@Override
	public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
		View view = inflater.inflate(R.layout.fragment_detalls_pressupost, container, false);
		return view;
	}
	
	/* (non-Javadoc)
	 * @see android.support.v4.app.Fragment#onActivityCreated(android.os.Bundle)
	 */
	@Override
	public void onActivityCreated(Bundle savedInstanceState) {
		super.onActivityCreated(savedInstanceState);
		extras = getActivity().getIntent().getExtras();
		
		etClient = (EditText) getView().findViewById(R.id.txtDetallsPressupostClient);
		etNomPressupost = (EditText) getView().findViewById(R.id.txtDetallsPressupostNomPressupost);
		tvDataCreacio = (TextView) getView().findViewById(R.id.lblDetallsPressupostDataCreacioValor);
		tvDataEntrega = (TextView) getView().findViewById(R.id.lblDetallsPressupostDataEntregaSeleccionada);
		
		dpDataEntrega = (DatePicker) getView().findViewById(R.id.dpDetallsPressupostDataEntrega);
		
		spConcepte = (Spinner) getView().findViewById(R.id.spDetallsPressupostConcepte);
		spTarifa = (Spinner) getView().findViewById(R.id.spDetallsPressupostTarifa);
		tvPreusUnitarisTotal = (TextView) getView().findViewById(R.id.lblDetallsPressupostPreusUnitarisTotal);
		tvImpostosTotal = (TextView) getView().findViewById(R.id.lblDetallsPressupostImpostosTotal);
		tvVariablesTotal = (TextView) getView().findViewById(R.id.lblDetallsPressupostVariablesTotal);
		tvImportTotal = (TextView) getView().findViewById(R.id.lblDetallsPressupostImportTotal);
		tvIDPressupost = (TextView) getView().findViewById(R.id.lblDetallsPressupostID);
		tloPreusUnitarisCeles = (TableLayout) getView().findViewById(R.id.tloDetallsPressupostPreusUnitarisCeles);
		tloImpostosCeles = (TableLayout) getView().findViewById(R.id.tloDetallsPressupostImpostosCeles);
		tloVariablesCeles = (TableLayout) getView().findViewById(R.id.tloDetallsPressupostVariablesCeles);
		imgAfegirPreuUnitari = (ImageView) getView().findViewById(R.id.imgAfegirPreuUnitari);
		imgAfegirImpost = (ImageView) getView().findViewById(R.id.imgAfegirImpost);
		imgAfegirVariable = (ImageView) getView().findViewById(R.id.imgAfegirVariable);
		botons = (LinearLayout)getView().findViewById(R.id.lloDetallsPressupostBotones);
		btnAcceptar = (Button)getView().findViewById(R.id.btnAcceptar);
		btnEnviar = (Button)getView().findViewById(R.id.btnEnviar);
		
		inicialitzarViews();
		
		imgAfegirPreuUnitari.setOnClickListener(new View.OnClickListener() {
			
			@Override
			public void onClick(View v) {
				if (lstPreusUnitaris.isEmpty()) {
					spConcepte.setFocusable(false);
					spTarifa.setFocusable(false);
				}
				afegirPreuUnitari();
			}
		});
		
		imgAfegirImpost.setOnClickListener(new View.OnClickListener() {
			
			@Override
			public void onClick(View v) {
				afegirImpost();
			}
		});
		
		imgAfegirVariable.setOnClickListener(new View.OnClickListener() {
			
			@Override
			public void onClick(View v) {
				afegirVariable();
			}
		});
		
		btnAcceptar.setOnClickListener(new View.OnClickListener() {
			
			@Override
			public void onClick(View v) {
				Dialeg dialegAcceptar = Dialeg.newInstance((DetallsPressupostFragment)
	    				getFragmentManager().findFragmentById(R.id.detallsPressupostFragment), 
	    				"Acceptar pressupost", "Segur que vol acceptar el pressupost?", ACCEPTAR);
	    		dialegAcceptar.show(getFragmentManager(), "acceptar");
			}
		});
		
		btnEnviar.setOnClickListener(new View.OnClickListener() {
			
			@Override
			public void onClick(View v) {
				try {
					
					if (!enviarPressupost())
						Toast.makeText(getActivity().getApplicationContext(),"Error d'enviament.", Toast.LENGTH_LONG).show();
					
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (DocumentException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		});
	}

	
	
	/**
	 * Actualitzar total.
	 */
	private void actualitzarTotal() {
		float total = totalPreusUnitaris + totalImpostos + totalVariables; 
		tvImportTotal.setText(Float.toString((float)Math.round(total*100)/100));
	}
	
	
	
	/**
	 * Inicialitzar views.
	 *
	 * @param extras the extras
	 */
	private void inicialitzarViews() {
		
		inicialitzarSpinnerConceptes();
				
		if (!extras.getBoolean("afegir")){
			Projecte registre = (Projecte)extras.getSerializable("registre");
			
			if (registre.getClient() == null){
				etClient.setText(registre.getDescClient());
			}else{
				etClient.setText(registre.getClient().getNomCognoms());
			}
			
			etNomPressupost.setText(registre.getNomProjecte());
			tvDataCreacio.setText(sdf.format(registre.getDataCreacio()));
			
			Calendar dEntrega = Calendar.getInstance();
			dEntrega.setTime(registre.getDataEntrega());
			tvDataEntrega.setText(sdf.format(registre.getDataEntrega()));
			dpDataEntrega.init(dEntrega.get(Calendar.YEAR), dEntrega.get(Calendar.MONTH), dEntrega.get(Calendar.DAY_OF_MONTH), null);
			dpDataEntrega.setVisibility(View.GONE);
			
			spConcepte.setSelection(spinnerAdapterConceptes.getPosition(registre.getConcepte().getNom()));
			spConcepte.setClickable(false);
			
			inicialitzarSpinnerTarifes(registre.getConcepte().getidConcepte());
			spTarifa.setSelection(spinnerAdapterTarifes.getPosition(registre.getTarifa().getNom()));
			spTarifa.setClickable(false);
						
			botons.setVisibility(View.VISIBLE);
			
			tvImportTotal.setText(Float.toString(registre.getImportProjecte()));
			tvIDPressupost.setText(Integer.toString(registre.getIdProjecte()));
			
			lstPreusUnitaris = registre.getPreusUnitaris();
			lstImpostos = registre.getImpostos();
			lstVariables = registre.getVariables();
			
			inicialitzarTaulaPreusUnitaris(false);
			inicialitzarTaulaImpostos(false);
			inicialitzarTaulaVariables(false);
			
		}else{
			etClient.setCursorVisible(true);
			etClient.setFocusable(true);
			etClient.setFocusableInTouchMode(true);
			etClient.requestFocus();

			etNomPressupost.setCursorVisible(true);
			etNomPressupost.setFocusable(true);
			etNomPressupost.setFocusableInTouchMode(true);

			tvDataCreacio.setText(sdf.format(new Date()));
			tvDataEntrega.setVisibility(View.GONE);

			dpDataEntrega.setFocusable(true);
		}
	}
	
	
	
	/**
	 * Inicialitzar spinner conceptes.
	 */
	private void inicialitzarSpinnerConceptes() {
		spinnerAdapterConceptes = new ArrayAdapter<String> (getActivity().getBaseContext(), 
				android.R.layout.simple_spinner_item, db.getConceptesSpinner());
		
		spinnerAdapterConceptes.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
		
		spConcepte.setAdapter(spinnerAdapterConceptes);
		
		spConcepte.setOnItemSelectedListener(new OnItemSelectedListener(){
			@Override
            public void onItemSelected(AdapterView<?> arg0, View arg1,
                    int arg2, long arg3) {
				
				inicialitzarSpinnerTarifes(db.getIDConcepte(spConcepte.getItemAtPosition(arg2).toString()));
				
				if (!spTarifa.isClickable()) {
					spTarifa.setClickable(true);
					spTarifa.setFocusable(true);
				}
			}
			
			@Override
            public void onNothingSelected(AdapterView<?> arg0) {
            }
		});
	}
	
	/**
	 * Inicialitzar spinner tarifes.
	 *
	 * @param idConcepte the id concepte
	 */
	private void inicialitzarSpinnerTarifes(int idConcepte) {
		spinnerAdapterTarifes = new ArrayAdapter<String> (getActivity().getBaseContext(), 
				android.R.layout.simple_spinner_item, db.getTarifesSpinner(idConcepte));
		
		spinnerAdapterTarifes.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
		
		spTarifa.setAdapter(spinnerAdapterTarifes);
		
		spTarifa.setOnItemSelectedListener(new OnItemSelectedListener(){
			@Override
            public void onItemSelected(AdapterView<?> arg0, View arg1,
                    int arg2, long arg3) {
				if (!imgAfegirPreuUnitari.isShown()
						&& extras.getBoolean("afegir")) {
					imgAfegirPreuUnitari.setVisibility(View.VISIBLE);
				}
			}
			
			@Override
            public void onNothingSelected(AdapterView<?> arg0) {
            }
		});
	}

	
	
	/**
	 * Inicialitzar taula preus unitaris.
	 *
	 * @param actualitzar the actualitzar
	 */
	private void inicialitzarTaulaPreusUnitaris(boolean actualitzar) {
		totalPreusUnitaris = 0f;
		if(!lstPreusUnitaris.isEmpty()){
			if(actualitzar) {
				tloPreusUnitarisCeles.removeAllViews();
			}
			
			for (int index = 0; index < lstPreusUnitaris.size(); index++) {
				final PreuUnitariFac prU = lstPreusUnitaris.get(index);
				
				TableRow preuUnitariRow = new TableRow(getActivity());
				preuUnitariRow.setLayoutParams(new LayoutParams(LayoutParams.MATCH_PARENT, LayoutParams.WRAP_CONTENT));
				preuUnitariRow.setGravity(Gravity.CENTER_VERTICAL);
	
				String preu = new String();
	            TextView txtPreu = new TextView(getActivity());
	            txtPreu.setLayoutParams(new LayoutParams(200, LayoutParams.WRAP_CONTENT));
	            
	            preu = prU.getNom();
	            preu += ":\n";
	            preu += Float.toString(prU.getPreu());
				preu += " €";
	            preu += "/";
	            preu += prU.getUnitat();
	                        
	            txtPreu.setText(preu);
	          
	            TextView txtUnitats = new TextView(getActivity());
	            txtUnitats.setLayoutParams(new LayoutParams(125, LayoutParams.WRAP_CONTENT));
	            txtUnitats.setGravity(Gravity.CENTER_VERTICAL);
	            
	            txtUnitats.setText("\n x " + Integer.toString(prU.getNumUnitats()));
	            
	            TextView txtPreuUnitariTotal = new TextView(getActivity());
	            txtPreuUnitariTotal.setLayoutParams(new LayoutParams(115, LayoutParams.WRAP_CONTENT));
	            txtPreuUnitariTotal.setGravity(Gravity.CENTER_VERTICAL);
	            
				txtPreuUnitariTotal.setText("\n = "
						+ Float.toString((float) Math.round(prU
								.getImportPreuUnitats() * 100) / 100) + " €");
	            
	            preuUnitariRow.addView(txtPreu);
	            preuUnitariRow.addView(txtUnitats);
	            preuUnitariRow.addView(txtPreuUnitariTotal);
	            
	            if(actualitzar){
		            ImageView ivEsborra = new ImageView(getActivity());
		            ivEsborra.setLayoutParams(new LayoutParams(25, LayoutParams.WRAP_CONTENT));
		            ivEsborra.setImageDrawable(getResources().getDrawable(android.R.drawable.ic_delete));
		            ivEsborra.setOnClickListener(new View.OnClickListener() {
						@Override
						public void onClick(View v) {
							TableRow parent = (TableRow) v.getParent();
							totalPreusUnitaris -= prU.getImportPreuUnitats();
							tvPreusUnitarisTotal.setText(Float.toString(totalPreusUnitaris));
							
							lstPreusUnitaris.remove(parent.getId());
							tloPreusUnitarisCeles.removeView(parent);
												
							if (lstPreusUnitaris.isEmpty()) {
								spConcepte.setClickable(true);
								spConcepte.setFocusable(true);
								
								spTarifa.setClickable(true);
								spTarifa.setFocusable(true);
								
								lstImpostos.removeAll(lstImpostos);
								lstVariables.removeAll(lstVariables);
							}
							refrescTaules(PREU_UNITARI);
						}
					});
		            preuUnitariRow.addView(ivEsborra);
	            }
	            
	            preuUnitariRow.setId(index);
	      
				// Càrrega de files a la taula
	            tloPreusUnitarisCeles.addView(preuUnitariRow);
	            
	            totalPreusUnitaris += prU.getImportPreuUnitats();
			}
		}
		// Assignació del total parcial de preus unitaris
		tvPreusUnitarisTotal.setText(Float.toString((float)Math.round(totalPreusUnitaris*100)/100));
	}
	
	/**
	 * Inicialitzar taula impostos.
	 *
	 * @param actualitzar the actualitzar
	 */
	private void inicialitzarTaulaImpostos(boolean actualitzar) {
		
		if (actualitzar) {
			tloImpostosCeles.removeAllViews();
			totalImpostos = 0f;
			tvImpostosTotal.setText(Float.toString(totalImpostos));
		}
		
		if (!lstImpostos.isEmpty()) {
			
			for (int index = 0; index < lstImpostos.size(); index++) {
				final ImpostFac imp = lstImpostos.get(index);
				
				TableRow impostRow = new TableRow(getActivity());
				impostRow.setLayoutParams(new LayoutParams(LayoutParams.MATCH_PARENT, LayoutParams.WRAP_CONTENT));
				impostRow.setGravity(Gravity.CENTER_VERTICAL);
	
				String totalParcialPreus = new String();
	            TextView txtParcialPreu = new TextView(getActivity());
	            txtParcialPreu.setLayoutParams(new LayoutParams(200, LayoutParams.WRAP_CONTENT));
	            
	            totalParcialPreus = imp.getNom();
	            totalParcialPreus += ":\n";
	            totalParcialPreus += tvPreusUnitarisTotal.getText().toString();
				totalParcialPreus += " €";
	                        
	            txtParcialPreu.setText(totalParcialPreus);
	          
	            TextView txtPercent = new TextView(getActivity());
	            txtPercent.setLayoutParams(new LayoutParams(125, LayoutParams.WRAP_CONTENT));  
	            txtPercent.setGravity(Gravity.CENTER_VERTICAL);
	            
	            txtPercent.setText("\n x " + Float.toString(imp.getPercentatge()) + "%");
	            
	            TextView txtImpostTotal = new TextView(getActivity());
	            txtImpostTotal.setLayoutParams(new LayoutParams(115, LayoutParams.WRAP_CONTENT));
	            txtImpostTotal.setGravity(Gravity.CENTER_VERTICAL);
	            
	            if (actualitzar) {
	            	float puTotal = Float.parseFloat(tvPreusUnitarisTotal.getText().toString());
	            	
	            	if (puTotal > 0) {
	            		puTotal *= imp.getPercentatge()/100;
	            	}
	            	
					txtImpostTotal
							.setText("\n = "
									+ Float.toString((float) Math
											.round(puTotal * 100) / 100) + " €");
	            	imp.setImportImpost(puTotal);
	            	lstImpostos.remove(index);
	            	lstImpostos.add(index, imp);
	            }else {
					txtImpostTotal.setText("\n = "
							+ Float.toString((float) Math.round(imp
									.getImportImpost() * 100) / 100) + " €");
	            }
	            
	            impostRow.addView(txtParcialPreu);
	            impostRow.addView(txtPercent);
	            impostRow.addView(txtImpostTotal);
	            
	            if(actualitzar){
	            	ImageView ivEsborra = new ImageView(getActivity());
		            ivEsborra.setLayoutParams(new LayoutParams(25, LayoutParams.WRAP_CONTENT));
		            ivEsborra.setImageDrawable(getResources().getDrawable(android.R.drawable.ic_delete));
		            ivEsborra.setOnClickListener(new View.OnClickListener() {
						@Override
						public void onClick(View v) {
							TableRow parent = (TableRow) v.getParent();
							
							lstImpostos.remove(parent.getId());
							if (lstImpostos.isEmpty()) {
								lstVariables.removeAll(lstVariables);
							}
							
							tloImpostosCeles.removeView(parent);
							
							refrescTaules(IMPOST);
						}
					});
		            impostRow.addView(ivEsborra);
	            }
	            
	            impostRow.setId(index);
	            
				// Càrrega de files a la taula
	            tloImpostosCeles.addView(impostRow);
	            
	            totalImpostos += imp.getImportImpost();
			}
			// Assignació del total parcial d'impostos
			tvImpostosTotal.setText(Float.toString((float)Math.round(totalImpostos*100)/100));
		}
	}
	
	/**
	 * Inicialitzar taula variables.
	 *
	 * @param actualitzar the actualitzar
	 */
	private void inicialitzarTaulaVariables(boolean actualitzar) {
		
		if (actualitzar) {
			tloVariablesCeles.removeAllViews();
			totalVariables = 0f;
			tvVariablesTotal.setText(Float.toString(totalVariables));
		}
		
		if (!lstVariables.isEmpty()) {
			
			for (int index = 0; index < lstVariables.size(); index++) {
				final VariableFac var = lstVariables.get(index);
				
				TableRow variableRow = new TableRow(getActivity());
				variableRow.setLayoutParams(new LayoutParams(LayoutParams.MATCH_PARENT, LayoutParams.WRAP_CONTENT));
				variableRow.setGravity(Gravity.CENTER_VERTICAL);
	
				String totalParcialImpostos = new String();
	            TextView txtParcialImpost = new TextView(getActivity());
	            txtParcialImpost.setLayoutParams(new LayoutParams(200, LayoutParams.WRAP_CONTENT));
	            
	            if (var.getTipusOperacio() == 1) {
	            	totalParcialImpostos = var.getNom();
		            totalParcialImpostos += ":\n";
		            totalParcialImpostos += Float.toString(Float.parseFloat(tvPreusUnitarisTotal.getText().toString()) 
		            						+ Float.parseFloat(tvImpostosTotal.getText().toString()));
					totalParcialImpostos += " €";
	            }else {
	            	totalParcialImpostos = var.getNom() + ":";
	            }
	                        
	            txtParcialImpost.setText(totalParcialImpostos);
	            
	            TextView txtOperacio = new TextView(getActivity());
	            txtOperacio.setLayoutParams(new LayoutParams(125, LayoutParams.WRAP_CONTENT));
	            txtOperacio.setGravity(Gravity.CENTER_VERTICAL);
	            
	            if (var.getTipusOperacio() == 1) {
	            	txtOperacio.setText("\n x " + Float.toString(var.getValor()) + "%");
	            }else {
	            	txtOperacio.setText("\n + " + Float.toString(var.getValor()));
	            }
	            
	            TextView txtVariableTotal = new TextView(getActivity());
	            txtVariableTotal.setLayoutParams(new LayoutParams(115, LayoutParams.WRAP_CONTENT));
	            txtVariableTotal.setGravity(Gravity.CENTER_VERTICAL);
	            
	            if (actualitzar) {
	            	float impTotal = Float.parseFloat(tvPreusUnitarisTotal.getText().toString())
	            						+ Float.parseFloat(tvImpostosTotal.getText().toString());
	            	
	            	if (impTotal > 0) {
	            		if (var.getTipusOperacio() == 1) {
	            			impTotal *= var.getValor() / 100;
							txtVariableTotal.setText("\n = "
									+ Float.toString((float) Math
											.round(impTotal * 100) / 100)
									+ " €");
	    	            	var.setImportVariable(impTotal);
						}else{
							txtVariableTotal.setText("\n = "
									+ Float.toString((float) Math.round(var
											.getValor() * 100) / 100) + " €");
			            	var.setImportVariable(var.getValor());
						}
	            	}
	            	
	            	lstVariables.remove(index);
	            	lstVariables.add(index, var);
	            }else {
					txtVariableTotal.setText("\n = "
							+ Float.toString((float) Math.round(var
									.getImportVariable() * 100) / 100) + " €");
	            }
	            
	            variableRow.addView(txtParcialImpost);
	            variableRow.addView(txtOperacio);
	            variableRow.addView(txtVariableTotal);
	            
	            if (actualitzar){
	            	ImageView ivEsborra = new ImageView(getActivity());
		            ivEsborra.setLayoutParams(new LayoutParams(25, LayoutParams.WRAP_CONTENT));
		            ivEsborra.setImageDrawable(getResources().getDrawable(android.R.drawable.ic_delete));
		            ivEsborra.setOnClickListener(new View.OnClickListener() {
						@Override
						public void onClick(View v) {
							TableRow parent = (TableRow) v.getParent();
							
							lstVariables.remove(parent.getId());
							if(lstVariables.isEmpty()) {
								imgAfegirVariable.setVisibility(View.INVISIBLE);
							}
							tloVariablesCeles.removeView(parent);	
							
							refrescTaules(VARIABLE);
						}
					});
		            variableRow.addView(ivEsborra);
	            }
	            
	            variableRow.setId(index);
				
				// Càrrega de files a la taula
	            tloVariablesCeles.addView(variableRow);
	            
	            totalVariables += var.getImportVariable();
			}
			// Assignació del total parcial d'impostos
			tvVariablesTotal.setText(Float.toString((float)Math.round(totalVariables*100)/100));
		}
	}

	
	
	/* (non-Javadoc)
	 * @see com.actionbarsherlock.app.SherlockFragment#onCreateOptionsMenu(android.view.Menu, android.view.MenuInflater)
	 */
	@Override
	public void onCreateOptionsMenu(Menu menu, MenuInflater inflater) {
		inflater.inflate(R.menu.detall_fragment, menu);
	    myMenu = menu;
	    if (getActivity().getIntent().getExtras().getBoolean("afegir")) {
	    	myMenu.findItem(R.id.menuDetallsInsert).setVisible(true);
	    	myMenu.findItem(R.id.menuDetallsModificar).setVisible(false);
	    	myMenu.findItem(R.id.menuDetallsEliminar).setVisible(false);
	    }
	}
	
	

	/* (non-Javadoc)
	 * @see com.actionbarsherlock.app.SherlockFragment#onOptionsItemSelected(android.view.MenuItem)
	 */
	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		switch (item.getItemId()) {
		
	        case android.R.id.home:
	        	db.close();
				Intent intent = new Intent(getActivity(), LlistaPressupostosActivity.class);
	            intent.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP|Intent.FLAG_ACTIVITY_NEW_TASK);
	            startActivity(intent);
	            return true;
	            
	        case R.id.menuDetallsModificar:
	        	etClient.setClickable(true);
				etClient.setCursorVisible(true);
				etClient.setFocusable(true);
				etClient.setFocusableInTouchMode(true);
				etClient.requestFocus();
				
				etNomPressupost.setClickable(true);
				etNomPressupost.setCursorVisible(true);
				etNomPressupost.setFocusable(true);
				etNomPressupost.setFocusableInTouchMode(true);
				
				tvDataEntrega.setVisibility(View.GONE);
				dpDataEntrega.setVisibility(View.VISIBLE);
				dpDataEntrega.setFocusable(true);
				
				spConcepte.setClickable(true);
				spConcepte.setFocusable(true);
				
				spTarifa.setClickable(true);
				spTarifa.setFocusable(true);
				
				botons.setVisibility(View.GONE);
				
				refrescTaules(PREU_UNITARI);

			imgAfegirPreuUnitari.setVisibility(View.VISIBLE);
			imgAfegirImpost.setVisibility(View.VISIBLE);
			imgAfegirVariable.setVisibility(View.VISIBLE);
	    			
	        	myMenu.findItem(R.id.menuDetallsUpdate).setVisible(true);
	        	myMenu.findItem(R.id.menuDetallsModificar).setVisible(false);
	        	myMenu.findItem(R.id.menuDetallsEliminar).setVisible(false);
	        	
	    		return true;
	    		
	    	case R.id.menuDetallsEliminar:
	    		Dialeg dialegEliminar = Dialeg.newInstance((DetallsPressupostFragment)
	    				getFragmentManager().findFragmentById(R.id.detallsPressupostFragment), 
	    				"Eliminar pressupost", "Segur que vol eliminar el pressupost?", ESBORRAR);
	    		dialegEliminar.show(getFragmentManager(), "eliminar");
	    		return true;
	    		
	    	case R.id.menuDetallsUpdate:
	    		Calendar dEntradaUpdate = Calendar.getInstance();
	    		dEntradaUpdate.set(dpDataEntrega.getYear(), dpDataEntrega.getMonth(), dpDataEntrega.getDayOfMonth());
	    		String nomClientUpdate = etClient.getText().toString();
	    		String nomPressupostUpdate = etNomPressupost.getText().toString();
	    		String concepteUpdate = spConcepte.getSelectedItem().toString();
	    		String tarifaUpdate = spTarifa.getSelectedItem().toString();
	    		
	    		if (nomClientUpdate == null || nomClientUpdate.isEmpty()) {
	    			Toast.makeText(getActivity().getApplicationContext(), "El camp client no pot estar buit.", Toast.LENGTH_LONG).show();
	    			return true;
	    		}
	    		
	    		if (nomPressupostUpdate == null || nomPressupostUpdate.isEmpty()) {
				Toast.makeText(getActivity().getApplicationContext(),
						"La descripció del pressupost no pot estar buit.",
						Toast.LENGTH_LONG).show();
	    			return true;
	    		}
	    		
	    		if (dEntradaUpdate.before(new Date())) {
	    			Toast.makeText(getActivity().getApplicationContext(), "La data d'entrega no pot ser inferior a la data d'avui.", Toast.LENGTH_LONG).show();
	    			return true;
	    		}
	    		
	    		if (concepteUpdate == null || concepteUpdate.isEmpty()) {
	    			Toast.makeText(getActivity().getApplicationContext(), "El concepte no pot estar buit.", Toast.LENGTH_LONG).show();
	    			return true;
	    		}
	    		
	    		if (tarifaUpdate == null || tarifaUpdate.isEmpty()) {
	    			Toast.makeText(getActivity().getApplicationContext(), "La tarifa no pot estar buida.", Toast.LENGTH_LONG).show();
	    			return true;
	    		}
	    		
	    		if (lstPreusUnitaris.isEmpty()) {
	    			Toast.makeText(getActivity().getApplicationContext(), "No hi ha preus unitaris.", Toast.LENGTH_LONG).show();
	    			return true;
	    		}
	    		
	    		if (lstImpostos.isEmpty()) {
	    			Toast.makeText(getActivity().getApplicationContext(), "No hi ha impostos.", Toast.LENGTH_LONG).show();
	    			return true;
	    		}
	    		
				try {
					int idConcepteUpdate = db.getIDConcepte(spConcepte.getSelectedItem().toString());
					
					if (db.getIDProjecte(nomPressupostUpdate
							, null
							, 0
							, nomClientUpdate
							, db.getIDTarifa(spTarifa.getSelectedItem().toString(), idConcepteUpdate)
							, idConcepteUpdate
							, dEntradaUpdate.getTime()
							, sdf.parse(tvDataCreacio.getText().toString())
							, 1
							, null
							, tvImportTotal.getText().toString()) == -1){
		    			Dialeg dialegModificar = Dialeg.newInstance((DetallsPressupostFragment)
			    				getFragmentManager().findFragmentById(R.id.detallsPressupostFragment), 
			    				"Modificar pressupost", "Segur que vol desar els canvis al pressupost?", MODIFICAR);
			    		dialegModificar.show(getFragmentManager(), "modificar");
		    		}else {
		    			Toast.makeText(getActivity().getApplicationContext(),"El pressupost ja existeix.", Toast.LENGTH_LONG).show();
		    		}
				} catch (ParseException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				
	    		return true;
	    		
	    	case R.id.menuDetallsInsert:
	    		Calendar dEntradaInsert = Calendar.getInstance();
				dEntradaInsert.set(dpDataEntrega.getYear(), dpDataEntrega.getMonth(), dpDataEntrega.getDayOfMonth());
	    		String nomClientInsert = etClient.getText().toString();
	    		String nomPressupostInsert = etNomPressupost.getText().toString();
	    		String concepteInsert = spConcepte.getSelectedItem().toString();
	    		String tarifaInsert = spTarifa.getSelectedItem().toString();
	    		
	    		if (nomClientInsert == null || nomClientInsert.isEmpty()) {
	    			Toast.makeText(getActivity().getApplicationContext(), "El camp client no pot estar buit.", Toast.LENGTH_LONG).show();
	    			return true;
	    		}
	    		
	    		if (nomPressupostInsert == null || nomPressupostInsert.isEmpty()) {
				Toast.makeText(getActivity().getApplicationContext(),
						"La descripció del pressupost no pot estar buit.",
						Toast.LENGTH_LONG).show();
	    			return true;
	    		}
	    		
	    		if (dEntradaInsert.before(new Date())) {
	    			Toast.makeText(getActivity().getApplicationContext(), "La data d'entrega no pot ser inferior a la data d'avui.", Toast.LENGTH_LONG).show();
	    			return true;
	    		}
	    		
	    		if (concepteInsert == null || concepteInsert.isEmpty()) {
	    			Toast.makeText(getActivity().getApplicationContext(), "El concepte no pot estar buit.", Toast.LENGTH_LONG).show();
	    			return true;
	    		}
	    		
	    		if (tarifaInsert == null || tarifaInsert.isEmpty()) {
	    			Toast.makeText(getActivity().getApplicationContext(), "La tarifa no pot estar buida.", Toast.LENGTH_LONG).show();
	    			return true;
	    		}
	    		
	    		if (lstPreusUnitaris.isEmpty()) {
	    			Toast.makeText(getActivity().getApplicationContext(), "No s'han afegit preus unitaris.", Toast.LENGTH_LONG).show();
	    			return true;
	    		}
	    		
	    		if (lstImpostos.isEmpty()) {
	    			Toast.makeText(getActivity().getApplicationContext(), "No s'han afegit impostos.", Toast.LENGTH_LONG).show();
	    			return true;
	    		}
	    		
	    		if (db.getIDProjecte(nomPressupostInsert) == -1){
		    		Dialeg dialegAfegir = Dialeg.newInstance((DetallsPressupostFragment)
		    				getFragmentManager().findFragmentById(R.id.detallsPressupostFragment), 
		    				"Afegir pressupost", "Segur que vol afegir el pressupost?", INSERTAR);
		    		dialegAfegir.show(getFragmentManager(), "afegir");
	    		}else {
	    			Toast.makeText(getActivity().getApplicationContext(),"El pressupost ja existeix.", Toast.LENGTH_LONG).show();
	    		}
	    		return true;
	    		
			default:
				return super.onOptionsItemSelected(item);
		}
	}

	
	
	/* (non-Javadoc)
	 * @see com.ADApps.translatorhelper.main.Dialeg.DialogCallbacks#onPositive(int)
	 */
	@Override
	public void onPositive(int mode) {
		
		switch (mode){
		
			case ESBORRAR:
				int idPressupostDelete = Integer.parseInt(tvIDPressupost.getText().toString());
				if (!db.deletePreusUnitarisFac(idPressupostDelete)) {
					Toast.makeText(getActivity().getApplicationContext(),"Error en esborrar els preus unitaris.", Toast.LENGTH_LONG).show();
				}
				
				if (!db.deleteImpostosFac(idPressupostDelete)) {
					Toast.makeText(getActivity().getApplicationContext(),"Error en esborrar els preus unitaris.", Toast.LENGTH_LONG).show();
				}

				if (!db.deleteVariablesFac(idPressupostDelete)) {
					Toast.makeText(getActivity().getApplicationContext(),"Error en esborrar els preus unitaris.", Toast.LENGTH_LONG).show();
				}
				
				if (db.deleteProjecte(idPressupostDelete)) {
					db.close();
					Intent intent = new Intent(getActivity(), LlistaPressupostosActivity.class);
		            intent.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP|Intent.FLAG_ACTIVITY_NEW_TASK);
		            startActivity(intent);
				}else {
					db.close();
					Toast.makeText(getActivity().getApplicationContext(),"Error en esborrar el pressupost.", Toast.LENGTH_LONG).show();
				}
				break;
				
			case MODIFICAR:
				Calendar dEntradaUpdate = Calendar.getInstance();
				dEntradaUpdate.set(dpDataEntrega.getYear(), dpDataEntrega.getMonth(), dpDataEntrega.getDayOfMonth());
				try {
					int idConcepteUpdate = db.getIDConcepte(spConcepte.getSelectedItem().toString());
					int idPressupostUpdate = Integer.parseInt(tvIDPressupost.getText().toString());
					
					if (db.updateProjecte(idPressupostUpdate
							, etNomPressupost.getText().toString()
							, null
							, 0
							, etClient.getText().toString()
							, db.getIDTarifa(spTarifa.getSelectedItem().toString(), idConcepteUpdate)
							, idConcepteUpdate
							, dEntradaUpdate.getTime()
							, sdf.parse(tvDataCreacio.getText().toString())
							, 1
							, null
							, tvImportTotal.getText().toString())) {
						
						if (!actualitzarPreusUnitaris(idPressupostUpdate)) {
							Toast.makeText(getActivity().getApplicationContext(),"Error en modificar els preus unitaris.", Toast.LENGTH_LONG).show();
						}
						
						if (!actualitzarImpostos(idPressupostUpdate)) {
							Toast.makeText(getActivity().getApplicationContext(),"Error en modificar els impostos.", Toast.LENGTH_LONG).show();
						}
						
						if (!actualitzarVariables(idPressupostUpdate)) {
							Toast.makeText(getActivity().getApplicationContext(),"Error en modificar les variables.", Toast.LENGTH_LONG).show();
						}
						
						db.close();
						Intent intent = new Intent(getActivity(), LlistaPressupostosActivity.class);
			            intent.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP|Intent.FLAG_ACTIVITY_NEW_TASK);
			            startActivity(intent);
					}else {
						db.close();
						Toast.makeText(getActivity().getApplicationContext(),"Error en modificar el pressupost", Toast.LENGTH_LONG).show();
					}
				} catch (NumberFormatException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				} catch (ParseException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				}
				break;
				
			case INSERTAR:
				Calendar dEntradaInsert = Calendar.getInstance();
				dEntradaInsert.set(dpDataEntrega.getYear(), dpDataEntrega.getMonth(), dpDataEntrega.getDayOfMonth());
				try {
					int idConcepteInsertar = db.getIDConcepte(spConcepte.getSelectedItem().toString());
					int idPressupostInsertar = db.insertProjecte(etNomPressupost.getText().toString()
, null
							, 0
							, etClient.getText().toString()
							, db.getIDTarifa(spTarifa.getSelectedItem().toString(), idConcepteInsertar)
							, idConcepteInsertar
							, dEntradaInsert.getTime()
							, sdf.parse(tvDataCreacio.getText().toString())
							, 1
							, null
							, tvImportTotal.getText().toString());
					
					if (idPressupostInsertar != -1) {
						if (!actualitzarPreusUnitaris(idPressupostInsertar)) {
							Toast.makeText(getActivity().getApplicationContext(),"Error en insertar els preus unitaris.", Toast.LENGTH_LONG).show();
						}
						
						if (!actualitzarImpostos(idPressupostInsertar)) {
							Toast.makeText(getActivity().getApplicationContext(),"Error en insertar els impostos.", Toast.LENGTH_LONG).show();
						}
						
						if (!actualitzarVariables(idPressupostInsertar)) {
							Toast.makeText(getActivity().getApplicationContext(),"Error en insertar les variables.", Toast.LENGTH_LONG).show();
						}
					}else {
						Toast.makeText(getActivity().getApplicationContext(),"Error en insertar el projecte", Toast.LENGTH_LONG).show();
					}
					
					db.close();
					Intent intent = new Intent(getActivity(), LlistaPressupostosActivity.class);
		            intent.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP|Intent.FLAG_ACTIVITY_NEW_TASK);
		            startActivity(intent);
		            
				} catch (ParseException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				break;
				
			case ACCEPTAR:
				
				if (!db.acceptarPressupost(Integer.parseInt(tvIDPressupost.getText().toString()), sdf.format(new Date()))){
					Toast.makeText(getActivity().getApplicationContext(),"Error en acceptar el pressupost", Toast.LENGTH_LONG).show();
				}
				
				db.close();
				Intent intent = new Intent(getActivity(), LlistaPressupostosActivity.class);
	            intent.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP|Intent.FLAG_ACTIVITY_NEW_TASK);
	            startActivity(intent);
	            
				break;
			default:
				break;
		}	
	}

	
	
	/**
	 * Actualitzar variables.
	 *
	 * @param idP the id p
	 * @return true, if successful
	 */
	private boolean actualitzarVariables(int idP) {
		boolean aVar = false;
		int index = 0;
		
		if (aVar = db.deleteVariablesFac(idP)) {
			while (index < lstVariables.size() && aVar) {
				VariableFac varF = lstVariables.get(index);
				aVar = db.insertVariableFac(idP, varF.getIdVariable(), varF.getImportVariable());
				index++;
			}
		}
		return aVar;
	}

	/**
	 * Actualitzar impostos.
	 *
	 * @param idP the id p
	 * @return true, if successful
	 */
	private boolean actualitzarImpostos(int idP) {
		boolean aIM = false;
		int index = 0;
		
		if (aIM = db.deleteImpostosFac(idP)) {
			while (index < lstImpostos.size() && aIM) {
				ImpostFac impF = lstImpostos.get(index);
				aIM = db.insertImpostFac(idP, impF.getIdImpost(), impF.getImportImpost());
				index++;
			}
		}
		return aIM;
	}

	/**
	 * Actualitzar preus unitaris.
	 *
	 * @param idP the id p
	 * @return true, if successful
	 */
	private boolean actualitzarPreusUnitaris(int idP) {
		
		if (db.deletePreusUnitarisFac(idP)) {
			for (int i = 0; i < lstPreusUnitaris.size(); i++) {
				PreuUnitariFac prU = lstPreusUnitaris.get(i);
				if (db.insertPreuUnitariFac(idP, prU.getIdPreuUnitari(),
						prU.getNumUnitats(), prU.getImportPreuUnitats()) == -1) {
					return false;
				}
			}
			return true;
		} else
			return false;
	}

	
	
	/* (non-Javadoc)
	 * @see com.ADApps.translatorhelper.main.Dialeg.DialogCallbacks#onNegative(int)
	 */
	@Override
	public void onNegative(int dialogMode) {
		
	}
	
	
	
	/**
	 * Afegir preu unitari.
	 */
	private void afegirPreuUnitari() {
		final Dialog dialog = new Dialog(getActivity());
		dialog.setContentView(R.layout.dialeg_preus_unitaris);
		dialog.setTitle(R.string.afegirPreuUnitari);
		
		final Spinner spPreuUnitari = (Spinner) dialog.findViewById(R.id.spDialegPreuUnitari);
		final TextView tvPreuUnitats = (TextView) dialog.findViewById(R.id.lblDialegPreuUnitariPreuUnitat);
		final EditText etUnitats = (EditText) dialog.findViewById(R.id.txtDialegPreuUnitariUnitats);

		// set the custom dialog components
		final Tarifa tarifa = db.getTarifa(spTarifa.getSelectedItem().toString(), db.getIDConcepte(spConcepte.getSelectedItem().toString()));
				
		if ((spinnerAdapterPreusUnitaris = new ArrayAdapter<String> (getActivity().getBaseContext(), 
				android.R.layout.simple_spinner_item, db.getPreusUnitarisSpinner(tarifa.getIdTarifa()))).isEmpty()){
			
			spConcepte.setFocusable(true);
			spTarifa.setFocusable(true);
			
			Toast.makeText(getActivity().getApplicationContext(),"No hi ha preus unitaris definits\n per aquesta tarifa i aquest concepte.",
					Toast.LENGTH_LONG).show();
			
		}else{
			
			spinnerAdapterPreusUnitaris.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
			
			spPreuUnitari.setAdapter(spinnerAdapterPreusUnitaris);
			
			spPreuUnitari.setOnItemSelectedListener(new OnItemSelectedListener(){
				@Override
		        public void onItemSelected(AdapterView<?> arg0, View arg1,
		                int arg2, long arg3) {
					PreuUnitari pu = db.getPreuUnitari(tarifa.getIdTarifa(), spPreuUnitari.getItemAtPosition(arg2).toString());
							tvPreuUnitats.setText(Float.toString(pu.getPreu())
									+ " €/" + pu.getUnitat());
				}
				
				@Override
		        public void onNothingSelected(AdapterView<?> arg0) {
		        }
			});
			
					
			Button dbAcceptar = (Button) dialog.findViewById(R.id.dbDialegPreuUnitariAcceptar);
				dbAcceptar.setOnClickListener(new OnClickListener() {
					@Override
					public void onClick(View v) {
						PreuUnitari pu = db.getPreuUnitari(tarifa.getIdTarifa(), spPreuUnitari.getSelectedItem().toString());
						int unitats = Integer.parseInt(etUnitats.getText().toString());
						float importPF = pu.getPreu() * Integer.parseInt(etUnitats.getText().toString());
						PreuUnitariFac puF = new PreuUnitariFac (
								pu.getNom(), 
								pu.getIdPreuUnitari(), 
								tarifa,
								pu.getPreu(), 
								pu.getUnitat(), 
								unitats,	
								importPF);
						if (!lstPreusUnitaris.contains(puF)) {
							lstPreusUnitaris.add(puF);
							
						if (extras.getBoolean("afegir")) {
							imgAfegirImpost.setVisibility(View.VISIBLE);
						}
							
							refrescTaules(PREU_UNITARI);
							
							actualitzarTotal();
							dialog.cancel();
						}else {
							Toast.makeText(getActivity().getApplicationContext(),"El preu unitari ja existeix.", Toast.LENGTH_LONG).show();
						}
					}
			});
				
			Button dbCancelar = (Button) dialog.findViewById(R.id.dbDialegPreuUnitariCancelar);
			// Si es prem el botó es tanca el diàleg
				dbCancelar.setOnClickListener(new OnClickListener() {
					@Override
					public void onClick(View v) {
						if (lstPreusUnitaris.isEmpty()) {
							spConcepte.setClickable(true);
							spConcepte.setFocusable(true);
							
							spTarifa.setClickable(true);
							spTarifa.setFocusable(true);
						}
						dialog.dismiss();
					}
			});
	
			dialog.show();
		}
	}
	
	
	/**
	 * Afegir variable.
	 */
	private void afegirVariable() {
		final Dialog dialog = new Dialog(getActivity());
		dialog.setContentView(R.layout.dialeg_variables);
		dialog.setTitle(R.string.afegirVariable);
		
		final Spinner spVariable = (Spinner) dialog.findViewById(R.id.spDialegVariable);
		final TextView tvVariables = (TextView) dialog.findViewById(R.id.lblDialegVariableValor);

		// set the custom dialog components
		spinnerAdapterVariables = new ArrayAdapter<String> (getActivity().getBaseContext(), 
				android.R.layout.simple_spinner_item, db.getVariablesSpinner());
		
		spinnerAdapterVariables.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
		
		spVariable.setAdapter(spinnerAdapterVariables);
		
		spVariable.setOnItemSelectedListener(new OnItemSelectedListener(){
			@Override
	        public void onItemSelected(AdapterView<?> arg0, View arg1,
	                int arg2, long arg3) {
				Variable var = db.getVariable(db.getIDVariable(arg0.getItemAtPosition(arg2).toString()));
				if (var.getTipusOperacio() == 1) {
					tvVariables.setText(Float.toString(var.getValor()) + "%");
				}else {
					tvVariables.setText(Float.toString(var.getValor()) + " €");
				}
			}
			
			@Override
	        public void onNothingSelected(AdapterView<?> arg0) {
	        }
		});

		
		Button dbAcceptar = (Button) dialog.findViewById(R.id.dbDialegVariableAcceptar);
			dbAcceptar.setOnClickListener(new OnClickListener() {
				
				@Override
				public void onClick(View v) {
					Variable var = db.getVariable(db.getIDVariable(spVariable.getSelectedItem().toString()));
					float importVF = Float.parseFloat(tvPreusUnitarisTotal.getText().toString())
										+ Float.parseFloat(tvImpostosTotal.getText().toString());
					
					if (importVF > 0) {
						if (var.getTipusOperacio() == 1) {

							float percentatgeImpTotal = importVF * var.getValor() / 100;
							importVF += percentatgeImpTotal;

						} else {
							importVF = var.getValor();
						}
					}
					
					VariableFac varF = new VariableFac (
							var.getIdVariable(),
							var.getNom(),
							var.getValor(),
							var.getTipusOperacio(),	
							importVF);
					
					if (!lstVariables.contains(varF)) {
						lstVariables.add(varF);
						
						refrescTaules(VARIABLE);
						
						actualitzarTotal();
						dialog.cancel();
					}else {
						Toast.makeText(getActivity().getApplicationContext(),"La variable ja existeix.", Toast.LENGTH_LONG).show();
					}
				}
		});
			
		Button dbCancelar = (Button) dialog.findViewById(R.id.dbDialegVariableCancelar);
		// Si es prem el botó es tanca el diàleg
			dbCancelar.setOnClickListener(new OnClickListener() {
				@Override
				public void onClick(View v) {
					dialog.dismiss();
				}
		});

		dialog.show();
	}

	
	/**
	 * Afegir impost.
	 */
	private void afegirImpost() {
		final Dialog dialog = new Dialog(getActivity());
		dialog.setContentView(R.layout.dialeg_impostos);
		dialog.setTitle(R.string.afegirImpost);
		
		final Spinner spImpost = (Spinner) dialog.findViewById(R.id.spDialegImpost);
		final TextView tvImpostos = (TextView) dialog.findViewById(R.id.lblDialegImpostValor);

		// set the custom dialog components
		spinnerAdapterImpostos = new ArrayAdapter<String> (getActivity().getBaseContext(), 
				android.R.layout.simple_spinner_item, db.getImpostosSpinner());
		
		spinnerAdapterImpostos.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
		
		spImpost.setAdapter(spinnerAdapterImpostos);
		
		spImpost.setOnItemSelectedListener(new OnItemSelectedListener(){
			@Override
	        public void onItemSelected(AdapterView<?> arg0, View arg1,
	                int arg2, long arg3) {
				Impost imp = db.getImpost(db.getIDImpost(spImpost.getItemAtPosition(arg2).toString()));
				
				tvImpostos.setText(Float.toString(imp.getPercentatge()) + "%");
			}
			
			@Override
	        public void onNothingSelected(AdapterView<?> arg0) {
	        }
		});
		
		
		Button dbAcceptar = (Button) dialog.findViewById(R.id.dbDialegImpostAcceptar);
			dbAcceptar.setOnClickListener(new OnClickListener() {
				@Override
				public void onClick(View v) {
					Impost imp = db.getImpost(db.getIDImpost(spImpost.getSelectedItem().toString()));
					float importIF = Float.parseFloat(tvPreusUnitarisTotal.getText().toString());
					
					if (importIF > 0) {
						
						float percentatgeImpTotal = importIF * imp.getPercentatge() / 100;
						importIF += percentatgeImpTotal;
						
					}
					
					ImpostFac impF = new ImpostFac (imp.getNom(),
							imp.getIdImpost(),
							imp.getPercentatge(),	
							importIF);
					
					if (!lstImpostos.contains(impF)) {
						lstImpostos.add(impF);
						
					if (extras.getBoolean("afegir"))
						imgAfegirVariable.setVisibility(View.VISIBLE);
						
						refrescTaules(IMPOST);
						
						actualitzarTotal();
						dialog.cancel();
					}else {
						Toast.makeText(getActivity().getApplicationContext(),"L'impost ja existeix.", Toast.LENGTH_LONG).show();
					}
				}
		});
			
		Button dbCancelar = (Button) dialog.findViewById(R.id.dbDialegImpostCancelar);
		// Si es prem el botó es tanca el diàleg
			dbCancelar.setOnClickListener(new OnClickListener() {
				@Override
				public void onClick(View v) {
					dialog.dismiss();
				}
		});

		dialog.show();
	}
	
	
	
	/**
	 * Refresc taules.
	 *
	 * @param origen the origen
	 */
	private void refrescTaules(int origen) {
		switch (origen) {
			case PREU_UNITARI:
				inicialitzarTaulaPreusUnitaris(true);
				inicialitzarTaulaImpostos(true);
				inicialitzarTaulaVariables(true);
				actualitzarTotal();
				break;
			case IMPOST:
				inicialitzarTaulaImpostos(true);
				inicialitzarTaulaVariables(true);
				actualitzarTotal();
				break;
			case VARIABLE:
				inicialitzarTaulaVariables(true);
				actualitzarTotal();
				break;
			default:
				break;
		}
	}
	
	
	/**
	 * Enviar pressupost.
	 *
	 * @return true, if successful
	 * @throws IOException Signals that an I/O exception has occurred.
	 * @throws DocumentException the document exception
	 */
	private boolean enviarPressupost() throws IOException, DocumentException {
		File fitxer = null;
		
		if ((fitxer = crearDocument()) != null){
			 
            Intent emailIntent = new Intent(Intent.ACTION_SEND);

            emailIntent.putExtra(Intent.EXTRA_STREAM, Uri.fromFile(fitxer));
 
			// Únicament clients de correu
            emailIntent.setType("message/rfc822");
 
			startActivity(Intent.createChooser(emailIntent,
					"Enviar correu electrònic..."));
			
			return true;
		}else {
			return false;
		}
	}
	
	
	/**
	 * Crear document.
	 *
	 * @return the file
	 * @throws IOException Signals that an I/O exception has occurred.
	 * @throws DocumentException the document exception
	 */
	private File crearDocument() throws IOException, DocumentException{
		// Creem el document.
		Document doc = new Document();
		
		// Creem el paràgraf.
		Paragraph par;
		
		// Creem la taula.
		PdfPTable taula;
		
		// Creem el fitxer amb el nom desitjat.
		File f = crearFitxer(etNomPressupost.getText().toString() + ".pdf");
		 
		// Creem el flux de dades de sortida pel fitxer on guardarem el pdf.
		FileOutputStream fitxerPdf = new FileOutputStream(f.getAbsolutePath());
		 
		// Associem el flux que acabem de crear al document.
		PdfWriter.getInstance(doc, fitxerPdf);
		 
		// Obrim el document.
		doc.open();
		
		// Afegim el títol.
		par = new Paragraph(TITOL_DOCUMENT, FontFactory.getFont(FontFactory.HELVETICA, 28, Font.BOLD, Color.BLACK));
		par.setSpacingAfter(3f);
		doc.add(par);
		
		// Afegim el Client.
		par = new Paragraph("Client:", FontFactory.getFont(FontFactory.HELVETICA, 16, Font.BOLD, Color.BLACK));
		par.setSpacingAfter(1.5f);
		par.setIndentationLeft(1f);
		doc.add(par);
		
		par = new Paragraph(etClient.getText().toString(), FontFactory.getFont(FontFactory.HELVETICA, 12, Font.NORMAL, Color.BLACK));
		par.setSpacingAfter(2f);
		par.setIndentationLeft(2f);
		doc.add(par);
		
		// Afegim la descripció del pressupost.
		par = new Paragraph("Descripció del pressupost:", FontFactory.getFont(
				FontFactory.HELVETICA, 16, Font.BOLD, Color.BLACK));
		par.setSpacingAfter(1.5f);
		par.setIndentationLeft(1f);
		doc.add(par);
		
		par = new Paragraph(etNomPressupost.getText().toString(), FontFactory.getFont(FontFactory.HELVETICA, 12, Font.NORMAL, Color.BLACK));
		par.setSpacingAfter(2f);
		par.setIndentationLeft(2f);
		doc.add(par);
		
		// Afegim la data d'entrega.
		par = new Paragraph("Data d'entrega:", FontFactory.getFont(FontFactory.HELVETICA, 16, Font.BOLD, Color.BLACK));
		par.setSpacingAfter(1.5f);
		par.setIndentationLeft(1f);
		doc.add(par);
		
		par = new Paragraph(tvDataEntrega.getText().toString(), FontFactory.getFont(FontFactory.HELVETICA, 12, Font.NORMAL, Color.BLACK));
		par.setSpacingAfter(2f);
		par.setIndentationLeft(2f);
		doc.add(par);
		
		// Afegim el concepte i la tarifa.
		par = new Paragraph("Concepte/Tarifa:", FontFactory.getFont(FontFactory.HELVETICA, 16, Font.BOLD, Color.BLACK));
		par.setSpacingAfter(1.5f);
		par.setIndentationLeft(1f);
		doc.add(par);
		
		par = new Paragraph(spConcepte.getSelectedItem().toString() + "/" + spTarifa.getSelectedItem().toString(), FontFactory.getFont(FontFactory.HELVETICA, 12, Font.NORMAL, Color.BLACK));
		par.setSpacingAfter(20f);
		par.setIndentationLeft(2f);
		doc.add(par);
		
		
		// Afegim la taula de preus unitaris.
		taula = new PdfPTable(3);
		
		taula.setSpacingBefore(20f);
		
		// Afegim la capçalera.
		taula.addCell("Preus unitaris");
		taula.addCell("Unitats");
		taula.addCell("");
		
		// Afegim les cel·les.
		for (int index = 0; index < lstPreusUnitaris.size(); index++) {
			PreuUnitariFac prU = lstPreusUnitaris.get(index);
			taula.addCell(prU.getNom() + ": " + Float.toString(prU.getPreu())
					+ " €/" + prU.getUnitat());
			taula.addCell(" x " + Integer.toString(prU.getNumUnitats()));
			taula.addCell(" = " + Float.toString(prU.getImportPreuUnitats())
					+ " €");
		}
		// Afegim la línia de total de preus unitaris.
		taula.addCell("");
		taula.addCell("");
		taula.addCell(tvPreusUnitarisTotal.getText().toString() + " €");
		
		doc.add(taula);
		
		
		// Afegim la taula d'impostos.
		taula = new PdfPTable(3);
		
		// Afegim la capçalera.
		taula.addCell("Impostos");
		taula.addCell("Valor");
		taula.addCell("");
		
		// Afegim les cel·les.
		for (int index = 0; index < lstImpostos.size(); index++) {
			ImpostFac imp = lstImpostos.get(index);
			taula.addCell(imp.getNom() + ": "
					+ tvPreusUnitarisTotal.getText().toString() + " €");
			taula.addCell(" x " + Float.toString(imp.getPercentatge()) + "%");
			taula.addCell(" = " + Float.toString(imp.getImportImpost()) + " €");
		}
		// Afegim la línia de total de preus unitaris.
		taula.addCell("");
		taula.addCell("");
		taula.addCell(tvImpostosTotal.getText().toString() + " €");
		
		doc.add(taula);
		
		
		// Afegim la taula de variables.
		taula = new PdfPTable(3);
		
		// Afegim la capçalera.
		taula.addCell("Variables");
		taula.addCell("Valor");
		taula.addCell("");
		
		// Afegim les cel·les.
		for (int index = 0; index < lstVariables.size(); index++) {
			VariableFac var = lstVariables.get(index);
			
			if (var.getTipusOperacio() == 1) {
				taula.addCell(var.getNom()+ ": " + Float.toString(Float.parseFloat(tvPreusUnitarisTotal.getText().toString()) 
								+ Float.parseFloat(tvImpostosTotal.getText()
										.toString())) + " €");
				taula.addCell(" x " + Float.toString(var.getValor()) + "%");
			}else {
				taula.addCell(var.getNom() + ":");
				taula.addCell(" + " + Float.toString(var.getValor()) + " €");
            }

			taula.addCell(" = " + Float.toString(var.getImportVariable())
					+ " €");
		}
		
		// Afegim la línia de total de preus unitaris.
		taula.addCell("");
		taula.addCell("");
		taula.addCell(tvVariablesTotal.getText().toString() + " €");
		
		doc.add(taula);
		
		
		// Afegim el total del pressupost.
		par = new Paragraph("Total: " + tvImportTotal.getText() + " €",
				FontFactory.getFont(FontFactory.HELVETICA, 16, Font.NORMAL,
						Color.BLACK));
		par.setSpacingAfter(1.5f);
		par.setSpacingBefore(2f);
		par.setAlignment("right");
		doc.add(par);
		
		
		// Tanquem el document.
		doc.close();		
		
		return f;
	}

	/**
	 * Crear fitxer.
	 *
	 * @param nomFitxer the nom fitxer
	 * @return the file
	 * @throws IOException Signals that an I/O exception has occurred.
	 */
	public static File crearFitxer(String nomFitxer) throws IOException {
	    File ruta = getRuta();
	    File fichero = null;
	    if (ruta != null)
	        fichero = new File(ruta, nomFitxer);
	    return fichero;
	}
	
	/**
	 * Gets the ruta.
	 *
	 * @return the ruta
	 */
	public static File getRuta() {
		// El fitxer serà emmagatzemat en un directori dins del directori
		// Download
	    File ruta = null;
	    if (Environment.MEDIA_MOUNTED.equals(Environment.getExternalStorageState())) {
	        ruta = new File(Environment.getExternalStoragePublicDirectory(Environment.DIRECTORY_DOWNLOADS), NOM_DIRECTORI);
	 
	        if (ruta != null) {
	            if (!ruta.mkdirs()) {
	                if (!ruta.exists()) {
	                    return null;
	                }
	            }
	        }
	    }
	    return ruta;
	}
}