/*
 * Translator Helper (TH)
 * Fco. Javier Domínguez Carral
 * TFC - UOC (2014)
 */
package com.ADApps.translatorhelper.projectes;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;

import android.app.Dialog;
import android.content.Intent;
import android.os.Bundle;
import android.view.Gravity;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.DatePicker;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.TableLayout;
import android.widget.TableRow;
import android.widget.TableRow.LayoutParams;
import android.widget.TextView;
import android.widget.Toast;

import com.ADApps.translatorhelper.R;
import com.ADApps.translatorhelper.contactes.Contacte;
import com.ADApps.translatorhelper.main.Dialeg;
import com.ADApps.translatorhelper.main.THDataBaseHelper;
import com.actionbarsherlock.app.SherlockFragment;
import com.actionbarsherlock.view.Menu;
import com.actionbarsherlock.view.MenuInflater;
import com.actionbarsherlock.view.MenuItem;


/**
 * The Class DetallsProjecteFragment.
 */
public class DetallsProjecteFragment extends SherlockFragment implements Dialeg.DialogCallbacks, OnClickListener{
	
	/** The Constant ESBORRAR. */
	private static final int ESBORRAR = 1;
	
	/** The Constant MODIFICAR. */
	private static final int MODIFICAR = 4;
	
	/** The Constant ENTREGAT. */
	private static final int ENTREGAT = 3;
	
	/** The Constant EN_CURS. */
	private static final int EN_CURS = 2;
	
	/** The Constant PROVISIONAL. */
	private static final int PROVISIONAL = 1;
	
	/** The Constant en_curs. */
	private static final String en_curs = "En curs";
	
	/** The Constant entregat. */
	private static final String entregat = "Entregat";
	
	/** The db. */
	private static THDataBaseHelper db;
	
	/** The tv id projecte. */
	private TextView tvIdProjecte;
	
	/** The tv client. */
	private TextView tvClient;
	
	/** The et desc projecte. */
	private EditText etDescProjecte;
	
	/** The tv estat. */
	private TextView tvEstat;
	
	/** The tv import. */
	private TextView tvImport;
	
	/** The tv data creacio. */
	private TextView tvDataCreacio;
	
	/** The tv data entrega. */
	private TextView tvDataEntrega;
	
	/** The dp data entrega. */
	private DatePicker dpDataEntrega;
	
	/** The et observacions. */
	private EditText etObservacions;
	
	/** The tv colaboradors empty. */
	private TextView tvColaboradorsEmpty;
	
	/** The tv id factura. */
	private TextView tvIdFactura;
	
	/** The img afegir colaboradors. */
	private ImageView imgAfegirColaboradors;
	
	/** The btn associar client. */
	private Button btnAssociarClient;
	
	/** The btn entregat. */
	private Button btnEntregat;
	
	/** The btn cancelar entrega. */
	private Button btnCancelarEntrega;
	
	/** The btn gen factura. */
	private Button btnGenFactura;
	
	/** The tlo colaboradors celes. */
	private TableLayout tloColaboradorsCeles;
	
	/** The botons. */
	private LinearLayout botons;
	
	/** The lst colaboradors. */
	private ArrayList<Contacte> lstColaboradors = new ArrayList<Contacte>();
	
	/** The dialeg adapter contactes. */
	private ArrayAdapter<String> dialegAdapterContactes;
	
	/** The registre. */
	private Projecte registre;
	
	/** The my menu. */
	private Menu myMenu;
	
	/** The sdf. */
	SimpleDateFormat sdf = new SimpleDateFormat ("dd/MM/yyyy");

	/* (non-Javadoc)
	 * @see android.support.v4.app.Fragment#onCreate(android.os.Bundle)
	 */
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setHasOptionsMenu(true);
		db = new THDataBaseHelper(getActivity());
		db.open();
	}

	/* (non-Javadoc)
	 * @see android.support.v4.app.Fragment#onCreateView(android.view.LayoutInflater, android.view.ViewGroup, android.os.Bundle)
	 */
	@Override
	public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
		View view = inflater.inflate(R.layout.fragment_detalls_projecte, container, false);
		return view;
	}
	
	/* (non-Javadoc)
	 * @see android.support.v4.app.Fragment#onActivityCreated(android.os.Bundle)
	 */
	@Override
	public void onActivityCreated(Bundle savedInstanceState) {
		super.onActivityCreated(savedInstanceState);
		Bundle extras = getActivity().getIntent().getExtras();
		
		tvIdProjecte = (TextView) getView().findViewById(R.id.lblDetallsProjecteID);
		tvClient = (TextView) getView().findViewById(R.id.lblDetallsProjecteNomClient);
		etDescProjecte = (EditText) getView().findViewById(R.id.txtDetallsProjecteTextDescProjecte);
		tvEstat = (TextView) getView().findViewById(R.id.lblDetallsProjecteTextEstat);
		tvImport = (TextView) getView().findViewById(R.id.lblDetallsProjecteTextImport);
		tvDataCreacio = (TextView) getView().findViewById(R.id.lblDetallsProjecteDataCreacioValor);
		tvDataEntrega = (TextView) getView().findViewById(R.id.lblDetallsProjecteDataEntregaSeleccionada);		
		dpDataEntrega = (DatePicker) getView().findViewById(R.id.dpDetallsProjecteDataEntrega);
		etObservacions = (EditText) getView().findViewById(R.id.txtDetallsProjecteTextObservacions);
		tvColaboradorsEmpty = (TextView) getView().findViewById(R.id.tvColaboradorsEmpty);
		tvIdFactura = (TextView) getView().findViewById(R.id.lblDetallsProjecteIDFactura);
		imgAfegirColaboradors = (ImageView) getView().findViewById(R.id.imgAfegirColaboradors);
		btnAssociarClient = (Button)getView().findViewById(R.id.btnAssociarClient);
		btnEntregat = (Button)getView().findViewById(R.id.btnEntregat);
		btnCancelarEntrega = (Button)getView().findViewById(R.id.btnCancelarEntrega);
		btnGenFactura = (Button)getView().findViewById(R.id.btnGenFactura);
		tloColaboradorsCeles = (TableLayout) getView().findViewById(R.id.tloDetallsProjecteColaboradorsCeles);
		botons = (LinearLayout)getView().findViewById(R.id.lloDetallsProjecteBotones);
				
		inicialitzarViews(extras);
		
		imgAfegirColaboradors.setOnClickListener(this);
		btnAssociarClient.setOnClickListener(this);
		btnEntregat.setOnClickListener(this);
		btnCancelarEntrega.setOnClickListener(this);
		btnGenFactura.setOnClickListener(this);
	}
	
	/**
	 * Inicialitzar views.
	 *
	 * @param extras the extras
	 */
	private void inicialitzarViews(Bundle extras) {
				
		registre = (Projecte)extras.getSerializable("registre");
		
		tvIdProjecte.setText(Integer.toString(registre.getIdProjecte()));
		
		if (registre.getClient() == null){
			tvClient.setText(registre.getDescClient());
		}else{
			tvClient.setText(registre.getClient().getNomCognoms());
		}
		
		etDescProjecte.setText(registre.getNomProjecte());
		etDescProjecte.setClickable(false);
		etDescProjecte.setFocusable(false);
		
		switch (registre.getEstat()){
			case EN_CURS:
				tvEstat.setText(R.string.estatPro_enCurs);
				btnCancelarEntrega.setVisibility(View.GONE);
			btnGenFactura.setVisibility(View.GONE);
				break;
			case ENTREGAT:
				tvEstat.setText(R.string.estatPro_entregat);
				btnEntregat.setVisibility(View.GONE);
				break;
			default:
				break;
		}

		tvImport.setText(Float.toString(registre.getImportProjecte()) + " €");
		
		tvDataCreacio.setText(sdf.format(registre.getDataCreacio()));
		
		Calendar dEntrega = Calendar.getInstance();
		dEntrega.setTime(registre.getDataEntrega());
		tvDataEntrega.setText(sdf.format(registre.getDataEntrega()));
		dpDataEntrega.init(dEntrega.get(Calendar.YEAR), dEntrega.get(Calendar.MONTH), dEntrega.get(Calendar.DAY_OF_MONTH), null);
		dpDataEntrega.setVisibility(View.GONE);
		
		etObservacions.setText(registre.getObservacions());
		
		lstColaboradors = registre.getColaboradors();
		
		if (lstColaboradors.isEmpty()){
			tvColaboradorsEmpty.setVisibility(View.VISIBLE);
		}
		
		if (registre.getFactura() != null) {
			tvIdFactura.setText(registre.getFactura().getIdFactura());
			btnGenFactura.setText(R.string.btnRegenFactura);
		}else{
			btnGenFactura.setText(R.string.btnGenFactura);
		}
		
		imgAfegirColaboradors.setVisibility(View.INVISIBLE);

		tloColaboradorsCeles.setClickable(false);
		
		
		
		inicialitzarTaulaColaboradors(false);
	}

	/**
	 * Inicialitzar taula colaboradors.
	 *
	 * @param actualitzar the actualitzar
	 */
	private void inicialitzarTaulaColaboradors(boolean actualitzar) {
		if(!lstColaboradors.isEmpty()){
			if(actualitzar) {
				tloColaboradorsCeles.removeAllViews();
			}

			for (int index = 0; index < lstColaboradors.size(); index++) {
				final Contacte con = lstColaboradors.get(index);
				
				TableRow colaboradorsRow = new TableRow(getActivity());
				colaboradorsRow.setLayoutParams(new LayoutParams(LayoutParams.MATCH_PARENT, LayoutParams.WRAP_CONTENT));
				colaboradorsRow.setGravity(Gravity.CENTER_VERTICAL);
				
				TextView txtNomColaborador = new TextView(getActivity());
				txtNomColaborador.setLayoutParams(new LayoutParams(400, LayoutParams.WRAP_CONTENT));
				txtNomColaborador.setText(con.getNomCognoms());
				
				colaboradorsRow.addView(txtNomColaborador);
				
				if (actualitzar){
					ImageView ivEsborra = new ImageView(getActivity());
		            ivEsborra.setLayoutParams(new LayoutParams(25, LayoutParams.WRAP_CONTENT));
		            ivEsborra.setImageDrawable(getResources().getDrawable(android.R.drawable.ic_delete));
		            ivEsborra.setOnClickListener(new View.OnClickListener() {
						@Override
						public void onClick(View v) {
							TableRow parent = (TableRow) v.getParent();
							
							lstColaboradors.remove(parent.getId());
							tloColaboradorsCeles.removeView(parent);
												
							inicialitzarTaulaColaboradors(true);
						}
					});
		            colaboradorsRow.addView(ivEsborra);
				}
				
	            colaboradorsRow.setId(index);
	            
				// Càrrega de files a la taula
	            tloColaboradorsCeles.addView(colaboradorsRow);
				
			}
		}else{
			((TextView) getView().findViewById(R.id.tvColaboradorsEmpty))
					.setText("No hi ha col·laboradors al projecte.");
		}
	}
	
	/**
	 * Afegir contacte.
	 *
	 * @param esClient the es client
	 */
	private void afegirContacte(final boolean esClient) {
		final Dialog dialog = new Dialog(getActivity());
		dialog.setContentView(R.layout.dialeg_contactes);
		
		if (esClient)
			dialog.setTitle(R.string.afegirClient);
		else
			dialog.setTitle(R.string.afegirColaborador);

		final ListView lstContactes = (ListView)dialog.findViewById(R.id.lstContactes);

		if ((dialegAdapterContactes = new ArrayAdapter<String> (getActivity().getBaseContext(), android.R.layout.simple_list_item_1, 
				db.getContactesDialeg(esClient))).isEmpty()){
			if (esClient){
				
				Toast.makeText(getActivity().getApplicationContext(),
						"No hi ha clients\n definits a l'aplicació.",
						Toast.LENGTH_LONG).show();

			}else{
				
				Toast.makeText(getActivity().getApplicationContext(),
						"No hi ha col·laboradors\n definits a l'aplicació.",
						Toast.LENGTH_LONG).show();

			}
		}else{
			lstContactes.setAdapter(dialegAdapterContactes);
			
			lstContactes.setOnItemClickListener(new OnItemClickListener(){
	
				@Override
				public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
					Contacte con = db.getContacte(db.getIDContacte((String)parent.getItemAtPosition(position)));
					
					if (esClient){
						tvClient.setText(con.getNomCognoms());
						db.associarClient(con.getIdContacte(), registre.getIdProjecte());
						dialog.cancel();
						
					}else{
						if (!lstColaboradors.contains(con)) {
							lstColaboradors.add(con);
							
							tvColaboradorsEmpty.setVisibility(View.GONE);
							
							inicialitzarTaulaColaboradors(true);
							dialog.cancel();
						}else{
							Toast.makeText(
									getActivity().getApplicationContext(),
									"El col·laborador ja està\n associat al projecte.",
									Toast.LENGTH_LONG).show();
						}
					}
				}
			});
			dialog.show();
		}
	}
	
	
	/**
	 * Generar factura.
	 */
	private void generarFactura() {
		final int idContacte = db.getIDContacte(tvClient.getText().toString());
		
		if (idContacte != -1) {
			final Dialog dialog = new Dialog(getActivity());
			dialog.setContentView(R.layout.dialeg_factures);
			dialog.setTitle(R.string.genFactura);
			
			final DatePicker dpDCFactura = (DatePicker)dialog.findViewById(R.id.dpDialegFactures);
			
			final Calendar dCobramentF = Calendar.getInstance();
			
			dpDCFactura.init(dCobramentF.get(Calendar.YEAR), dCobramentF.get(Calendar.MONTH), dCobramentF.get(Calendar.DAY_OF_MONTH), null);

			Button dbAcceptar = (Button) dialog.findViewById(R.id.btnDialegFacturesAcceptar);
			dbAcceptar.setOnClickListener(new OnClickListener() {
				@Override
				public void onClick(View v) {
					dCobramentF.set(dpDCFactura.getYear(), dpDCFactura.getMonth(), dpDCFactura.getDayOfMonth()); 
					Date dEstat = new Date();
					SimpleDateFormat sdfFac = new SimpleDateFormat("dd-MM-yyyy");
					String idProjecte = tvIdProjecte.getText().toString();
					String idFactura = idProjecte + "_" + idContacte + "_"
							+ sdfFac.format(dEstat);
					
					if (db.insertFactura(idProjecte,
							idFactura,
							idContacte, 
							dCobramentF.getTime(), 
							PROVISIONAL, 
							dEstat, 
							registre.getImportProjecte()) != -1){
						
						tvIdFactura.setText(idFactura);
						
					}
					
					dialog.cancel();
				}
			});
			
			Button dbCancelar = (Button) dialog.findViewById(R.id.btnDialegFacturesCancelar);
			// Si es prem el botó es tanca el diàleg
			dbCancelar.setOnClickListener(new OnClickListener() {
				@Override
				public void onClick(View v) {
					dialog.dismiss();
				}
			});

			dialog.show();
			
		}else{
			Toast.makeText(getActivity().getApplicationContext(),
					"El client no està donat d'alta al sistema.",
					Toast.LENGTH_LONG).show();
		}
	}
	
	
	/* (non-Javadoc)
	 * @see android.view.View.OnClickListener#onClick(android.view.View)
	 */
	@Override
	public void onClick(View v) {
		switch (v.getId()) {
		
			case R.id.imgAfegirColaboradors:
				afegirContacte(false);
				break;
				
			case R.id.btnAssociarClient:
				afegirContacte(true);
				break;
				
			case R.id.btnEntregat:
				Dialeg dialegEntregat = Dialeg.newInstance((DetallsProjecteFragment)
	    				getFragmentManager().findFragmentById(R.id.detallsProjecteFragment), 
	    				"Entregar projecte", "Segur que vol entregar el projecte?", ENTREGAT);
				dialegEntregat.show(getFragmentManager(), entregat);
				break;
				
			case R.id.btnCancelarEntrega:
				Dialeg dialegEnCurs = Dialeg.newInstance((DetallsProjecteFragment)
	    				getFragmentManager().findFragmentById(R.id.detallsProjecteFragment), 
	    				"Retrocedir entrega del projecte", "Segur que vol retrocedir la entrega del projecte?", EN_CURS);
				dialegEnCurs.show(getFragmentManager(), en_curs);
				break;
				
			case R.id.btnGenFactura:
				generarFactura();
				break;
				
			default:
				break;
		}	
	}
	
	
	/* (non-Javadoc)
	 * @see com.actionbarsherlock.app.SherlockFragment#onCreateOptionsMenu(android.view.Menu, android.view.MenuInflater)
	 */
	@Override
	public void onCreateOptionsMenu(Menu menu, MenuInflater inflater) {
		inflater.inflate(R.menu.detall_fragment, menu);
		myMenu = menu;
	}
	
	/* (non-Javadoc)
	 * @see com.actionbarsherlock.app.SherlockFragment#onOptionsItemSelected(android.view.MenuItem)
	 */
	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		switch (item.getItemId()) {
		
	        case android.R.id.home:
	        	db.close();
				Intent intent = new Intent(getActivity(), LlistaProjectesActivity.class);
	            intent.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP|Intent.FLAG_ACTIVITY_NEW_TASK);
	            startActivity(intent);
	            return true;
	            
	        case R.id.menuDetallsModificar:
				etDescProjecte.setClickable(true);
				etDescProjecte.setCursorVisible(true);
				etDescProjecte.setFocusable(true);
				etDescProjecte.setFocusableInTouchMode(true);
				
				if (tvEstat.getText().toString().contains(en_curs)){
					tvDataEntrega.setVisibility(View.GONE);
					dpDataEntrega.setVisibility(View.VISIBLE);
					dpDataEntrega.setFocusable(true);
				}
				
				etObservacions.setClickable(true);
				etObservacions.setCursorVisible(true);
				etObservacions.setFocusable(true);
				etObservacions.setFocusableInTouchMode(true);
				
				imgAfegirColaboradors.setVisibility(View.VISIBLE);
				
				botons.setVisibility(View.GONE);
	    			
	        	myMenu.findItem(R.id.menuDetallsUpdate).setVisible(true);
	        	myMenu.findItem(R.id.menuDetallsModificar).setVisible(false);
	        	myMenu.findItem(R.id.menuDetallsEliminar).setVisible(false);
	        	
	        	inicialitzarTaulaColaboradors(true);
	        	
	    		return true;
	    		
	    	case R.id.menuDetallsEliminar:
	    		
	    		Dialeg dialegEliminar = Dialeg.newInstance((DetallsProjecteFragment)getFragmentManager().findFragmentById(R.id.detallsProjecteFragment), 
	    				"Eliminar projecte", "Segur que vol eliminar el projecte?", ESBORRAR);
	    		dialegEliminar.show(getFragmentManager(), "eliminar");
	    		return true;
	    		
	    	case R.id.menuDetallsUpdate:
	    		Calendar dEntregaUpdate = Calendar.getInstance();
	    		dEntregaUpdate.set(dpDataEntrega.getYear(), dpDataEntrega.getMonth(), dpDataEntrega.getDayOfMonth());
	    		String descProjectetUpdate = etDescProjecte.getText().toString();
	    		
	    		if (descProjectetUpdate == null || descProjectetUpdate.isEmpty()) {
				Toast.makeText(getActivity().getApplicationContext(),
						"La descripció del projecte no pot estar buida.",
						Toast.LENGTH_LONG).show();
	    			return true;
	    		}
	    		
	    		if (dEntregaUpdate.before(new Date())) {
	    			Toast.makeText(getActivity().getApplicationContext(), "La data d'entrega no pot ser inferior a la data d'avui.", Toast.LENGTH_LONG).show();
	    			return true;
	    		}
	    		
				int estat = ((tvEstat.getText().toString() == en_curs) ? 2: 3);
				String factura = null;
				
				if (registre.getFactura() != null){
					factura = registre.getFactura().getIdFactura();
				}
				
				if (db.getIDProjecte(descProjectetUpdate
						, factura
						, db.getIDContacte(tvClient.getText().toString())
						, registre.getDescClient()
						, registre.getTarifa().getIdTarifa()
						, registre.getConcepte().getidConcepte()
						, dEntregaUpdate.getTime()
						, registre.getDataCreacio()
						, estat
						, etObservacions.getText().toString()
						, Float.toString(registre.getImportProjecte())) == -1){
					
					Dialeg dialegModificar = Dialeg.newInstance((DetallsProjecteFragment)
							getFragmentManager().findFragmentById(R.id.detallsProjecteFragment), "Modificar projecte", 
							"Segur que vol desar els canvis al projecte?", MODIFICAR);
					dialegModificar.show(getFragmentManager(), "modificar");
					
				}else {
					Toast.makeText(getActivity().getApplicationContext(),"El projecte ja existeix.", Toast.LENGTH_LONG).show();
				}
		    		return true;
	    		
			default:
				return super.onOptionsItemSelected(item);
		}
	}
	
	

	/* (non-Javadoc)
	 * @see com.ADApps.translatorhelper.main.Dialeg.DialogCallbacks#onPositive(int)
	 */
	@Override
	public void onPositive(int mode) {
		switch (mode){
		
			case ESBORRAR:
				int idProjecteDelete = Integer.parseInt(tvIdProjecte.getText().toString());
				if (!db.deletePreusUnitarisFac(idProjecteDelete)) {
					Toast.makeText(getActivity().getApplicationContext(),"Error en esborrar els preus unitaris.", Toast.LENGTH_LONG).show();
				}
				
				if (!db.deleteImpostosFac(idProjecteDelete)) {
					Toast.makeText(getActivity().getApplicationContext(),"Error en esborrar els preus unitaris.", Toast.LENGTH_LONG).show();
				}
	
				if (!db.deleteVariablesFac(idProjecteDelete)) {
					Toast.makeText(getActivity().getApplicationContext(),"Error en esborrar els preus unitaris.", Toast.LENGTH_LONG).show();
				}
				
				if (db.deleteProjecte(idProjecteDelete)) {
					db.close();
				Intent intent = new Intent(getActivity(),
						LlistaProjectesActivity.class);
		            intent.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP|Intent.FLAG_ACTIVITY_NEW_TASK);
		            startActivity(intent);
				}else {
					Toast.makeText(getActivity().getApplicationContext(),"Error en esborrar el projecte.", Toast.LENGTH_LONG).show();
				}
				break;
				
			case MODIFICAR:
				Calendar dEntregaUpdate = Calendar.getInstance();
				dEntregaUpdate.set(dpDataEntrega.getYear(), dpDataEntrega.getMonth(), dpDataEntrega.getDayOfMonth());
				try {
				int estat = ((tvEstat.getText().toString().equals(en_curs)) ? 2
						: 3);
					int idProjecteUpdate = Integer.parseInt(tvIdProjecte.getText().toString());
					
					if (db.updateProjecte(idProjecteUpdate
							, etDescProjecte.getText().toString()
							, tvIdFactura.getText().toString()
							, db.getIDContacte(tvClient.getText().toString())
							, tvClient.getText().toString()
							, registre.getTarifa().getIdTarifa()
							, registre.getConcepte().getidConcepte()
							, dEntregaUpdate.getTime()
							, sdf.parse(tvDataCreacio.getText().toString())
							, estat
							, etObservacions.getText().toString()
							, Float.toString(registre.getImportProjecte()))) {
						
						if (!actualitzarColaboradors(idProjecteUpdate)) {
						Toast.makeText(getActivity().getApplicationContext(),
								"Error en modificar els col·laboradors.",
								Toast.LENGTH_LONG).show();
						}
						
						db.close();
						Intent intent = new Intent(getActivity(), LlistaProjectesActivity.class);
			            intent.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP|Intent.FLAG_ACTIVITY_NEW_TASK);
			            startActivity(intent);
					}else {
						Toast.makeText(getActivity().getApplicationContext(),"Error en modificar el projecte", Toast.LENGTH_LONG).show();
					}
				} catch (NumberFormatException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				} catch (ParseException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				}
				break;
				
			case ENTREGAT:
				
				if (!db.modificarEstatProjecte(Integer.parseInt(tvIdProjecte.getText().toString()), sdf.format(new Date()), ENTREGAT)){
				Toast.makeText(getActivity().getApplicationContext(),
						"Error en entregar el projecte.", Toast.LENGTH_LONG)
						.show();
				}else{
					db.close();
					Intent intentEntregar = new Intent(getActivity(), LlistaProjectesActivity.class);
					intentEntregar.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP|Intent.FLAG_ACTIVITY_NEW_TASK);
		            startActivity(intentEntregar);
				}
	            
				break;
				
			case EN_CURS:
				
				if (!db.modificarEstatProjecte(Integer.parseInt(tvIdProjecte.getText().toString()), EN_CURS)){
					Toast.makeText(getActivity().getApplicationContext(),"Error en retrocedir l'estat del projecte.", Toast.LENGTH_LONG).show();
				}else{
					tvEstat.setText(en_curs);
					btnCancelarEntrega.setVisibility(View.GONE);
				btnGenFactura.setVisibility(View.GONE);
					btnEntregat.setVisibility(View.VISIBLE);
					onOptionsItemSelected (myMenu.findItem(R.id.menuDetallsModificar));
					Toast.makeText(getActivity().getApplicationContext(),"Modifiqui la data d'entrega del projecte.", Toast.LENGTH_LONG).show();
				}
	            
				break;
				
			default:
				break;
		}
	}
	
	/* (non-Javadoc)
	 * @see com.ADApps.translatorhelper.main.Dialeg.DialogCallbacks#onNegative(int)
	 */
	@Override
	public void onNegative(int dialogMode) {
		
	}
	
	
	/**
	 * Actualitzar colaboradors.
	 *
	 * @param idP the id p
	 * @return true, if successful
	 */
	private boolean actualitzarColaboradors(int idP) {
		boolean actualitzat = false;
		
		if (db.deleteColaboradors(idP)) {
			if (!lstColaboradors.isEmpty()) {
				for (int index = 0; index < lstColaboradors.size(); index++) {
					Contacte con = lstColaboradors.get(index);
					actualitzat = db
							.insertColaborador(idP, con.getIdContacte());
				}
			} else
				actualitzat = true;
		}
		return actualitzat;
	}
}
