/*
 * Translator Helper (TH)
 * Fco. Javier Domínguez Carral
 * TFC - UOC (2014)
 */
package com.ADApps.translatorhelper.projectes;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Date;

import com.ADApps.translatorhelper.contactes.*;
import com.ADApps.translatorhelper.factures.*;
import com.ADApps.translatorhelper.parametres.conceptes.*;
import com.ADApps.translatorhelper.parametres.impostos.*;
import com.ADApps.translatorhelper.parametres.preusunitaris.*;
import com.ADApps.translatorhelper.parametres.tarifes.*;
import com.ADApps.translatorhelper.parametres.variables.*;


/**
 * The Class Projecte.
 */
public class Projecte implements Serializable{

	/** The Constant serialVersionUID. */
	private static final long serialVersionUID = 1L;
	
	/** The id projecte. */
	private int idProjecte;
	
	/** The nom projecte. */
	private String nomProjecte;
	
	/** The client. */
	private Contacte client;
	
	/** The desc client. */
	private String descClient;
	
	/** The concepte. */
	private Concepte concepte;
	
	/** The tarifa. */
	private Tarifa tarifa;
	
	/** The preus unitaris. */
	private ArrayList<PreuUnitariFac> preusUnitaris;
	
	/** The data entrega. */
	private Date dataEntrega;
	
	/** The data creacio. */
	private Date dataCreacio;
	
	/** The impostos. */
	private ArrayList<ImpostFac> impostos;
	
	/** The variables. */
	private ArrayList<VariableFac> variables;
	
	/** The estat. */
	private int estat;
	
	/** The colaboradors. */
	private ArrayList<Contacte> colaboradors;
	
	/** The observacions. */
	private String observacions;
	
	/** The import projecte. */
	private float importProjecte;
	
	/** The factura. */
	private Factura factura;
	
	/**
	 * Instantiates a new projecte.
	 *
	 * @param idProjecte the id projecte
	 * @param nomProjecte the nom projecte
	 * @param client the client
	 * @param descClient the desc client
	 * @param concepte the concepte
	 * @param tarifa the tarifa
	 * @param preusUnitaris the preus unitaris
	 * @param dataEntrega the data entrega
	 * @param dataCreacio the data creacio
	 * @param impostos the impostos
	 * @param variables the variables
	 * @param estat the estat
	 * @param colaboradors the colaboradors
	 * @param observacions the observacions
	 * @param importProjecte the import projecte
	 * @param factura the factura
	 */
	public Projecte(int idProjecte, String nomProjecte, Contacte client, String descClient, Concepte concepte, Tarifa tarifa
			, ArrayList<PreuUnitariFac> preusUnitaris, Date dataEntrega, Date dataCreacio
			, ArrayList<ImpostFac> impostos, ArrayList<VariableFac> variables, int estat
			, ArrayList<Contacte> colaboradors, String observacions, float importProjecte, Factura factura) {
		super();
		this.idProjecte = idProjecte;
		this.nomProjecte = nomProjecte;
		this.client = client;
		this.descClient = descClient;
		this.concepte = concepte;
		this.tarifa = tarifa;
		this.preusUnitaris = preusUnitaris;
		this.dataEntrega = dataEntrega;
		this.dataCreacio = dataCreacio;
		this.impostos = impostos;
		this.variables = variables;
		this.estat = estat;
		this.colaboradors = colaboradors;
		this.observacions = observacions;
		this.importProjecte = importProjecte;
		this.factura = factura;
	}

	/**
	 * Gets the client.
	 *
	 * @return the client
	 */
	public Contacte getClient() {
		return client;
	}

	/**
	 * Gets the nom projecte.
	 *
	 * @return the nom projecte
	 */
	public String getNomProjecte() {
		return nomProjecte;
	}

	/**
	 * Sets the nom projecte.
	 *
	 * @param nomProjecte the new nom projecte
	 */
	public void setNomProjecte(String nomProjecte) {
		this.nomProjecte = nomProjecte;
	}

	/**
	 * Sets the client.
	 *
	 * @param client the new client
	 */
	public void setClient(Contacte client) {
		this.client = client;
	}

	/**
	 * Gets the concepte.
	 *
	 * @return the concepte
	 */
	public Concepte getConcepte() {
		return concepte;
	}

	/**
	 * Sets the concepte.
	 *
	 * @param concepte the new concepte
	 */
	public void setConcepte(Concepte concepte) {
		this.concepte = concepte;
	}

	/**
	 * Gets the tarifa.
	 *
	 * @return the tarifa
	 */
	public Tarifa getTarifa() {
		return tarifa;
	}

	/**
	 * Sets the tarifa.
	 *
	 * @param tarifa the new tarifa
	 */
	public void setTarifa(Tarifa tarifa) {
		this.tarifa = tarifa;
	}

	/**
	 * Gets the preus unitaris.
	 *
	 * @return the preus unitaris
	 */
	public ArrayList<PreuUnitariFac> getPreusUnitaris() {
		return preusUnitaris;
	}

	/**
	 * Sets the preus unitaris.
	 *
	 * @param preusUnitaris the new preus unitaris
	 */
	public void setPreusUnitaris(ArrayList<PreuUnitariFac> preusUnitaris) {
		this.preusUnitaris = preusUnitaris;
	}

	/**
	 * Gets the data entrega.
	 *
	 * @return the data entrega
	 */
	public Date getDataEntrega() {
		return dataEntrega;
	}

	/**
	 * Sets the data entrega.
	 *
	 * @param dataEntrega the new data entrega
	 */
	public void setDataEntrega(Date dataEntrega) {
		this.dataEntrega = dataEntrega;
	}

	/**
	 * Gets the data creacio.
	 *
	 * @return the data creacio
	 */
	public Date getDataCreacio() {
		return dataCreacio;
	}

	/**
	 * Sets the data creacio.
	 *
	 * @param dataCreacio the new data creacio
	 */
	public void setDataCreacio(Date dataCreacio) {
		this.dataCreacio = dataCreacio;
	}

	/**
	 * Gets the impostos.
	 *
	 * @return the impostos
	 */
	public ArrayList<ImpostFac> getImpostos() {
		return impostos;
	}

	/**
	 * Sets the impostos.
	 *
	 * @param impostos the new impostos
	 */
	public void setImpostos(ArrayList<ImpostFac> impostos) {
		this.impostos = impostos;
	}

	/**
	 * Gets the variables.
	 *
	 * @return the variables
	 */
	public ArrayList<VariableFac> getVariables() {
		return variables;
	}

	/**
	 * Sets the variables.
	 *
	 * @param variables the new variables
	 */
	public void setVariables(ArrayList<VariableFac> variables) {
		this.variables = variables;
	}

	/**
	 * Gets the estat.
	 *
	 * @return the estat
	 */
	public int getEstat() {
		return estat;
	}

	/**
	 * Sets the estat.
	 *
	 * @param estat the new estat
	 */
	public void setEstat(int estat) {
		this.estat = estat;
	}

	/**
	 * Gets the colaboradors.
	 *
	 * @return the colaboradors
	 */
	public ArrayList<Contacte> getColaboradors() {
		return colaboradors;
	}

	/**
	 * Sets the colaboradors.
	 *
	 * @param colaboradors the new colaboradors
	 */
	public void setColaboradors(ArrayList<Contacte> colaboradors) {
		this.colaboradors = colaboradors;
	}

	/**
	 * Gets the observacions.
	 *
	 * @return the observacions
	 */
	public String getObservacions() {
		return observacions;
	}

	/**
	 * Sets the observacions.
	 *
	 * @param observacions the new observacions
	 */
	public void setObservacions(String observacions) {
		this.observacions = observacions;
	}

	/**
	 * Gets the import projecte.
	 *
	 * @return the import projecte
	 */
	public float getImportProjecte() {
		return importProjecte;
	}

	/**
	 * Sets the import projecte.
	 *
	 * @param importProjecte the new import projecte
	 */
	public void setImportProjecte(float importProjecte) {
		this.importProjecte = importProjecte;
	}

	/**
	 * Gets the factura.
	 *
	 * @return the factura
	 */
	public Factura getFactura() {
		return factura;
	}

	/**
	 * Sets the factura.
	 *
	 * @param factura the new factura
	 */
	public void setFactura(Factura factura) {
		this.factura = factura;
	}

	/**
	 * Gets the id projecte.
	 *
	 * @return the id projecte
	 */
	public int getIdProjecte() {
		return idProjecte;
	}

	/**
	 * Gets the desc client.
	 *
	 * @return the desc client
	 */
	public String getDescClient() {
		return descClient;
	}

	/**
	 * Sets the desc client.
	 *
	 * @param descClient the new desc client
	 */
	public void setDescClient(String descClient) {
		this.descClient = descClient;
	}
}
